import os
import errno

def touch(fname, times=None):
    """ from http://stackoverflow.com/questions/1158076/implement-touch-using-python """
    with open(fname, 'a'):
        os.utime(fname, times)

def mkdir_p(path):
    """ Make directories recursively.  See http://stackoverflow.com/questions/600268/mkdir-p-functionality-in-python """
    try:
        os.makedirs(path)
    except OSError as exc: # Python >2.5
        if exc.errno == errno.EEXIST and os.path.isdir(path):
            pass
        else:
            raise

def make_fake_pipeline_analysis_dir(fake_pipedir_name='fake-pipeline-analysis',
                                    uid='uid___A001_X111_X111',TP=False):
    """

    Parameters
    ----------
    fake_pipedir_name : str
    uid : str
    TP : boolean (make a TP pipeline dir structure)
    """
    sgm = '{fake_pipedir_name}/SOUS_{uid}/GOUS_{uid}/MOUS_{uid}'.format(uid=uid,
                                                                        fake_pipedir_name=fake_pipedir_name)
    for subdir in('working','products','rawdata'):
        mkdir_p('{sgm}/{subdir}'.format(subdir=subdir, sgm=sgm))

    mkdir_p('{sgm}/rawdata/{uid}/ASDMBinary'.format(sgm=sgm, uid=uid))

    # Create junk files
    if not TP:
      junk1 = '{fake_pipedir_name}/sous_{uid}.xml'.format(uid=uid, fake_pipedir_name=fake_pipedir_name)
      junk2 = '{fake_pipedir_name}/SOUS_{uid}/gous_{uid}.xml'.format(uid=uid, fake_pipedir_name=fake_pipedir_name)
      junk3 = '{fake_pipedir_name}/SOUS_{uid}/GOUS_{uid}/mous_{uid}.xml'.format(uid=uid, fake_pipedir_name=fake_pipedir_name)

      for junk in (junk1, junk2, junk3):
        touch(junk)


      for script in ('casa_piperestorescript.py',
                   'casa_pipescript.py',
                   'PPR_{uid}.xml'.format(uid=uid),
                   'scriptForPI.py',
                   'scriptForFluxCalibration.py',
                   'scriptForImaging.py'):
        with open(os.path.join(sgm, 'products', script), 'w') as f:
            f.write("# Contents of {0}".format(script))

      other_stuff = ['products/junk_calapply.txt',
                   'products/junk_flagversions.tar.gz',
                   'products/junk_caltables.tar.gz',
                   'working/flux.csv',
                   'working/junk_flagtemplate.txt',
                   'products/pipeline_products_junk.fits',
                   'products/pipeline_products_junk_weblog.tar.gz',
                   'products/pipeline_products_junk_casa_commands.log',
                  # 'working/pipeline_working_junk.mask',
                   'working/casapy_junk.log',
                  ]

    else:

      for script in ('casa_pipescript.py',
                   'PPR_{uid}.xml'.format(uid=uid)):

        with open(os.path.join(sgm, 'products', script), 'w') as f:
            f.write("# Contents of {0}".format(script))


      other_stuff = ['products/junk_calapply.txt',
                   'products/junk_flagversions.tar.gz',
                   'products/junk_caltables.tar.gz',
                   'working/junk_flagtemplate.txt',
                   'working/jyperk.csv',
                   'products/pipeline_products_junk.fits',
                   'products/pipeline_products_junk_weblog.tar.gz',
                   'products/pipeline_products_junk_casa_commands.log',
                   'working/casapy_junk.log',
                  ]

    for fn in other_stuff:
        touch(os.path.join(sgm, fn))


    if not TP:
# Make mask directory:

      mkdir_p(os.path.join(sgm,'working/pipeline_working_junk.mask'))


# Put something in the mask directory:
      fileo = open(os.path.join(sgm,'working/pipeline_working_junk.mask/FORTEST'),'w')
      print >> fileo, 'I am a test'
      fileo.close()

    workingdir = join(sgm, 'working')



