#! /usr/bin/env python

"""
A class to enable the batch analysis of baseline data set
the script calling this class is ReduceBaseline.py. Does not exist yet


20151217- includes fix to now flag per individual antenna and scan (not all antennas for a given scan)
Still beta test.
Note for second run the number osf junos is hardcoded to 0. Must fix


$Id $
"""

import string
import getpass
from pylab import *
import os
import sys
import time
import copy
from xml.dom import minidom
import pickle
import analysisUtils as au
import subprocess

import getpass
import pickle
import glob
username = getpass.getuser()
sys.path.append('/users/%s/AIV/science/scripts/R10.4_WORKING/'%username)
sys.path.append('/users/%s/AIV/science/analysis_scripts/'%username)
#execfile(os.getenv('CASA_TELCAL'))

#import numpy as np
import datetime as dt


def makeTimeStamp():
    return time.strftime('%Y-%m-%dT%H:%M:%S')


def system_except(cmd):
    ret = os.system(cmd)
    if ret != 0:
        raise Exception("Command '%s' returned non-zero exit status %d" %(cmd, ret))

class bcolors:
    HEADER = '\033[95m'
    OKBLUE = '\033[94m'
    OKGREEN = '\033[92m'
    WARNING = '\033[93m'
    FAIL = '\033[91m'
    ENDC = '\033[0m'
    
    def disable(self):
        self.HEADER = ''
        self.OKBLUE = ''
        self.OKGREEN = ''
        self.WARNING = ''
        self.FAIL = ''
        self.ENDC = ''

class BaselineDataReducer:
    def __init__(self):
        '''
        
        
        
        
        '''

        self.username = getpass.getuser()

        # remove .casa/matplotlib because of ICT-3803
        os.system('rm -Rf ~%s/.casa/matplotlib'%self.username)
        print "starting up \n"
        print "test"
        return


# To Do - Need to edit so that it can reduce CM antenna dar

    def runOnce(self, asdm, mode='delays', refAnt = '', scanTxt = '',ignoredScans = '', ignoreAnts='',batchprocess=False,correction='U',debug_scans=False,flaggedAnt=''):
        """
        Run the loop through a whole Baseline run once
        ignoreAnts is to ignore some antennas when calculating the scans to ignore. comma-separated list
        TODO: make the comparison plot at the end.
        TODO: open ticket about difference between C and U_WET even for short baselines.
        
        """        
        asdm = asdm.strip('/')
        print "anchor 0 \n"
        self.file_scansToIgnore = '%s_AllScansToIgnore.pickle'%asdm
        ignoreAnts = ignoreAnts.split(',')
        sc, so = au.readscans(asdm)
        ants = au.readAntennasFromASDM(asdm, verbose = False)
        print ants
        print "anchor  1 \n"
        if scanTxt == '':
            scans = []
            sources = []
            for i in sc.keys():
                if 'CALIBRATE_DELAY' in sc[i]['intent']:
                    scans.append(i)
                    sources.append(sc[i]['source'])
                    #scanTxt += '%s '%i
            nscans = size(scans)
            nsources = size(unique(sources))
            scanTxt = '%d~%d'%(scans[0],scans[-1])
        else:
            scanStart=int(scanTxt.split(',')[0])
            scanEnd = int(scanTxt.split('~')[1])
            scans =  range(scanStart,scanEnd+1)
            sources = []
            for i in scans:
                    sources.append(sc[i]['source'])
            nscans = size(scans)
            nsources = size(unique(sources))

        if nscans <= 10:
            print "WARNING: There are less than 10 scans available to analyze. Result will not look good. Aborting..."
            return
        
        print "#### Analyzing the Baseline run: %s with %d scans and %d sources" %(asdm,nscans,nsources)
        
        # read file containing scans to Ignore or use user input
        antScansToIgnore=[]
        AllAntScansToIgnore=''
        if flaggedAnt == '':
            if (os.path.exists(self.file_scansToIgnore)):
                f=open(self.file_scansToIgnore, 'r')
                antScansToIgnore=pickle.load(f)
                f.close()
                
                AllAntScansToIgnore = self.mergeScans_antennas(antScansToIgnore)
                print "### Found an existing file %s listing the following scans to exclude:\n %s" %(self.file_scansToIgnore,AllAntScansToIgnore)
                ans0= raw_input('Do you want to use it (y/n) ?')
                if ans0 == 'y' or ans0 == 'Y':
                    print 'Using the list as is.'
                elif ans0 == 'n' or ans0 == 'N' or ans0 == '':
                    AllAntScansToIgnore =''
            
                #elif (type(ans0) is str) or (',' in ans0):
                #    scansToAdd = ans0.split(',')
                #    AllScansToIgnore = AllScansToIgnore.tolist()
                #    for i in range(size(scansToAdd)):
                #        AllScansToIgnore.append(scansToAdd[i])
                #    AllScansToIgnore = sort(AllScansToIgnore)
                #    print 'All scans to Ignore = %s' %AllScansToIgnore
                
        else:
            AllAntScansToIgnore=flaggedAnt
        # Manual flagging of scans
        scansToIgnore=[]
        AllScansToIgnore=''
        if not ignoredScans=='':
            AllScansToIgnore = ignoredScans.split(',')
            print "Ignoring"
            print   AllScansToIgnore 
            
            for i in range(size(ants)):
                        print "Ignoring " ,  ants[i], AllScansToIgnore
                        scansToIgnore.append({'antenna': ants[i], 'scans': AllScansToIgnore})

            #print "Ignoring scans "+scansToIgnore


        for sti in AllScansToIgnore:
            scanTxt = '%s !%s'%(scanTxt,sti)
        print '### Scan selection : %s' %scanTxt

        system_except('rm -f tmp*.txt casapy*.log ipython*.log* *.last')
        
        #TODO: need a better way of choosing the refAnt
        if refAnt =='':
           print 'No reference antenna specified. Algorithm with choose the best one' 
           refAnt=self.getRefAntennaASDM(asdm)
        if refAnt not in ants:
            print 'WARNING refant %s is not in this ASDM. Choose a better one' %refAnt
            return()
        if (mode != 'delays') and (mode !='phases'):
            print 'WARNING: mode %s does not exist. Make it \"delays\" or \"phases\"' %mode
            return()

        # hack for ACA

        cmd1=''
        result1_basename = ''
        if  'C' in ''.join(ants):
            
        #  case there are CM antennas, run with
        #   (phasecorr = C, fullwetpath=F)
            print "There are CM antennas in the array, will run TC_ANTPOS with (phasecorr = C, fullwetpath=F) \n"
            correction='C'
            cmd1 = 'tc_antpos(asdm = \'%s\', refant = \'%s\', mode = \'%s\', scan = \'%s\', phasecorrection = \'%s\', fullwetpath = False, flaggedantenna = \'%s\')'%(asdm,refAnt, mode,scanTxt,correction,AllAntScansToIgnore)
            result1_basename = '%s_%s_%s_%s_DRY' %(asdm,mode,correction,refAnt)
            print "will run" + cmd1

        # This has been recommended as default by Ed 2015
        # cmd1 with standard wvr-corrected data (phasecorr = U, fullwetpath=T)

        elif  'D' in ''.join(ants):

            print "There are NO CM antennas in the array, will run TC_ANTPOS with (phasecorr = U, fullwetpath=F) \n"
            cmd1 = 'tc_antpos(asdm = \'%s\', refant = \'%s\', mode = \'%s\', scan = \'%s\', phasecorrection = \'%s\', fullwetpath = True, flaggedantenna = \'%s\')'%(asdm,refAnt, mode,scanTxt,correction,AllAntScansToIgnore)
            result1_basename = '%s_%s_%s_%s_WET' %(asdm,mode,correction,refAnt)
            print "will run" + cmd1



        #print cmd1
        f = open('tmpfile1.txt', 'w')
        f.write(cmd1)
        f.close()
        print "#### %s ####"%cmd1
        devnull = open('/dev/null','w')
        args1 = ['casapy-telcal','-c','tmpfile1.txt', '--nologger','--log2term']
        #pid1 = subprocess.Popen(args1, stdout = devnull, stderr = devnull)

        # system_except('casapy-telcal -c tmpfile1.txt --nologger --log2term 1> /dev/null 2> /dev/null')

        # cmd2 with fullwetpath=T wvr-correction.
        cmd2 = 'tc_antpos(asdm = \'%s\', refant = \'%s\', mode = \'%s\', scan = \'%s\', phasecorrection = \'U\', fullwetpath =  True , flaggedantenna = \'%s\')'%(asdm,refAnt, mode,scanTxt,AllAntScansToIgnore)
        f = open('tmpfile2.txt', 'w')
        f.write(cmd2)
        f.close()
        args2 = ['casapy-telcal','-c','tmpfile2.txt', '--nologger','--log2term']
        #print "#### %s ####"%cmd2
        print "#### Could take a few minutes ... ####"

      #pid2 = subprocess.Popen(args2, stdout = devnull, stderr = devnull)
        
        #assign results name
        


        
        result2_basename = '%s_%s_U_%s_WET' %(asdm,mode,refAnt)
        asdm_result1 = '%s_antpos_result' %(result1_basename)
        asdm_result2 = '%s_antpos_result' %(result2_basename)
        system_except('rm -Rf %s %s'%(asdm_result1,asdm_result2))
        print "#### Baseline results stored in %s and %s" %(asdm_result1,asdm_result2)

        #assign baseline fit name
        baseline_result1 = '%s_baseline.dat' %(result1_basename)
        baseline_result2 = '%s_baseline.dat' %(result2_basename)
        system_except('rm -f %s %s'%(baseline_result1,baseline_result2))
        print "#### Fit results stored in %s and %s" %(baseline_result1, baseline_result2)

        # package the plots in a directory
        plotsDir1 = '%s_plots' %(result1_basename)
        plotsDir2 = '%s_plots' %(result2_basename)
        system_except('rm -Rf %s %s'%(plotsDir1,plotsDir2))
        print "#### Plots for this run stored in %s and %s" %(plotsDir1,plotsDir2)

        #while (pid1.poll() == None) or (pid2.poll() == None):
#while (pid1.poll() == None):
#    count1 = 0
#    count2 = 0
##    while not(os.path.exists(baseline_result1)) or  not(os.path.exists(baseline_result2)):
#    while not(os.path.exists(baseline_result1)):
#        print 'Waiting to start tc_antpos'
#        time.sleep(20)
#    for i in open(baseline_result1,'r').readlines():
#        if 'SCAN' in i: count1+=1
#    #for i in open(baseline_result2,'r').readlines():
#    #    if 'SCAN' in i: count2+=1
#
#    #print "cmd1: %d, cmd2: %d out of %d scans. %d%% complete"%(count1,count2, nscans, 100*(count1+count2)/(2.*nscans))
#    print "cmd1: %d,out of %d scans. %d%% complete"%(count1, nscans, 100*(count1)/(2.*nscans))
#    time.sleep(10)
#
        # execute
        os.system('casapy-telcal -c tmpfile1.txt --nologger --log2term')

        # read the results


        positionResults1 = self.readPositionResults('%s' %asdm_result1)
        Ddir1,Tdir1,fitCoef1 = self.readBaselineFit('%s' %baseline_result1)
        fitCoefRes1 = self.calcResiduals(Ddir1, Tdir1, fitCoef1, positionResults1)

        #positionResults2 = self.readPositionResults('%s' %asdm_result2)
        #Ddir2,Tdir2,fitCoef2 = self.readBaselineFit('%s' %baseline_result2)
        #fitCoefRes2 = self.calcResiduals(Ddir2, Tdir2, fitCoef2, positionResults2)                  

        # find the scans to Exclude only if it doesn't exist 
        # Else set them to zero.
        # Use only one of the analysis.
        newAllAntScansToIgnore=''
        if not(os.path.exists(self.file_scansToIgnore)):
            #scansToIgnore = self.findScansToIgnore(fitCoefRes1, mode, ignoreAnts, debug =True)
            scansToIgnore = self.findScansToIgnore(fitCoefRes1, mode, ignoreAnts, debug=debug_scans)
            #scansToIgnore = self.findScansToIgnore(fitCoefRes1, mode, ignoreAnts, debug =False)
            # Setting debut to false to avoid plotting - AH
            #print "These are new AllSc
            #AllScansToIgnore = self.mergeScans(scansToIgnore)
            newAllAntScansToIgnore = self.mergeScans_antennas(scansToIgnore)
        


        # not sure what this does AH 2015-09-22
        #else:
        #    for row in scansToIgnore: row['scans']=[]
        #    AllScansToIgnore = []     

        # print results
        self.printResults(positionResults1, fitCoef1, scansToIgnore, result1_basename)


        # Commenting out the WET result for now - AH
        
        #self.printResults(positionResults2, fitCoef2, scansToIgnore, result2_basename)

        # review the plots
        os.system('eog %s &'%plotsDir1)
        #os.system('eog %s &'%plotsDir2)
        
        # checkPoint
        choice=''
        if batchprocess:
            choice='C'
        else: 
            choice = self.checkPoint(newAllAntScansToIgnore)

        if choice == 'A':
            print "At the CASA Command line type: blr.runOnce(asdm='%s',mode = \'%s\', refAnt = \'%s\'). Scans to be excluded will automatically be read from previous iteration" %(asdm,mode,refAnt)
            #print "Similarly, You can re-run the redcurion including the bad scans by running again \n"
            #print 'casapy-telcal -c runScript.py --nologger'

        elif choice == 'B':
            print "Continuing with the Export/Edit/Import steps... "
            # apply wet
            #self.applyPosModel(asdm_result2)
            # apply DRY
            ants = au.readAntennasFromASDM(asdm, verbose = False)
            print string.join(ants, ",")
            self.applyPosModel(asdm_result1)
        elif choice == 'C':
            print "Continuing manually..."
            return()
              
        

    def checkPoint(self, AllAntScansToIgnore):
        
        print "#### You are at a checkpoint in this analysis. Review the above results and messages. Review the plots that just popped up with eog and then decide how you want to proceed. Press the letter of your choice.. \n"

        # Issue warning if there are scans to be ignored.
        if AllAntScansToIgnore != '':
            print 'WARNING WARNING!: Delay jumps detected in this observation in antenna/scans %s'% AllAntScansToIgnore
            print 'WARNING WARNING!: Strongly suggested to re-run the analysis with the scan excluded \n'
        
        print "Choice A : There are signs of delay/phase jumps! You want to re-run this analysis with the same mode excluding the bad scans" 
        print "Choice B: Would you like to go on with the Export/Edit/Import step with this solution ? "
        print "Choice C: Would you like to stop here and continue manually \n ?"
        print "Enter choice:  "
        choice = raw_input()

        return choice
        
        
    def applyPosModel(self, asdm_result):
        """sah
        Run the Export, Edit, Import steps directly on the antennas for which
        we have already derived a model
        """
        print('\n ### Applying Results for %s ###' %asdm_result) 
        
        includeList = raw_input('Type comma separated list of antennas to apply results to. Default is None:  ')
        includeList = includeList.split(',')
        if includeList == [] or includeList == ['']:
            includeTxt = ''
        else:
            includeTxt = '-a %s'%(','.join(map(str, includeList)))
            print 'Antennas to apply position model: %s' %includeTxt
        
        answer = raw_input('Would you like to proceed with the Export/Edit/Import steps. Be careful, if answer is "y", you will proceed with importing these model to the TMCDB. {y|n} ?')
        
        if answer == 'y' or answer == 'Y' or answer == 'yes' or answer == 'YES' or answer == 'Yes':
            print '### Exporting TMCDB PositionModel ###'
            tmcdbModel = os.popen('ExportPositionModel.py').read()
            print tmcdbModel
            cmd_edit = 'EditPositions.py -f %s %s -i %s' %(asdm_result,includeTxt, tmcdbModel.split()[-1])
            print cmd_edit
            system_except(cmd_edit)

            inputComment = raw_input('Ready to ImportPositionModel.py. Please add a comment (asdm and list of antennas being updated are already added automatically) or type Enter to abort:\n')
            
            if inputComment == '':
                print 'You have chosen to NOT Import the new models to the TMCDB. You can still do it manually with the command: \n'
                self.lw.write('ImportPositionModel.py -f PositionModel-Current.xml -m \'%s, Antennas updated: %s, Your comment  \''%(asdm, (','.join(map(str, antApply)))))
            else:
                cmd_import = 'ImportPositionModel.py -f PositionModel-Current.xml -m \'%s, %s  \''%(asdm_result,inputComment)
                print cmd_import
                system_except(cmd_import)
                cmd_update='UpdatePosition.sh %s -a %s' % (asdm_result, (','.join(map(str, includeList))))
                print "Please run %s" % cmd_update
               
        else:
            print 'You have chosen to do the Export/Edit/Import steps manually. Here\'s a reminder'
            print "1/ ExportPositionModel.py"
            print "2/ EditPositions.py -f %s -x %s -i PositionModel-XXX.xml (from step 1/)"%(asdm_result, antExcludtext)
            print "3/ ImportPositionModel.py -f PositionModel-Current.xml -m \"comments\" "
        return
    
    def readPositionResults(self,sdmfile):
        """
        reads the  CalPointing.xml file without needing an asdm library.
        Can read the CalPointing.xml regardless of the method ( phase or delays) used
        
        ###We can replace this with the ASDM library on osf-red when Michel has deployed the
        ASDM library attached with casa###
        
        """

        if (os.path.exists(sdmfile) == False):
            print "readPositionResults(): Could not find file = ", sdmfile
            return(None)
        filename = sdmfile+'/CalPosition.xml'
        xmlscans = minidom.parse(filename)
        cmd = 'grep delayRms %s' %filename
        if os.popen(cmd).read() == '':
            self.method = 'phaseRms'
        else:
            self.method = 'delayRms'
        results = []
        rowlist = xmlscans.getElementsByTagName("row")
        for rownode in rowlist:
            antenna  = rownode.getElementsByTagName('antennaName')[0].childNodes[0].nodeValue.strip()
            refAntenna = rownode.getElementsByTagName('refAntennaNames')[0].childNodes[0].nodeValue.split()
            antennaPosition = rownode.getElementsByTagName('antennaPosition')[0].childNodes[0].nodeValue.split()
            positionOffset = rownode.getElementsByTagName('positionOffset')[0].childNodes[0].nodeValue.split()
            positionError = rownode.getElementsByTagName('positionErr')[0].childNodes[0].nodeValue.split()
            padName = rownode.getElementsByTagName('stationName')[0].childNodes[0].nodeValue.strip()
            if antenna in refAntenna[2]:
                Rms = 0.0
            else:
                Rms = rownode.getElementsByTagName(self.method)[0].childNodes[0].nodeValue
                
            record = {'antenna': str(antenna),
                      'refAntenna': str(refAntenna[2].strip('\"')),
                      'positionOffset': [float(positionOffset[2]),
                                         float(positionOffset[3]),
                                         float(positionOffset[4])],
                      'positionErr': [float(positionError[2]),
                                      float(positionError[3]),
                                      float(positionError[4])],                  
                      'newPosition': [float(antennaPosition[2])+float(positionOffset[2]),
                                      float(antennaPosition[3])+float(positionOffset[3]),
                                      float(antennaPosition[4])+float(positionOffset[4])],
                      'Rms' : float(Rms),
                      'padName' : str(padName),
                      'method' : str(self.method)
                      }
            results.append(record)
        return results

    def readBaselineFit(self, file):
        """
        reads a baseline.dat file
        which contains the results of the fit of delay or phase for each scan and the error on that fit
        Convert it ns and to deg directly

        """
        #o2 =2 #old offset with no errors
        o2= 3 #new offset with errors
        o2 = 4 # new offset with erros and absolute and relative delay
        
        data={}
        f = open(file,'r')
        lines = f.readlines()
        f.close()
        
        nscans = int(lines[-1].split()[1])
        Ddir=zeros([3,nscans+1])   #Delta direction cosines
        Tdir = zeros([3,nscans+1]) #Total direction cosines
        start = 0
        for line in lines:
            if line.startswith(' SCAN '):
                sline = line.split()
                scan = int(sline[1])
                Ddir[0,scan]=float(sline[2])
                Ddir[1,scan]=float(sline[3])
                Ddir[2,scan]=float(sline[4])
                Tdir[0,scan]=float(sline[5])
                Tdir[1,scan]=float(sline[6])
                Tdir[2,scan]=float(sline[7])
                nants = (size(sline)-8)/o2
                for i in range(nants):
                    ant = sline[o2*i+8]
                    if start == 0:
                        data[ant]=zeros([3,nscans+1])
                        data[ant][0,scan] = float(sline[o2*i+9])  #relative delay/phase
                        data[ant][1,scan] = float(sline[o2*i+10]) #error
                        data[ant][2,scan] = float(sline[o2*i+11]) #absolute delay/phase
                    else:
                        data[ant][0,scan] = float(sline[o2*i+9])
                        data[ant][1,scan] = float(sline[o2*i+10])
                        data[ant][2,scan] = float(sline[o2*i+11]) 
                start = 1
        return Ddir,Tdir,data

    def calcResiduals(self,Ddir,Tdir,fitCoef,posRes):
        lightspeed = 299792458.
        nAnts = size(posRes)
        Drms=zeros(nAnts)
        Trms= zeros(nAnts)
        fitCoefRes={}
        for i in range(nAnts):
            ant = posRes[i]['antenna']
            #if ant != self.refAnt:
            Tfit = dot(posRes[i]['positionOffset'],Tdir)/lightspeed 
            Dfit = dot(posRes[i]['positionOffset'],Ddir)/lightspeed
            
            fitCoefRes[ant]= [(fitCoef[ant][0]-Dfit),fitCoef[ant][1],(fitCoef[ant][2]-Tfit)]

            #q = find(Tres[ant] !=0)
            #weights = (1/fitCoef[ant][1])**2
            #Drms[i] = sqrt(au.wtvar(array(Dres[ant])[q],weights[q]))
            #Trms[i] = sqrt(au.wtvar(array(Tres[ant])[q],weights[q]))

        return fitCoefRes #,Drms,Trms

    def printResults(self,res,fitcoef,ig,resultname):
        
        nAnts = size(res)
        nScans = shape(fitcoef[res[0]['antenna']])[1]
        a = resultname.split('_')
        asdm = '%s___%s_%s_%s'%(a[0],a[3],a[4],a[5])
        refAnt = a[-2]
        plotsDir = '%s_plots' %(resultname)
        antList = []
        resRmsAnt =[]
        pads = []
        baselineLength = au.getBaselineLengthsFromASDM(asdm,refAnt)
        heightDiff = au.getBaselineHeightFromASDM(asdm,refAnt, verbose = False)
        blength = []
        bheight = []

        for i in range(nAnts):
            ant = res[i]['antenna']
            antList.append(ant)
            blength.append(baselineLength[ant])
            bheight.append(heightDiff[ant])
                    
        if res[0]['method'] == 'delayRms':
            mult = 1e12
            rmsunits = 'ps'
            threshold1 = 1 # 1ps
            threshold2 = 3 # 3ps
        else:
            mult = 180/pi
            rmsunits = 'deg'
            threshold1 = 30 # 30deg
            threshold2 = 60 # 60deg
        date,timestamp=au.getObservationStartDateFromASDM(asdm)
        pwv=au.getMedianPWV(asdm)
        print '<pre>\n'
        print '#############################'
        print 'Summary of results for %s' %resultname
        print '#############################'
        print 'date and timestamp:'
        print date,timestamp
        print "PWV: ", pwv[0]
        print "\nAnt  Pad  Length,  Height,  X Pos.Off [mm],    Y Pos.Off [mm],  Z Pos.Off [mm], Residual     ,  Avg/Std of   , Ant , DelayJumps Problem "
        print "             [m],     [m],                ,                  ,                , %s [%s],  fit.err [%s] ,     , Detected    Symbol"\
              %(res[0]['method'],rmsunits, rmsunits)

        minPosOff = zeros(3)+1
        maxPosOff = zeros(3)
        medPosOff = zeros(3)+1
        minPosErr = zeros(3)+1
        maxPosErr = zeros(3)
        medPosErr = zeros(3)
        
        for i in range(nAnts):
            ant = antList[i]
            avgFitErr = mean(fitcoef[ant][1,:]*mult)
            stdFitErr =  std(fitcoef[ant][1,:]*mult)
            residualRms = res[i]['Rms']*mult
            resRmsAnt.append(residualRms)
            pads.append(res[i]['padName'])
            NJumps =0
            #NJumps = size(ig[i]['scans'])
            if ant != refAnt:
                for j in range(3):
                    maxPosOff[j] = max([maxPosOff[j],res[i]['positionOffset'][j]*1e3])
                    minPosOff[j] = min([minPosOff[j],abs(res[i]['positionOffset'][j]*1e3)])
                    medPosOff[j] = median([medPosOff[j],abs(res[i]['positionOffset'][j]*1e3)])
                    maxPosErr[j] = max([maxPosErr[j],res[i]['positionErr'][j]*1e3])
                    minPosErr[j] = min([minPosErr[j],abs(res[i]['positionErr'][j]*1e3)])
                    medPosErr[j] = median([medPosErr[j],abs(res[i]['positionErr'][j]*1e3)])
                    
            # check results quality
            qa0 = ''
            qa1 = ''
            if NJumps > 1 :
                qa0 = bcolors.OKGREEN
                qa1 = bcolors.ENDC
                s1 = '+ '
            else:
                s1 = ''
            if NJumps > int(0.1*nScans):  # 10% of the number of scans
                qa0 = bcolors.FAIL
                qa1 = bcolors.ENDC
                s1 = '++ '

            qb0 = ''
            qb1 = ''
            if residualRms > threshold1 :
                qb0 = bcolors.OKGREEN
                qb1 = bcolors.ENDC
                s2 = s1+ '# '
            else:
                s2 = s1
            if  residualRms > threshold2:
                qb0 = bcolors.FAIL
                qb1 = bcolors.ENDC
                s2 = s1+ '## '

            qc0 = ''
            qc1 = ''
            if avgFitErr >  10:
                qc0 = bcolors.FAIL
                qc1 = bcolors.ENDC
                s3 = s2+ '$ '
            else:
                s3 = s2 
            qd0 = ''
            qd1 = ''
            if stdFitErr >  10:
                qd0 = bcolors.FAIL
                qd1 = bcolors.ENDC
                s4 = s3 + '* '
            else:
                s4 = s3

            if ant == refAnt:
                s4 = 'refAnt'
            
            print "%s %s  %6.1f, %6.1f, %7.3f (%2.3f),   %7.3f (%2.3f), %7.3f (%2.3f),    %s%5.2f%s     ,%s%6.2f%s/%s%6.2f%s  , %s    %s%d%s        %s"\
                  %(res[i]['antenna'],res[i]['padName'],blength[i],heightDiff[ant],\
                    res[i]['positionOffset'][0]*1e3,res[i]['positionErr'][0]*1e3,\
                    res[i]['positionOffset'][1]*1e3,res[i]['positionErr'][1]*1e3,\
                    res[i]['positionOffset'][2]*1e3,res[i]['positionErr'][2]*1e3,\
                    qb0,residualRms,qb1, qc0,avgFitErr,qc1,qd0, stdFitErr,qd1, res[i]['antenna'],qa0,NJumps,qa1, s4)

        print '\nMin                        %7.3f (%2.3f),  %7.3f (%2.3f), %7.3f (%2.3f) '%(minPosOff[0],minPosErr[0],minPosOff[1],minPosErr[1], minPosOff[2],minPosErr[2])
        print 'Median                     %7.3f (%2.3f),  %7.3f (%2.3f), %7.3f (%2.3f) ' %(medPosOff[0],medPosErr[0],medPosOff[1],medPosErr[1], medPosOff[2],medPosErr[2])
        print 'Max                        %7.3f (%2.3f),  %7.3f (%2.3f), %7.3f (%2.3f) ' %(maxPosOff[0],maxPosErr[0],maxPosOff[1],maxPosErr[1], maxPosOff[2],maxPosErr[2])
        print ''
        print '#######################'
        print "Legend for Problem Symbol: "
        print "+ / ++: A few/A lot of delay jumps. Re-run excluding problematic scans "
        print "# / ##: Large /Very large residual rms. Caused by atmospheric phase noise, long bselines, delay/phase jumps. Examine plot of that antennas. "
        print " $    : Large average (over scans) of the fit errors. Abnormally large  phase noise or no fringes detected. Examine plot for that antenna "
        print " *    : Large standard deviation (over scans) of the fit errors. Most likely due to delay jumps. Rerun excluding problematic scans"
        print '#######################'
        print '</pre>\n'
        qP= [i for i,x in enumerate(pads) if x[0] == 'P']
        qS= [i for i,x in enumerate(pads) if x[0] == 'S']
        qW= [i for i,x in enumerate(pads) if x[0] == 'W']
        bheight = array(bheight)
        blength = array(blength)
        resRmsAnt = array(resRmsAnt)

        # make the  phaseRMS vs baseline length
        figure(1,figsize=(11,8));clf()
        plot(blength, resRmsAnt,'o')
        plot(blength[qP], resRmsAnt[qP],'ro')
        plot(blength[qS], resRmsAnt[qS],'go')
        plot(blength[qW], resRmsAnt[qW],'mo')        
        grid(True)
        xlabel('baseline length [m]')
        ylim([0,10])
        ylabel('Delta Delay/Phase Residual Rms[%s]'%rmsunits)
        title('Residual Rms (after Baseline fit) vs baseline length refAnt = %s' %refAnt)
        legend(['non-branch','P-branch','S-branch','W-branch'])
        savefig('%s/%s_residualRMS_vs_baseline.png'%(plotsDir,asdm))
        close(1)

        # make the phaseRMS vs  height difference.
        figure(2,figsize=(11,8));clf()
        plot(abs(bheight), resRmsAnt,'o')
        plot(abs(bheight[qP]), resRmsAnt[qP],'ro')
        plot(abs(bheight[qS]), resRmsAnt[qS],'go')
        plot(abs(bheight[qW]), resRmsAnt[qW],'mo')
        grid(True)
        xlabel(' Absolute baseline height [m]')
        ylabel('Residual Rms[%s]'%rmsunits)
        ylim([0,10])
        legend(['non-branch','P-branch','S-branch','W-branch'])
        title('Residual Rms (after Baseline fit) vs baseline height refAnt = %s' %refAnt)
        savefig('%s/%s_residualRMS_vs_height.png'%(plotsDir,asdm))
        close(2)
        
        return

    def plotPWVvsHeight(self,asdm,refAnt):
        #TODO remove the mean from central antennas before calculating teh deviation
        # break down the data in 30mns
        #store to web page ?

        # make the plot vs time and save it
        figure(1,figsize=(11,5));clf()
        au.plotPWVFromASDM(asdm, figfile =True)

        antPos = au.readAntennaPositionFromASDM(asdm)
        stationPos = au.readStationFromASDM(asdm)
        pwv = au.readpwv(asdm)

        #split the above PWV into 30mn chunks
        nwvr_scans = size(pwv[0]/size(antPos.keys()))
        #if size nwvr_scans < 5:
        #    print "Sorry, only %d scans available in this ASDM. Not enough"
        #    return
        
        heightDiff = au.getBaselineHeightFromASDM(asdm,refAnt, verbose = False)
        ants = unique(pwv[2])
        pads = []
        for ant in ants:
            pads.append(stationPos[antPos[ant]['id']]['name'])
        pwv_m = []
        pwv_e = []
        height = []
        qP= [i for i,x in enumerate(pads) if x[0] == 'P']
        qS= [i for i,x in enumerate(pads) if x[0] == 'S']
        qW= [i for i,x in enumerate(pads) if x[0] == 'W']

        
        for ant in ants:
            q = find(array(pwv[2])==ant)
            pwv_m.append(1e3* mean(array(pwv[1])[q]))
            pwv_e.append(1e3*std(array(pwv[1])[q]))
            height.append(heightDiff[ant])
        
        height = array(height)
        pwv_m = array(pwv_m)
        pwv_e = array(pwv_e)

        # plot the PWV_mean vs  height difference vs array center antennas
        figure(2,figsize=(11,8));clf()
        errorbar(height, pwv_m, pwv_e,fmt = 'bo')
        errorbar(height[qP], pwv_m[qP],pwv_e[qP],fmt = 'ro', ecolor='r')
        errorbar(height[qS], pwv_m[qS],pwv_e[qS],fmt = 'go', ecolor ="g")
        errorbar(height[qW], pwv_m[qW],pwv_e[qW],fmt = 'mo', ecolor="m")
        grid(True)
        xlabel('baseline height [m]')
        ylabel('Mean PWV during observation [mm]')
        title('PWV vs relative elevation in %s \n refAnt: %s' %(asdm,refAnt))
        legend(['non-branch','P-branch','S-branch','W-branch'])
        savefig('%s_PWV_height.png'%(asdm))

        # plot the PWV_fluctuations vs  height difference vs array center antennas
        figure(3,figsize=(11,8));clf()
        plot(height,  pwv_e, 'bo')
        plot(height[qP],pwv_e[qP],'ro')
        plot(height[qS],pwv_e[qS],'go')
        plot(height[qW],pwv_e[qW],'mo')
        xl = xlim()
        ind = 0
        for ant in ants:
            text(xl[1]+0.02, pwv_e[ind],
                 str('%s: %s, %4.2f, %4.2f'%(ant,pads[ind],pwv_m[ind],pwv_e[ind])),size=7, ha='left',va='center')
            ind +=1
            
        grid(True)
        xlabel('baseline height [m]')
        ylabel('PWV fluctuations during observation [mm]')
        title('PWV std deviation vs relative elevation in %s \n refAnt: %s' %(asdm,refAnt))
        legend(['non-branch','P-branch','S-branch','W-branch'])
        savefig('%s_PWV_fluctuations_vs_height.png'%(asdm))
 

    def findScansToIgnore(self, a, mode = 'delays', ignoreAnts= None, debug=True):
        """
        find outlier  in  delay or phases in scan pairs using the MAD method
        if mode = 'delays', a is the fit values of the delays
        if mode = 'phase', as is the error on the fit values.
        We are using the differential ( scan to scan)  value, not the total
        """
        if type(ignoreAnts) == type([]):
            ignoreAnts = ignoreAnts
        else:
            ignoreAnts = [ignoreAnts]

        ants = sort(a.keys())

        scansToIgnore = []
        nscans = size(a[a.keys()[0]],1)
        for ant in ants:
            tmpscans = []
            if mode == 'delays':
                d = copy.deepcopy(a[ant][0]) # use the fit values (delays)
            else:
                d = copy.deepcopy(a[ant][1])  # use the err on the fit values
            done = 0
            if debug:
                clf();plot(d,'.-'); title(ant)
            while done == 0:
                #Avg,Std=self.weighted_avg_std(d,e)
                #Avg = stats.nanmean(d)
                #Std = stats.nanstd(d)
                Std = au.MAD(d)
                #q = find(abs(d-Avg) > 4*Std) # we assume the model is 0
                q = find(abs(d) > 5*Std)
                print "Debug"
                print q
                if debug:
                    hlines(5*Std,0,nscans+1)
                    hlines(-5*Std,0,nscans+1)
                if size(q) !=0:
                    if debug: plot(q,d[q],'ro')
                    d[q] = NaN
                    for qq in q: tmpscans.append(qq)
                    done = 0
                else:
                    done = 1
            tmpscans = array(sort(tmpscans))
            if debug:
                print tmpscans
            
            if (size(tmpscans)!=0):
                i = 0
                while i < size(tmpscans)-1:
                    if tmpscans[i+1] == tmpscans[i]+1:
                        tmpscans[i+1]=0
                        i +=2
                    else:
                        i +=1
                tmpscans = tmpscans[find(tmpscans !=0)]
            if debug:
                print ant, tmpscans
                tmpscans2=':'.join([str(x) for x in tmpscans])
                print ant+':'+tmpscans2
                raw_input()

            if ant in ignoreAnts: tmpscans = []   
            scansToIgnore.append( {'antenna': ant, 'scans': tmpscans})
            print "these are scans to ignore"         
            print scansToIgnore

  
        # save data with pickle if no file exists yet

        print "these are scans to ignore"         
        print scansToIgnore
        scanlist_merged=''
        scanlist_merged_total=''
        print "these are scans to ignore per antenna"         
        for y in scansToIgnore:
              antenna_flag=y['antenna']
              scanlist=y['scans']
              print scanlist
              if len(scanlist)==0:
                  continue
              else: 
                scanlist_merged=':'.join([str(x) for x in scanlist])
                print antenna_flag+':'+scanlist_merged
                antenna_flags_total=antenna_flag+':'+scanlist_merged
                scanlist_merged_total=scanlist_merged_total+' '+antenna_flags_total
         
        print "### Final Scan List ###"
        print scanlist_merged_total
        print "### Saving ScanToIgnore with pickle ###"
        
        f = open(self.file_scansToIgnore,'w')
        pickle.dump(scansToIgnore, f)
        f.close()
  
        return  scansToIgnore                            

    def weighted_avg_std(self,values, weights):
        """
        Return the weighted average and standard deviation.
        values, weights -- Numpy ndarrays with the same shape.
        """
        avg = average(values, weights=weights)
        var = average((values-avg)**2, weights=weights)  # Fast and numerically precise
        return (avg, sqrt(var))

    def mergeScans(self, scansToIgnore):
        AllScansToIgnore =[]
        for i in range(size(scansToIgnore)):
            for j in range(size(scansToIgnore[i]['scans'])):
                AllScansToIgnore.append(scansToIgnore[i]['scans'][j])
        AllScansToIgnore = unique(AllScansToIgnore)
        return AllScansToIgnore


    def mergeScans_antennas(self, scansToIgnore):

        scanlist_merged_total=''
        print "Merging scans  per antenna"         
        for y in scansToIgnore:
              antenna_flag=y['antenna']
              scanlist=y['scans']
              print scanlist
              if len(scanlist)==0:
                  continue
              else: 
                scanlist_merged=':'.join([str(x) for x in scanlist])
                print antenna_flag+':'+scanlist_merged
                antenna_flags_total=antenna_flag+':'+scanlist_merged
                scanlist_merged_total=antenna_flags_total+' '+scanlist_merged_total
         
        return scanlist_merged_total
     
    def compare2results(self,resultFile1,resultFile2, excludeAntennas=''):
        """
        compares 2 results
        Do not need to necessarily have the same size and the same structure.
        Must have the same reference antenna
        Antennas are ordered by distance to ref antenna of first dataset
        """
        res1 = self.readPositionResults(resultFile1)
        res2 = self.readPositionResults(resultFile2)
        if 'delays' in resultFile1:
            asdm1 = resultFile1.split('delays')[0][0:-1]
            asdm2 = resultFile2.split('delays')[0][0:-1]
                        
        else:
            asdm1 = resultFile1.split('phases')[0]
            asdm2 = resultFile2.split('phases')[0]
        
        removeAnt = excludeAntennas.split(',')
        
        # find common antennas
        ants1 = []
        ants2 = []
        for ind in range(size(res1)):
            ants1.append(res1[ind]['antenna'])
        for ind in range(size(res2)):
            ants2.append(res2[ind]['antenna'])
        antList = sort(list(set(ants1) & set(ants2)))
        n = size(antList)
        
        baselineLength = au.getBaselineLengthsFromASDM(asdm1,res1[0]['refAntenna'])
        for k in baselineLength.keys():
            if k not in antList: baselineLength.pop(k)
        antList_by_bl = sorted(baselineLength, key=baselineLength.get)
        bl_by_bl = sorted(baselineLength.values())
        bl_by_bl = ['%d'%i for i in bl_by_bl]
                               
        offset = zeros([3,n,2])
        err = zeros([3,n,2])
        delayRms = zeros([n,2])
        diff = zeros([3,n])
        differr = zeros([3,n])
        ants = []

        i = 0
        for ant in antList_by_bl:
            if ant in removeAnt:
                i +=1
                continue
            q1 = find(array(ants1) == ant)
            q2 = find(array(ants2) == ant)
            
            offset[0,i,0]= res1[q1]['positionOffset'][0]
            offset[1,i,0]= res1[q1]['positionOffset'][1]
            offset[2,i,0]= res1[q1]['positionOffset'][2]
            err[0,i,0]= res1[q1]['positionErr'][0]
            err[1,i,0]= res1[q1]['positionErr'][1]
            err[2,i,0]= res1[q1]['positionErr'][2]
            offset[0,i,1]= res2[q2]['positionOffset'][0]
            offset[1,i,1]= res2[q2]['positionOffset'][1]
            offset[2,i,1]= res2[q2]['positionOffset'][2]
            err[0,i,1]= res2[q2]['positionErr'][0]
            err[1,i,1]= res2[q2]['positionErr'][1]
            err[2,i,1]= res2[q2]['positionErr'][2]
            diff[0,i]= res1[q1]['positionOffset'][0]-res2[q2]['positionOffset'][0]
            diff[1,i]= res1[q1]['positionOffset'][1]-res2[q2]['positionOffset'][1]
            diff[2,i]= res1[q1]['positionOffset'][2]-res2[q2]['positionOffset'][2]
            differr[0,i]=sqrt(err[0,i,0]**2+err[0,i,1]**2)
            differr[1,i]=sqrt(err[1,i,0]**2+err[1,i,1]**2)
            differr[2,i]=sqrt(err[2,i,0]**2+err[2,i,1]**2)

            if res1[i]['method'] == 'delayRms':
                delayRms[i,0]= res1[q1]['Rms']*1e12 # in ps
                delayRms[i,1]= res2[q2]['Rms']*1e12 # in ps
            else:
                delayRms[i,0]= res1[q1]['Rms']*180/pi # in deg
                delayRms[i,1]= res2[q2]['Rms']*180/pi #  in deg
            i +=1
            
        figure(10,figsize=(11,8));clf()
        ax = subplot(4,1,1)
        plot(arange(n),diff[0,:]*1e3,'o')
        errorbar(arange(n),diff[0,:]*1e3,yerr= differr[0,:]*1e3, fmt = 'o')
        
        plot([0,n],[-.1,-.1],'b')
        plot([0,n],[0.1,0.1],'b')
        q0 = find(abs(diff[0,:]*1e3) > 0.1)
        
        plot(q0,diff[0,q0]*1e3,'ro')
        errorbar(q0,diff[0,q0]*1e3,yerr= differr[0,q0]*1e3, fmt = 'ro')
        ax.set_xticklabels(())
        
        xlim([-1,n])
        #ylim([-2,2])
        grid()
        ylabel('X diff [mm]')
        for q in q0:
            text(q+0.2,diff[0,q]*1e3+0.02,antList_by_bl[q])
        subplots_adjust(hspace = 0.01)

        
        ax = subplot(4,1,2)
        plot(diff[1,:]*1e3,'o')
        errorbar(arange(n),diff[1,:]*1e3,yerr= differr[1,:]*1e3, fmt = 'o')
        plot([0,n],[-.1,-.1],'b')
        plot([0,n],[0.1,0.1],'b')
        q1 = find(abs(diff[1,:]*1e3) > 0.1)
        plot(q1,diff[1,q1]*1e3,'ro')
        errorbar(q1,diff[1,q1]*1e3,yerr= differr[1,q1]*1e3, fmt = 'ro')
        ax.set_xticklabels(())
        grid()
        xlim([-1,n])
        #ylim([-2,2])
        ylabel('Y diff [mm]')
        for q in q1:
            text(q+0.2,diff[1,q]*1e3+0.02,antList_by_bl[q])

        subplots_adjust(hspace = 0.01)
        subplot(4,1,3)
        plot(diff[2,:]*1e3,'o')
        errorbar(arange(n),diff[2,:]*1e3,yerr= differr[2,:]*1e3, fmt = 'o')
        plot([0,n],[-.1,-.1],'b')
        plot([0,n],[0.1,0.1],'b')
        ax.set_xticklabels(())
        grid()
        ylabel('Z diff[mm]')
        q2 = find(abs(diff[2,:]*1e3) > 0.1)
        plot(q2,diff[2,q2]*1e3,'ro')
        errorbar(arange(n)[q2],diff[2,q2]*1e3,yerr= differr[2,q2]*1e3, fmt = 'ro')
        for q in q2:
            text(q+0.2,diff[2,q]*1e3+0.02,antList_by_bl[q])
        xlim([-1,n])
        #ylim([-6,6])
        subplots_adjust(hspace = 0.01)
        
        ax = subplot(4,1,4)
        plot(delayRms[:,0],'go')
        plot(delayRms[:,1],'mo')
        xlim([-1,n])
        if res1[0]['method'] == 'delayRms':
            thresh = 5
        else:
            thresh = 60
        ylim([0,thresh])
        q3 = find(delayRms[:,0] > thresh)
        for q in q3:
            annotate('%2.1fps\n%2.1fps'%(delayRms[q,0],delayRms[q,1]),xy=(q,5),xytext=(q-0.5,3),arrowprops=dict(facecolor='black', width=1, shrink=0.05,headwidth=5))
        xticks(arange(n),antList_by_bl,rotation=90)
        for q in arange(n):
            text(q-0.2,thresh-1.3,bl_by_bl[q], rotation='vertical')
        grid()

        ylabel('Delay RMS [ps]')
        suptitle('Comparison of tc_antpos results: %s(green) vs \n  %s(magenta)'%(resultFile1,resultFile2))
        savefig('%s_%s_position_results_comparison.png'%(resultFile1,resultFile2), format='png')
        return diff*1e3, differr*1e3
    


    def tmp(self):
        DdirX5,TdirX5, fitCoefX5 = b.readBaselineFit('uid___A002_X8ac80e_X5_delays_C_baseline.dat')
        DdirXff,TdirXff, fitCoefXff = b.readBaselineFit('uid___A002_X8ac80e_Xff_delays_C_baseline.dat')
        DdirX294,TdirX294, fitCoefX294 = b.readBaselineFit('uid___A002_X8ac80e_X294_delays_C_baseline.dat')
        positionResultsX5 = b.readPositionResults('uid___A002_X8ac80e_X5_antpos_delays_C_result')
        positionResultsXff = b.readPositionResults('uid___A002_X8ac80e_Xff_antpos_delays_C_result')
        positionResultsX294 = b.readPositionResults('uid___A002_X8ac80e_X294_antpos_delays_C_result')  

        aList,DrmsX5,TrmsX5 = b.calcResiduals(DdirX5,TdirX5,fitCoefX5,positionResultsX5)
        aList,DrmsXff,TrmsXff = b.calcResiduals(DdirXff,TdirXff,fitCoefXff,positionResultsXff)
        aList,DrmsX294,TrmsX294 = b.calcResiduals(DdirX294,TdirX294,fitCoefX294,positionResultsX294)


    def getRefAntennaASDM(self,asdm):
        # Returns best reference antenna based on
        #         * shortest mean baseline length
        #         * antenna has not been moved in at least 3 months
        # Written: A. Hales - June 2015

        mean_lengths={}
        # Read antenna list
        ants = au.readAntennasFromASDM(asdm, verbose = False)
        lengths=[]
        best_ant=''
        date_moved=''
        age_moved=''

        # Get baselines per antenna
        for ant in ants:
            baselines=au.getBaselineLengthsFromASDM(asdm,ant)
            lenghts=np.array(baselines.values())
            print ant
            mean_length=lenghts.mean()
            mean_lengths[ant]=mean_length


        # Sort antennas by mean baseline length
        
        import operator
        antList_by_bl = sorted(mean_lengths.items(), key=operator.itemgetter(1))
        
        #antList_by_bl=antList_by_bl.reverse
        
        print "Ordered list of antennas (in mean baseline length) \n"
        print antList_by_bl

        # Choose the first antenna
        i=0
        for ants in antList_by_bl:
           print ants[0]
           centre_ant=ants[0]
           #antList_by_bl.pop(i)
   
           print "Best Reference antenna based on baseline lenght " + centre_ant

           # Check for las time it was moved
   
           (date, age, pad1, pad2,ant)=self.findLastMove(centre_ant)
           
           print date +' '+ants[0]+' '+ ant+' '+pad1+' '+pad2+' '+str(age)

           # Last move tolerance arbitrarely set to 120 days.
           if (age>120):
               best_ant=centre_ant
               date_moved=date
               age_moved=age
               break;
           if (age>90):
               best_ant=centre_ant
               date_moved=date
               age_moved=age
               break;
           if (age>60):
               best_ant=centre_ant
               date_moved=date
               age_moved=age
           if (age>30):
               best_ant=centre_ant
               date_moved=date
               age_moved=age
               break;    
           if (age<30):
               print "This antenna was moved less than 30 days ago ((%.1f) days ago) \n" % age
               print "Moving into next antenna \n"
               i=i+1
        if (best_ant==''):
               print "There is no antenna with position older than 30 days. \n" 
               print "Please include in Baseline run an antenna which has been on the same pad for more than a month a re-observe the data. \n"
               i=i+1
               return None   
   
        print "Reference antenna is "+ best_ant + " and was last moved on "+  date_moved +" (%.1f) days ago" % age_moved
        return best_ant

        
       

    def findLastMove(self,antenna):
           # Returns data and age (in days) from the last time this antenna was moved
           # e.g
           #       blr.findLastMove('DA59')
           #returns
           #      ('2014-02-01T00:00', 495.0, 'OSF', 'A021', 'DA59')
   
                      
           date_today = dt.datetime.today().strftime('%Y%m%d')
           date_today_mjd=au.strDate2MJD(date_today)

           #
           import os
           currentpath=os.getcwd()

           print '#### CVS updating antennaMoves.txt... #### '
           # cvs up
           dir='/users/%s/AIV/science/PadData/'%username
           print 'cd '+ dir
           os.chdir(dir)
           up_cmd = 'cvs up antennaMoves.txt'
           system_except(up_cmd)
           os.chdir(currentpath)
   
           # Look for occurences of selected antenna in antennaMoves.txt
           
           os.system('rm -rf temp.txt')
           os.system('grep '+ antenna +' '+dir+'antennaMoves.txt > temp.txt')
           #os.system('grep DV12 /users/ahales//AIV/science/PadData/antennaMoves.txt > temp.txt')
   
           file = open('temp.txt', "r")
   
           count=1
   
           moves={}
           for line in file:
               print line
               line_split=line.split(' ')
               date=line_split[0]
               ant=line_split[1]
               pad1=line_split[2]
               pad2=line_split[3]
               mjd = au.strDate2MJD(date)
               age=date_today_mjd-mjd
               moves[date]=age
               #print date +' '+ant+' '+pad1+' '+pad2+' '+str(age)

           import operator
           print moves
           moves_by_date = sorted(moves.items(), key=operator.itemgetter(1))
          # print  moves_by_date
           last_move=moves_by_date.pop(0)
          # print last_move[0]
          # print last_move[1]
           return date, age, pad1, pad2, ant
        

