#!/usr/bin/env python
# CheckForMonitorTimeGaps
#written by dbarkats

# $Id $

from optparse import OptionParser
import tmUtils as tm
import os,sys
from pylab import *
import time
from dateutil import rrule
from datetime import datetime,timedelta
from calendar import monthrange
import pickle
import getpass
username = getpass.getuser()
sys.path.append('/users/%s/AIV/science/analysis_scripts/'%username)

# TODO
# Get list of monitor points
#for past day
# for all monitor points
# check the time gaps
# if one of them exceeds Make plot and send a summary report of those that exceed 5%
# monitor points:
   # Mount: METR_EQUIP_STATUS monitored once every 5mns.
   # ACD ARM2 every 5seconds. 1/4 wave plot mechnism position. should return 0.
   # IFPROC FIFO_DEPTH; 2 integers samples every 15s
   # PSD and PSA ALIVE_COUNTER: integter sampled every 10s.


class bcolors:
    HEADER = '\033[95m'
    OKBLUE = '\033[94m'
    OKGREEN = '\033[92m'
    WARNING = '\033[93m'
    FAIL = '\033[91m'
    ENDC = '\033[0m'
    

def get_monitor_list():
    monList= []
    monList.append(['Mount','METR_EQUIP_STATUS'])
    monList.append(['FrontEnd_ACD','ARM2'])
    monList.append(['IFProc0','FIFO_DEPTHS'])
    monList.append(['PSA','ALIVE_COUNTER'])
    monList.append(['PSD','ALIVE_COUNTER'])
    monList.append(['LLC','VF_MON'])

    return monList

def get_ant_list():
    
    #return ['DV01']
    return ['DV01','DV04','DV12','DV25','DA42','DA44','DA50','DA61','CM01','CM05','CM09','CM12','PM01','PM02','PM03','PM04']
    
def system_except(cmd):
    ret = os.system(cmd)
    if ret != 0:
        raise Exception("Command '%s' returned non-zero exit status %d" %(cmd, ret))


# Execution starts here
if __name__ == '__main__':
    usage = '''

  
    '''
    # Initialize parser
    parser = OptionParser()

    parser.add_option("-f", "--from", dest="fr",
                      help="date you want to start your check. format YYYY-MM-DDTHH:MM:SS ")

    parser.add_option("-t", "--to", dest="to",
                      help="date you want to stop your check on.format YYYY-MM-DDTHH:MM:SS ")

    (options, args) = parser.parse_args()

    now = datetime.now()
    today = ('%s'%now)[0:10]
    yesterday = ('%s'%(now - timedelta(days=1)))[0:10]
    start='%sT00:00:00'%yesterday
    end='%sT23:59:59'%yesterday
    
    if options.fr is None:
        day1 = start
    else:
        day1 = options.fr 
    if options.to is None:
        day2 = end
    else:
        day2 = options.to
    print '### Checking monitoring time gaps from: %s to: %s'%(day1,day2)
    
    monList = get_monitor_list()
    antList = get_ant_list()
    percentLost = []
    ngaps = []
    monName = []
    for ant in antList:
        for mon in monList:
            print ant, mon
            monName.append('%s_%s_%s'%(ant,mon[0],mon[1]))
            a,b,c =  tm.check_for_time_gaps(ant,mon[0],mon[1], startdate= day1, enddate=day2)
            ngaps.append(a)
            percentLost.append(c)

    # present results
    print '\n'
    print '\n'
    print '\n'
    print '### Final results over %d monitor points and %d antennas ###'%(len(monList),len(antList))
    q = find(array(percentLost) > 5.0)
    if len(q) == 0:
        print day1
        print 'No gaps >5%% in this list of monitpoints from  %s to %s'%(day1,day2)
    else:
        print "Found a median of %d gaps, with %3.1f%% data lost "%(median(ngaps), median(percentLost))
        print "MON                           , NGAPS, %LOST "
        for i in range(size(ngaps)):
            if percentLost[i] > 5.0:                
                print bcolors.FAIL+'%30s,  %4d,  %4.1f'%(monName[i],ngaps[i],percentLost[i])+bcolors.ENDC
            else:
                print '%30s,  %4d,  %4.1f'%(monName[i],ngaps[i],percentLost[i])

