#!/usr/bin/env python

 
"""
Script Edit Pad Delay for a given Pad on the TMCDB

Usage: EditFirstPadDelay.py -a DA46 -p A058 -d 1.000000E-6



#"""

# Execution starts here

import os, sys
import socket
import getpass
import pickle
import glob
from optparse import OptionParser;


username = getpass.getuser()

sys.path.append('/users/%s/AIV/science/scripts/R10.4_WORKING/'%username)

sys.path.append('/users/%s/AIV/science/analysis_scripts/'%username)


#sys.path.append('/users/%s/AIV/science/scripts/R10.4_WORKING/'%username)
#sys.path.append('/users/%s/AIV/science/analysis_scripts//'%username)
#sys.path.append('/opt/telcalsa/current/telcalsa/current/lib/python/site-packages/');
#from FocusModelEditor import FocusModelEditor
#from PointingModelEditor import PointingModelEditor
#from PositionEditor import PositionEditor
#from DelayEditor import DelayEditor 

from pylab import *
import tmUtils as tm
from datetime import datetime,timedelta
import warnings
from  getNominalPtBandOffsets import getNominal
import re
import tmcdbPlayer_tmp as tp
import time;

import plot_tmcdb_content as tk

def system_except(cmd):
    ret = os.system(cmd)
    if ret != 0:
        raise Exception("Command '%s' returned non-zero exit status %d" %(cmd, ret))


def grep_file (f,search_term):
  line_found=''
  for line in open(f, 'r'):
      if re.search(search_term, line):
          print line,
          line_found=line
          if line == None:
              print 'no matches found'
  return line_found


parser=OptionParser();
parser.add_option("-a","--antenna",dest="antenna",help="Antenna to get parameters. Ex.: DV01",default="");
parser.add_option("-d","--delay",dest="delay",help="New Pad Delay e.g 1.782948E-6 (in seconds)",default="");
parser.add_option("-p","--pad",dest="pad",help="Pad to get parameters. Ex.: A001",default="");
parser.add_option("-c","--comment",dest="comment",help="Comment for CVS",default="First Pad Delay");



(options,args)=parser.parse_args();


#################################
# Define Antenna & Pad
#################################

ant=options.antenna
new_delay=options.delay
pad=options.pad
comment=options.comment

print "Processing  Antenna %s in Pad %s for new pad delay %s " % (ant,pad,new_delay)
print "\033[90m#########################################"

#################################
# Time
#################################

today=tk.getCurrentTime()


################################
# Check Pad Delay
################################

date=today.split('T')[0]

padDelay=tk.getPadDelayModelDate(ant,date)

print "TMCDB Pad delay is %s " % (padDelay)

outfile=tk.getFilename("delay_model",date);

print "Delay file %s " % outfile

term='PadToCorrDelay pad=\"%s\"'%pad

grep_file(outfile,term)

#new_delay='1.000000E-6'

new_line='        <PadToCorrDelay pad="%s">%s</PadToCorrDelay>\n'% (pad,new_delay)

print "new line is %s " % new_line

#def replaceAll(file,searchExp,replaceExp):

new_file=outfile.split('.xml')[0]+'_new.xml'

print "new xml file is %s " % new_file

old_f=open(outfile,'r')
f=open(new_file,'w')

for line in old_f:
        if term in line:
            line = new_line
        f.write(line)
f.close()
old_f.close()


grep_file(new_file,term)

os.system('chmod ugo+rwx -R %s' %  new_file)
os.system('rm -rf %s' %  outfile)


print "#########################################\033[0m"
print "##################################"
print "# New XML file created           #"
print "##################################"
print "\n"
   
answer = raw_input('Would you like to proceed with the Import steps. Be careful, if answer is "y", you will proceed with importing these model to the TMCDB. {y|n} ?')

if answer == 'y' or answer == 'Y' or answer == 'yes' or answer == 'YES' or answer == 'Yes':
           
   
   cmd_import = 'ImportDelayModel.py -f %s -m "Updating %s Pad Delay - %s"'%(new_file,pad,comment)

   print cmd_import
   system_except(cmd_import)
   print "New Pad Delay loaded in the TMCDB "


else:
   print 'You have chosen to do the Edit manually.'
   print "Edit Pad Delay in the TMCDB Manually "
   print "or run"


   print 'Generated xml file: %s \n'% new_file
   print 'To update the tmcdb execute: \n '
   print '\033[1mImportDelayModel.py -f %s -m "Updating %s Pad Delay [YOUR COMMENT]" \033[0m'%(new_file,pad)

print "\n"
