import os
from pylab import *
import time
import datetime
import re

# 1st pass at parsing of all errors from FrontEndError logs
def parse_Errors(fileList=[]):
 
    outfile=open('Tuning_Errors_summary.txt','w')
    outfile.write('Summary of all the tunings errors until today %s\n \n' % time.asctime())
    outfile.write('==================== \n')

    if size(fileList) == 0:
        fileList=findFiles()

    for input_file in fileList:
        parse_file1(input_file, outfile)
    outfile.close()

    return

# 2nd pass at parsing  of Tuning_Errors_summary.txt
def classify_Errors():
    b=open('Tuning_Errors_summary.txt')
    obs=b.readlines()
    data={}
    attList = ['f','class','ant','utime','iftp', 'pmc', 'lprV', 'ind','dt']
    for i in attList: data[i] = []

    i=2
    while i < size(obs) -1:
        i=i+1
        line=obs[i]
        section=''
        while  not line.startswith('==='):
            section=section+line
            i=i+1
            line=obs[i]
        
        data['ind'].append(i)
        data['f'].append(double(section.partition('Frequency =')[2].split('GHz')[0]))
        acstime= double(section.partition('alma time =')[2].split('\n')[0])
        utime = (float(acstime) - 122192928e9)/1e7
        data['utime'].append(time.gmtime(utime))
        data['dt'].append(datetime.datetime(data['utime'][-1][0],data['utime'][-1][1],data['utime'][-1][2],data['utime'][-1][3],data['utime'][-1][4],data['utime'][-1][5]))
        antind=section.find('Host :')
        if antind != -1: data['ant'].append(section[antind+7:antind+10])

                  
        if ('LS' in section) or ('laser synthesizer'  in section):
            data['class'].append(0)
            data['iftp'].append(NaN)
            data['pmc'].append(NaN)
            data['lprV'].append(NaN)
        elif ('No Lock found within' in section) or ('Failed to lock the WCA' in section):
            data['class'].append(1)
            data['iftp'].append(NaN)
            data['pmc'].append(NaN)
            data['lprV'].append(NaN)
        elif 'specified  parameters' in section:
            data['class'].append(2)
            data['iftp'].append(NaN)
            data['pmc'].append(NaN)
            data['lprV'].append(NaN)
        elif ('The WCA didn\'t lock properly')  in section:
            data['class'].append(3)
            #print double(section.partition('IFTotal power:')[2][0:9])
            data['iftp'].append(double(section.partition('IFTotal power:')[2][0:9]))
            data['pmc'].append(double(section.partition('PM Current:')[2][0:11]))
            data['lprV'].append(double(section.partition('Previous value:')[2].split('\'')[0]))
        elif 'false lock' in section:
            data['class'].append(4)
            data['iftp'].append(NaN)
            data['pmc'].append(NaN)
            data['lprV'].append(NaN)
        elif 'Lost lock' in section:
            data['class'].append(5)
            data['iftp'].append(NaN)
            data['pmc'].append(NaN)
            data['lprV'].append(NaN)
        elif ('monitor request' in section) or ('control request' in section):
            data['class'].append(6)
            data['iftp'].append(NaN)
            data['pmc'].append(NaN)
            data['lprV'].append(NaN)
        elif 'Operation Timeout' in section:
            data['class'].append(7)
            data['iftp'].append(NaN)
            data['pmc'].append(NaN)
            data['lprV'].append(NaN)          
        else:
            data['class'].append(9)
            data['iftp'].append(NaN)
            data['pmc'].append(NaN)
            data['lprV'].append(NaN)

    return data
                
def findFiles():
    datadir="/data/RADIO/"
    fileList=os.popen('find  %s -name FrontEndErrors*' %(datadir)).read().split('\n')
    if fileList != '':
        return fileList[0:-1]
    else:
        print 'could not find this file in local dir or in /data/RADIO'
        return

def parse_file1(input_file, outfile):

    b=open(input_file)
    outfile.write('%s \n'% input_file)
    obs=b.readlines()
    for i in range(size(obs)/2):
        line1=obs[2*i+0]
        print line1
        if 'Frequency' in line1.split():
            host=[]
            host.append('')
            off0=outfile.tell()
            outfile.write('Frequency = %s GHz \n' %line1.split()[4])
            off1=outfile.tell()
            line2=obs[2*i+1]
            #print line2
            tmp1=re.split('-abm',line2)
            if size(tmp1) > 1:
                for k in range(size(tmp1)-1):
                    host_new=tmp1[k][-4::]
                    if not(host_new in host[-1]):
                        host.append(host_new)
                        outfile.write('Host : %s \n' % host_new )
                    
                    detail_index1 = [match.start() for match in re.finditer(re.escape("Detail'; Value = '"), tmp1[k+1])]
                    detail_index2 = [match.start() for match in re.finditer(re.escape("Detail', value='"), tmp1[k+1])]
                    addi_index   = [match.start() for match in re.finditer(re.escape("Additional'; Value ="), tmp1[k+1])]
                    cont_index   = [match.start() for match in re.finditer(re.escape("Context"), tmp1[k+1])]
                    short_index  = [match.start() for match in re.finditer(re.escape("shortDescription"), tmp1[k+1])]

                    if size(short_index) != 0:
                        for j in range(size(short_index)):
                            outfile.write('Short description : %s \n' %(tmp1[k+1][short_index[j]+17::].split(',')[0]))
                    if size(detail_index1) != 0:
                        for j in range(size(detail_index1)):
                            outfile.write('Detailed error : %s \n' %(tmp1[k+1][detail_index1[j]+18::].split("Name")[0]))
                    if size(detail_index2) != 0:
                        for j in range(size(detail_index2)):
                            outfile.write('Detailed error : %s \n' %(tmp1[k+1][detail_index2[j]+16::].split(")")[0]))
                    if size(addi_index) != 0:
                        for j in range(size(addi_index)):
                            outfile.write('Additional error : %s \n' %(tmp1[k+1][addi_index[j]+20::].split("Name = ")[0]))
                    if size(cont_index) != 0:
                        for j in range(size(cont_index)):
                            outfile.write('Context error : %s \n' %(tmp1[k+1][cont_index[j]+16::].split(')')[0]))

            else:
                
                detail_index1 = [match.start() for match in re.finditer(re.escape("Detail'; Value = '"), tmp1[0])]
                detail_index2 = [match.start() for match in re.finditer(re.escape("Detail', value='"), tmp1[0])]
                              
                addi_index = [match.start() for match in re.finditer(re.escape("Additional'; Value ="), tmp1[0])]
                cont_index= [match.start() for match in re.finditer(re.escape("Context"), tmp1[0])]
                short_index  = [match.start() for match in re.finditer(re.escape("shortDescription"), tmp1[0])]

                if size(short_index) != 0:
                    for j in range(size(short_index)):
                        outfile.write('Short description : %s \n' %(tmp1[0][short_index[j]+17::].split(',')[0]))
                if size(detail_index1) != 0:
                    for j in range(size(detail_index1)):
                        outfile.write('Detailed error : %s \n' %(tmp1[0][detail_index1[j]+18::].split("Name")[0]))
                if size(detail_index2) != 0:
                    for j in range(size(detail_index2)):
                        outfile.write('Detailed error : %s \n' %(tmp1[0][detail_index2[j]+16::].split(")")[0]))
                if size(addi_index) != 0:
                    for j in range(size(addi_index)):
                        outfile.write('Additional error : %s \n' %(tmp1[0][addi_index[j]+20::].split('Name = ')[0]))
                if size(cont_index) != 0:
                    for j in range(size(cont_index)):
                        outfile.write('Context error : %s \n' %(tmp1[0][cont_index[j]+16::].split(')')[0]))
             
                    
            tmp=line2.split('timeStamp=')
            if size(tmp) >  1:
                acstime=(tmp[1][0:18])
                outfile.write('alma time = %s \n'  % acstime)
                utime = (float(acstime) - 122192928e9)/1e7
                # UNIX time to GMT
                timestamp = time.gmtime(utime)
                outfile.write('UT= %s \n'%(time.strftime('%Y-%m-%dT%H:%M:%S', timestamp)))
                
            if outfile.tell() == off1:
                print off0-off1
                outfile.seek(off0-off1,1)
            else:
                outfile.write('==================== \n')


def make_plots(d):

    t=array(d['dt'])
    clas=array(d['class'])
    f=array(d['f'])
    iftp=array(d['iftp'])
    lprv=array(d['lprV'])
    pmc=array(d['pmc'])


    tlim=find(t > datetime.datetime(2010,7,1,00,00,00))

    #data summary
    figure(8, figsize=(10,5))
    clf()
    subplot(2,1,1)
    plot_date(t, clas,'o')
    plot_date(t[tlim],clas[tlim],'or')
    ylim(-1,10)
    xlabel('date UT'); ylabel('Locking error class')
    bins=arange(11)-0.5
    subplot(2,1,2)
    hist(clas,bins)
    hist(clas[tlim],bins, fc='r')
    ylim(0,300)
    figtext(0.7, 0.4, 'Blue, all data', color='b')
    figtext(0.7, 0.37, 'Red, post July 1 2010', color='r')
    figtext(0.4, 0.93, ' Classification of locking errors', size='large')
    savefig('class_lock_errors_histogram.png', format='png')

    t=t[tlim]
    clas=clas[tlim]
    f=f[tlim]
    iftp=iftp[tlim]
    lprv=lprv[tlim]
    pmc=pmc[tlim]

    
    b3 = (f < 116)
    b6 = logical_and(f > 211, f <  275)
    b7 = logical_and(f > 275, f <  373)
    b9 = logical_and(f > 602, f <  720)

    e0 = (clas == 0)
    e1 = (clas == 1)
    e2 = (clas == 2)
    e3 = (clas == 3)
    e4 = (clas == 4)
    e5 = (clas == 5)

    e6 = (clas == 6)
    e7 = (clas == 7)
    e9 = (clas == 9)
    e9= logical_or(e6,e7,e9)

    bin3=arange(83,118)
    bin6=arange(210,277)
    bin7=arange(274,375)
    bin9=arange(601,722)
    
    
    # class 0 errors
    e=e0
    
    figure(1)
    clf()
    subplot(2,2,1)
    q=find(logical_and(b3,e))
    n,bin, patches=hist(f[q],bin3)
    subplot(2,2,2)
    q=find(logical_and(b6,e))
    n,bin, patches=hist(f[q],bin6)
    subplot(2,2,3)
    q=find(logical_and(b7,e))
    n,bin, patches=hist(f[q],bin7)
    subplot(2,2,4)
    q=find(logical_and(b9,e))
    n,bin, patches=hist(f[q],bin9)
    figtext(0.3, 0.95, ' Class 0 lock failures', size='large')
    savefig('class0_lock_errors.png', format='png')

    # class 1 errors
    e=e1
    
    figure(2)
    clf()
    subplot(2,2,1)
    q=find(logical_and(b3,e))
    n,bin, patches=hist(f[q],bin3)
    subplot(2,2,2)
    q=find(logical_and(b6,e))
    n,bin, patches=hist(f[q],bin6)
    subplot(2,2,3)
    q=find(logical_and(b7,e))
    n,bin, patches=hist(f[q],bin7)
    subplot(2,2,4)
    q=find(logical_and(b9,e))
    n,bin, patches=hist(f[q],bin9)
    figtext(0.3, 0.95, ' Class 1 lock failures', size='large')
    savefig('class1_lock_errors.png', format='png')

    # class 2 errors
    e=e2
    
    figure(3)
    clf()
    subplot(2,2,1)
    q=find(logical_and(b3,e))
    n,bin, patches=hist(f[q],bin3)
    subplot(2,2,2)
    q=find(logical_and(b6,e))
    n,bin, patches=hist(f[q],bin6)
    subplot(2,2,3)
    q=find(logical_and(b7,e))
    n,bin, patches=hist(f[q],bin7)
    subplot(2,2,4)
    q=find(logical_and(b9,e))
    n,bin, patches=hist(f[q],bin9)
    figtext(0.3, 0.95, ' Class 2 lock failures', size='large')
    savefig('class2_lock_errors.png', format='png')

    # class 3 errors
    e=e3
    figure(4)
    clf()
    subplot(2,2,1)
    q=find(logical_and(b3,e))
    n,bin, patches=hist(f[q],bin3)
    subplot(2,2,2)
    q=find(logical_and(b6,e))
    n,bin, patches=hist(f[q],bin6)
    subplot(2,2,3)
    q=find(logical_and(b7,e))
    n,bin, patches=hist(f[q],bin7)
    subplot(2,2,4)
    q=find(logical_and(b9,e))
    n,bin, patches=hist(f[q],bin9)
    figtext(0.3, 0.95, ' Class 3 lock failures', size='large')
    savefig('class3_lock_errors.png', format='png')


    figure(10)
    clf()
    subplot(3,1,1)
    plot(f[e3],pmc[e3],'o')
    xlabel('Freq [GHz]');ylabel('Photomixer current [Amps]')
    subplot(3,1,2)
    plot(f[e3],lprv[e3],'o')
    xlabel('Freq [GHz]');ylabel('LPR Voltage prior to setback to zero [V]')
    subplot(3,1,3)
    plot(f[e3],iftp[e3],'o')
    ylim(-1,0)
    xlabel('Freq [GHz]');ylabel('photomixer IF total power [?]')
    figtext(0.3, 0.95, 'Numerical values for Class 3 lock failures', size='large')
    savefig('class3_lock_errors_values.png', format='png')

    # class 4 errors
    e=e4
    figure(5)
    clf()
    subplot(2,2,1)
    q=find(logical_and(b3,e))
    n,bin, patches=hist(f[q],bin3)
    subplot(2,2,2)
    q=find(logical_and(b6,e))
    n,bin, patches=hist(f[q],bin6)
    subplot(2,2,3)
    q=find(logical_and(b7,e))
    n,bin, patches=hist(f[q],bin7)
    subplot(2,2,4)
    q=find(logical_and(b9,e))
    n,bin, patches=hist(f[q],bin9)
    figtext(0.3, 0.95, ' Class 4 lock failures', size='large')
    savefig('class4_lock_errors.png', format='png')

    # class 5 errors
    e=e5
    figure(6)
    clf()
    subplot(2,2,1)
    q=find(logical_and(b3,e))
    n,bin, patches=hist(f[q],bin3)
    subplot(2,2,2)
    q=find(logical_and(b6,e))
    n,bin, patches=hist(f[q],bin6)
    subplot(2,2,3)
    q=find(logical_and(b7,e))
    n,bin, patches=hist(f[q],bin7)
    subplot(2,2,4)
    q=find(logical_and(b9,e))
    n,bin, patches=hist(f[q],bin9)
    figtext(0.3, 0.95, ' Class 5 lock failures', size='large')
    savefig('class5_lock_errors.png', format='png')

    # class 6 errors
    e=e9
    figure(7)
    clf()
    subplot(2,2,1)
    q=find(logical_and(b3,e))
    n,bin, patches=hist(f[q],bin3)
    subplot(2,2,2)
    q=find(logical_and(b6,e))
    n,bin, patches=hist(f[q],bin6)
    subplot(2,2,3)
    q=find(logical_and(b7,e))
    n,bin, patches=hist(f[q],bin7)
    subplot(2,2,4)
    q=find(logical_and(b9,e))
    n,bin, patches=hist(f[q],bin9)
    figtext(0.3, 0.95, ' Class 6,7,9 lock failures', size='large')
    savefig('class6_lock_errors.png', format='png')

    
   
