#! /usr/bin/env python
"""
A  script that calls BaselineReducer.py 

$Id: ReduceBaselineData.py,v 1.1 2015/06/21 22:44:26 ahales Exp $

"""
import os
import sys
from pylab import *
from optparse import OptionParser


import getpass
import pickle
import glob
username = getpass.getuser()
sys.path.append('/users/%s/AIV/science/scripts/R10.4_WORKING/'%username)
sys.path.append('/users/%s/AIV/science/analysis_scripts//'%username)


if __name__ == '__main__':
    usage = '''
    ReduceBaselinData.py --help

    cd ~
    mkdir baseline_analysis
    cd baseline_analysis_analysis

    ReduceBaselineData.py -f uid___A002_X59c7d4_X50f


    This script works on red-osf

    Developed by A. Hales
    '''
    
    #options ....
    parser = OptionParser(usage=usage)
    

    parser.add_option("-f", "--filename",
                      dest="asdm",
                      type= 'string',
                      help="ASDM filename containing the baseline data we want to analyze.Can be command separated list of ASDM. If none is provided, this script will read the filenames from the uncommented lines of ~/AIV/science//PadData/baselineData_sofar.txt. This is much easier for batch processing of many ASDM")

    parser.add_option("-a", "--aca",
                      dest="arrayTypw",
                      type= 'string',
                      help="In case the array includes only CM and PM antennas use this option to take care of the lack of WVRs in the CM antenna")

    (options, args) = parser.parse_args()

    #os.system('rm -f Log.txt')
    #lw = LogWriter('Log.txt')


    print options.asdm
    os.system('runScript.py')
    f = open('runScript.py', 'w')
    f.write('import sys \n')
    line='sys.path.append(\'/users/%s/AIV/science/analysis_scripts/\') \n'%username
    f.write(line)
    f.write('import BaselineReducer as BR  \n')
    f.write('blr = BR.BaselineDataReducer()\n')
    cmd1 = 'blr.runOnce(asdm =\'%s\')  \n'%(options.asdm)
    f.write(cmd1)
    f.close()


    print "Now run: \n"
    print 'casapy-telcal -c runScript.py --nologger'
    print "You can re-run the redcurion including the bad scans by running again \n"
    print 'casapy-telcal -c runScript.py --nologger'
