####
#### Globals
####


### Things to work on: clean this.  fix up the ampCal routine to make it a bit more inuitive
### look at the reason the scan lenght seems to change.  put in the auto pick up of the elevation
### from denis routines.  figure out Tcal, Ta* and Tsys to make sure I understand them well.
### better temperature models including the limb darkening, etc.
### set up two load stuff for band3.  Make an option for ampCal to allow a specific angle for sky dip.
### figure out the bias integration.  Use the observatory tag and scan/subscan stuff in
### MS instead of user input.  

# import sys ; sys.path.append('/users/scorder/bin')

#biasCounts   = [{'slope' : 1.755,'intercept':-0.128},{'slope' : 1.525,'intercept':-0.127}] # backend values PM03, pre-IFP swap
#biasCounts   = [{'slope' : 1,'intercept':0},{'slope' : 1,'intercept':0}]  # no conversion
#biasCounts   = [{'slope' : 1,'intercept': -0.068},{'slope' : 1,'intercept': -0.081}]  # measured values
#biasCounts =    [{'slope' : 1.69,'intercept': -0.101},{'slope' : 1.54,'intercept': -0.116}] # PM03 post-IFP swap (serial numbers 118 and 119), these are channel A
#biasCounts =    [{'slope' : 1.52,'intercept': -0.0935},{'slope' : 1.625,'intercept': -0.164}] # DV02 post-IFP swap (serial numbers 106 and 122), these are channel A
#biasCounts =    [{'slope' : 1.64,'intercept': -0.096},{'slope' : 1.59,'intercept': -0.0964}] # DV01 post-IFP swap (serial numbers 109 and 120), these are channel A
#biasCounts =    [{'slope' : 1,'intercept': -0.0562},{'slope' : 1,'intercept': -0.0548}] # DV01 post-IFP swap measured with max atten on blank sky, can still see variation on the loads! (serial numbers 109 and 120), these are channel A

#biasCounts =    [{'slope' : 1.660,'intercept': -0.122},{'slope' : 1.560,'intercept': -0.123}] # DV03, 123 and 131 serial numbers
#biasCounts =    [{'slope' : 1,'intercept': -0.081},{'slope' : 1.0,'intercept': -0.084}] # DV03, 123 and 131 serial numbers
biasCounts =    [{'slope' : 1,'intercept': -0.086},{'slope' : 1.0,'intercept': -0.086}] # DV03, 123 and 131 serial numbers

normalization = 2.5/(2.0**16.0-1)
numBaseBands = 1
h            = 6.6260755e-27
k            = 1.3806580e-16
c            = 2.99792458e10
jy2cgs       = 1e-23
Tcmb         = 2.725
#dipScans   = [1,7]
#atmScans   = [2,4]
#tarScans   = [3]
#dipSteps   = 10

planetTemperatures = {'mars'    : {3 : 213.3, 6 : 223.6, 7 : 227.9},
                      'jupiter' : {3 : 179,   6 : 188,   7 : 192  },
                      'venus'   : {3 : 365,   6 : 298,   7 : 274  },
                      'saturn'  : {3 : 149,   6 : 150,   7 : 151  },
                     }

import fileIOPython as fiop
reload(fiop)
import ephem
#import shortCuts as sC
import math as m
from numpy import *
from scipy import *
from pylab import *
#import reduc_beammap as rb
from taskinit import *
from importasdm import importasdm
#import casa
import analysisUtils as aU
import os
import copy
import sys
import time



def getAsdmList() :
    os.system("rm -rf junk")
    os.system("ls -d uid___* > junk")
    table = fiop.fileToTable("junk")
    asdmList = []
    for i in table :
        if "ms" in i[0] : continue
        else : asdmList.append(i[0])
    return asdmList

def getMsList() :
    os.system("rm -rf junk")
    os.system("ls -d uid___* > junk")
    table = fiop.fileToTable("junk")
    msList = []
    for i in table :
        if ".ms" == i[0][-3:] : msList.append(i[0]) 
        else : continue
    return msList

def importAsdmList(asdmList=None,makeClean=False) :
    if asdmList <> None :  asdmList = aU.makeList(asdmList)
    else : asdmList = getAsdmList()
    for i in asdmList :
        msFile = i.replace('/','')+'.ms'
        if makeClean : os.system("rm -rf %s*" % msFile)
        importasdm(asdm=i,vis=msFile)

def moveBadData(msList,badData) :
    for i in badData :
        os.system('mv %s* badData/.' % i[:-3])
        msList.remove(i)
    return msList

def processSkyDipList(msList,scanSelect,antennaName,outFile=None,useHotLoad=True,hotOrGain='Gain',loadFile=None,location="OSF",errorHot=0,quiet=False) :
    if outFile == None : outFile = ("%s_skyDipValues.txt" % (antennaName))
    scanSelect = aU.makeList(scanSelect)
    msList = aU.makeList(msList)    
    fd = open(outFile,'w')
    fd.write("MsFile\t\t\t Scan\t Pol\t Baseband\t etaF\t Tau\t Gains\t\t dGains\t\t Trx\t dTrx\t y\t dy\t delThot\t\n")
    badData = []
    for i in msList :
        for ii in scanSelect : 
            print i,ii
            [etaF,tau,Gains,dGains,Trx,dTrx,Tsky,dTsky,y,dy,skyData,hotData,ambData,elev_time_start,elev_time_end,elev_,airmass,delThot] = \
                processSkyDip(i,ii,antennaName,useHotLoad=useHotLoad,hotOrGain=hotOrGain,loadFile=loadFile,location=location,errorHot=errorHot,quiet=quiet)
            for j in range(len(etaF)) :
                for k in range(len(etaF[0])) :
                    fd.write("%s\t %i\t %i\t %i\t\t %5.3f\t %5.4f\t %5.6f\t %7.6f\t %6.2f\t %6.2f\t %6.4f\t %6.4f\t %6.3f\t\n" % (i,ii,j,k,etaF[j,k],tau[j,k],Gains[:,j,k].mean(),Gains[:,j,k].std(),Trx[:,j,k].mean(),Trx[:,j,k].std(),y[:,j,k].mean(),y[:,j,k].std(),delThot[:,j,k].mean()) )
            if not quiet :
                print 'Was this good data?  If no, enter n, otherwise, hit enter.'
                checkString = sys.stdin.readline()
                if checkString.lower()[0] == 'n' : badData.append(i)
        fd.write("\n")
    fd.close()
    return badData

def processSkyDip(msFile,scanSelect,antennaName,useHotLoad=True,hotOrGain='Gain',loadFile=None,location="OSF",errorHot=0,quiet=False) :
    if loadFile == None : loadFile = '/users/scorder/ampCal/%s/calLoadAndWeather.txt' % antennaName
    antId = getAntennaIndex(msFile,antennaName)
    freq  = getRefFrequency(msFile)
    [scanStart_,scanEnd_] = scanStartEndTime(msFile,scanSelect,antennaName)
    unique_elev = getUniqueElevations(msFile,maskStart=scanStart_,maskEnd=scanEnd_)
    [calMjd,calTime,calAmb,calHot,toutAll,humAll,patmAll] = getWeatherAndCalData(scanStart_,scanEnd_,antennaName,loadFile,errorHot)
    tatm = getTatm(toutAll,patmAll,humAll,location)
    sizer = (len(unique_elev),2,numBaseBands)
    Gains = zeros(sizer) ; dGains = zeros(sizer) ; Trx = zeros(sizer) ; dTrx = zeros(sizer)
    Tsky  = zeros(sizer) ; dTsky  = zeros(sizer) ; y   = zeros(sizer) ; dy   = zeros(sizer)
    delThot = zeros(sizer)
    elevFit = zeros(len(unique_elev)) ; airmass = zeros(len(unique_elev))
    etaF = zeros((2,numBaseBands)) ; tau = zeros((2,numBaseBands))
    for i in range(len(unique_elev)) :
        elev_ = unique_elev[i]
        elev_ = aU.makeList(elev_)
        elevFit[i] = average(elev_)
        airmass[i] = 1.0/(m.sin(elevFit[i])+0.50572*(96.07995-(90-elevFit[i]*180.0/3.14159))**-1.6364)
        [elev_time_start,elev_time_end] =  \
            elevationStartEndTime(msFile,antennaName,elevation=elev_,maskStart=scanStart_,maskEnd=scanEnd_)
        for j in range(2) : # polarization
            for k in range(numBaseBands) :  # base band number
                [skyData,skyErr,hotData,hotErr,ambData,ambErr]   = partitionAtmScan(msFile,antennaName,elev_time_start,elev_time_end,j,k,quiet=quiet)
                [Gains[i,j,k],dGains[i,j,k],Trx[i,j,k],dTrx[i,j,k],Tsky[i,j,k],dTsky[i,j,k],y[i,j,k],dy[i,j,k]] = \
                    processAtmData(skyData,skyErr,hotData,hotErr,ambData,ambErr,calAmb,calHot,tatm,freq)
                delThot[i,j,k] = calAmb+(hotData-ambData)/Gains[0,j,k]
    clf() ; color1= ['b.','r.'] ; color2= ['b-','r-']

    for j in range(2) :
        for k in range(numBaseBands) :
            tout_ = jVal(freq,toutAll) ; tatm_= jVal(freq,tatm) ; tCMB_ = jVal(freq,Tcmb)
            tout_=tout_*1.0
            ax = airmass[:]
            ay=Tsky[:,j,k]
            p0=[0.95,0.05]
            fitfunc = lambda p,x : (1-p[0])*tout_+p[0]*(1.0-exp(-p[1]*x))*tatm_+p[0]*tCMB_*exp(-p[1]*x)
            errfunc = lambda p,x,y: fitfunc(p,x)-y
            p1,success = optimize.leastsq(errfunc,copy.copy(p0),args=(ax,ay))
            etaF[j,k] = p1[0] ; tau[j,k] = p1[1]
#            p0=1.00
#            etaF_ = 0.98
#            fitfunc = lambda p,x : (1-etaF_)*tout_+etaF_*(1.0-exp(-p*x))*tatm_+etaF_*tCMB_*exp(-p*x)
#            errfunc = lambda p,x,y: fitfunc(p,x)-y
#            p1,success = optimize.leastsq(errfunc,copy.copy(p0),args=(ax,ay))
#            etaF[j,k] = etaF_ ; tau[j,k] = p1
#            etaF[j,k] = p1[0] ; tau[j,k] = p1[1]
            xx = arange(0.0,5.5,0.1)
            yy = fitfunc(p1,xx)
            plot(airmass,Tsky[:,j,k],color1[j])
            xlim(0.,5.0)
            ion()
            plot(xx,yy,color2[j])
            title('Tsky vs Airmass') ; xlabel('Airmass') ; ylabel('Tsky') #; show()
            print "Polarization %i Baseband %i : etaF = %6.3f tau = %6.3f" % (j,k,etaF[j,k],tau[j,k])
    if not quiet : show()
    return [etaF,tau,Gains,dGains,Trx,dTrx,Tsky,dTsky,y,dy,skyData,hotData,ambData,elev_time_start,elev_time_end,elev_,airmass,delThot]

def plotTrxVsAirmass(vis,antenna,scan,spec,errorHot=0,band=3) :
    [etaF,tau,gains,dgains,trx,dtrx,tsy,dtsky,y,dy,skydata,hotdata,ambdata,elev_start,elev_end,elev,airmass,delThot] = processSkyDip(vis,scan,antenna,loadFile='../ampCalLog.txt',errorHot=errorHot)
    clf()
    plot(airmass,transpose(trx[:,0])[0],'b.')
    plot(airmass,transpose(trx[:,1])[0],'r.')
    plot(array([1,5.25]),array([spec,spec]),'g-')
#    xlim(0,5.0)
    ylim(trx.min()*0.8,spec*1.05)
    xlabel('Airmass')
    ylabel('T$_{rx}$ (K)')
    title('Antenna: %s Band: %i' % (antenna,band))

def plotThotVsAirmass(vis,antenna,scan,spec,errorHot=0,band=3,envelope=10) :
    [etaF,tau,gains,dgains,trx,dtrx,tsy,dtsky,y,dy,skydata,hotdata,ambdata,elev_start,elev_end,elev,airmass,delThot] = processSkyDip(vis,scan,antenna,loadFile='../ampCalLog.txt',errorHot=errorHot)
    clf()
    plot(airmass,transpose(delThot[:,0])[0],'b.')
    plot(airmass,transpose(delThot[:,1])[0],'r.')
    plot(array([1,5.25]),array([spec,spec]),'g-')
#    xlim(0,5.0)
    ylim(spec-envelope,spec+envelope)
    xlabel('Airmass')
    ylabel('T$_{hot}$ (K)')
    title('Antenna %s Band %i' % (antenna,band))

def doManyVis(visList,antenna,scans,spec,errorHot=0,band=3) :
    for vis in visList :
        for scan in scans :
            [etaF,tau,gains,dgains,trx,dtrx,tsy,dtsky,y,dy,skydata,hotdata,ambdata,elev_start,elev_end,elev,airmass,delThot] = processSkyDip(vis,scan,antenna,loadFile='../ampCalLog.txt',errorHot=errorHot,fourSubScans=False)
            clf()
            plot(airmass,transpose(trx[:,0])[0],'b.')
            plot(airmass,transpose(trx[:,1])[0],'r.')
            plot(array([1,5.25]),array([spec,spec]),'g-')
#            xlim(0,5.0)
            ylim(25,50)
            xlabel('Airmass')
            ylabel('T$_{rx}$ (K)')
            title('Antenna %s Band %i' % (antenna,band))
            print trx[:,0].mean(),trx[:,0].std(),trx[:,1].mean(),trx[:,1].std()
            print trx
            sys.stdin.readline()

def plotGainsVsAirmass(vis,antenna,scan,errorHot=0,band=3) :
    [etaF,tau,gains,dgains,trx,dtrx,tsy,dtsky,y,dy,skydata,hotdata,ambdata,elev_start,elev_end,elev,airmass,delThot] = processSkyDip(vis,scan,antenna,loadFile='../ampCalLog.txt',errorHot=errorHot)
    print gains
    clf()
    plot(airmass,transpose(gains[:,0])[0],'b.')
    plot(airmass,transpose(gains[:,1])[0],'r.')
#    xlim(0,5.0)
#    ylim(25,50)
    xlabel('Airmass')
    ylabel('Gain')
    title('%s %i' % (antenna,band))

def processBiasScanList(msList,scanSelect,antennaName,loadFile=None,percentVar=0.3,doCorrection=False,outFile=None) :
    if outFile == None : outFile = ("%s_biasValues.txt" % (antennaName))
    msList = aU.makeList(msList)
    fd = open(outFile,'w')
    rData = []
    for i in msList :
        junk,date = processBiasScan(i,scanSelect,antennaName,loadFile,percentVar,doCorrection)
        rData.append(junk)
        fd.write("%s %s %f %f\n" % (i,date/(24.0*60*60),junk[0],junk[1]))
    fd.close()
    return rData

def processBiasScan(msFile,scanSelect,antennaName,loadFile=None,percentVar=0.3,doCorrection=False) :
    errorHot = 0.0
    tau = 0.05
    etaF = 1.0
    location = 'OSF'
    useHotLoad = True
    if loadFile == None : loadFile = '/users/scorder/ampCal/%s/calLoadAndWeather.txt' % antennaName
    antId = getAntennaIndex(msFile,antennaName)
    [scanStart_,scanEnd_] = scanStartEndTime(msFile,scanSelect,antennaName)
    elev_ = getElevation(msFile,maskStart=scanStart_,maskEnd=scanEnd_)
    [calMjd,calTime,calAmb,calHot,toutAll,humAll,patmAll] = getWeatherAndCalData(scanStart_,scanEnd_,antennaName,loadFile,errorHot)
    tatm = getTatm(toutAll,patmAll,humAll,location)
    airmass = 1.0/(m.sin(elev_)+0.50572*(96.07995-(90-elev_)*180.0/3.14159)**-1.6364)
    opacity = exp(airmass*tau)
    if useHotLoad :
       sizer = (2,numBaseBands)
       Gains = zeros(sizer) ; dGains = zeros(sizer) ; Trx = zeros(sizer) ; dTrx = zeros(sizer)
       Tsky  = zeros(sizer) ; dTsky  = zeros(sizer) ; y   = zeros(sizer) ; dy   = zeros(sizer)
       Tsys  = zeros(sizer) ; dTsys  = zeros(sizer) ; alpha = zeros(sizer) 
       Pload = zeros(sizer) ; Tcal   = zeros(sizer) ; Psky = zeros(sizer)
       Pamb  = zeros(sizer) ; Phot   = zeros(sizer) ; Rdata = zeros(sizer)
       for j in range(2) : # polarization
           for k in range(numBaseBands) :  # base band number
               [skyData,skyErr,hotData,hotErr,ambData,ambErr,refData,refErr]   = partitionAtmScan(msFile,antennaName,scanStart_,scanEnd_,j,k,percentVar=percentVar,doCorrection=doCorrection,fourSubScans=True)
               freq  = getRefFrequency(msFile)
               tatm_ = jVal(freq,tatm) ; toutAll_ = jVal(freq,toutAll) ; tCMB_ = jVal(freq,Tcmb)
               calHot_ = jVal(freq,calHot) ; calAmb_ = jVal(freq,calAmb)
               alpha[j,k]  = solveAlpha(calHot_,calAmb_,tatm_,toutAll_,etaF,freq)
               [Gains[j,k],dGains[j,k],Trx[j,k],dTrx[j,k],Tsky[j,k],dTsky[j,k],y[j,k],dy[j,k]] = \
                   processAtmData(skyData,skyErr,hotData,hotErr,ambData,ambErr,calAmb,calHot,tatm,freq)
               Pload[j,k] = alpha[j,k]*hotData+(1-alpha[j,k])*ambData
               Tcal[j,k]  = (tatm_-tCMB_)
               Tsys[j,k]  = Tcal[j,k]*skyData/(Pload[j,k]-skyData)
               Psky[j,k]  = skyData ; Pamb[j,k]  = ambData ; Phot[j,k]  = hotData ; Rdata[j,k] = refData
    return Rdata,scanStart_

def processAtmScanList(msList,scanSelect,antennaName,useHotLoad=True,loadFile=None,location='OSF',errorHot=0,skyDipFile=None,quiet=False,outFile=None) :
    if outFile == None : outFile = ("%s_AtmValues.txt" % (antennaName))
    if skyDipFile == None : skyDipFile = ("%s_skyDipValues.txt" % (antennaName))
    skydipTable = fiop.fileToTable(skyDipFile,ignoreEmpty=True,keepType=True)
    scanSelect = aU.makeList(scanSelect)
    msList = aU.makeList(msList)    
    fd = open(outFile,'w')
    fd.write("MsFile\t\t\t Scan\t Pol\t Baseband\t Tcal\t\t Tsys\t Gains\t\t dGains\t\t Trx\t dTrx\t Tsky\t dTsky\t Psky\t y\t dy\t alpha\n")
    badData = []
    for i in msList :
        tau  = []
        etaF = []
        subTable = fiop.getRestrictTable(skydipTable,0,i)
        for j in range(len(subTable[0])) :
            etaF.append(subTable[0][j][4])
            tau.append(subTable[0][j][5])
        tau = sum(tau)/len(tau)
        etaF = sum(etaF)/len(etaF)
        for ii in scanSelect : 
            print i,ii
            [Tcal,Tsys,Gains,dGains,Trx,dTrx,Tsky,dTsky,y,dy,alpha,Psky,Pload,Pamb,Phot] = processAtmScan(i,ii,antennaName,tau,etaF,useHotLoad=useHotLoad,loadFile=loadFile,location=location,errorHot=errorHot,quiet=quiet)
            for j in range(len(Tcal)) :
                for k in range(len(Tcal[0])) :
                    fd.write("%s\t %i\t %i\t %i\t\t %6.3f\t %6.3f\t %5.6f\t %7.6f\t %6.2f\t %6.2f\t %6.2f\t %6.2f\t %10f\t %6.3f\t %6.3f\t %6.3f\t\n" % (i,ii,j,k,Tcal[j,k],Tsys[j,k],Gains[j,k],dGains[j,k],Trx[j,k],dTrx[j,k],Tsky[j,k],dTsky[j,k],Psky[j,k],y[j,k],dy[j,k],alpha[j,k]) )
            if not quiet :
                print 'Was this good data?  If no, enter n, otherwise, hit enter.'
                checkString = sys.stdin.readline()
                if checkString.lower()[0] == 'n' : badData.append(i)
        fd.write("\n")
    fd.close()
    return badData



def processAtmScan(msFile,scanSelect,antennaName,tau,etaF=0.98,useHotLoad=True,loadFile=None,location='OSF',errorHot=0,quiet=False) :
## Need to make it multiple frequency support...later later.
    if loadFile == None : loadFile = '/users/scorder/ampCal/%s/calLoadAndWeather.txt' % antennaName
    antId = getAntennaIndex(msFile,antennaName)
    [scanStart_,scanEnd_] = scanStartEndTime(msFile,scanSelect,antennaName)
    elev_ = getElevation(msFile,maskStart=scanStart_,maskEnd=scanEnd_)
    [calMjd,calTime,calAmb,calHot,toutAll,humAll,patmAll] = getWeatherAndCalData(scanStart_,scanEnd_,antennaName,loadFile,errorHot)
    tatm = getTatm(toutAll,patmAll,humAll,location)
    airmass = 1.0/(m.sin(elev_)+0.50572*(96.07995-(90-elev_)*180.0/3.14159)**-1.6364)
    opacity = exp(airmass*tau)
    if useHotLoad :
       sizer = (2,numBaseBands)
       Gains = zeros(sizer) ; dGains = zeros(sizer) ; Trx = zeros(sizer) ; dTrx = zeros(sizer)
       Tsky  = zeros(sizer) ; dTsky  = zeros(sizer) ; y   = zeros(sizer) ; dy   = zeros(sizer)
       Tsys  = zeros(sizer) ; dTsys  = zeros(sizer) ; alpha = zeros(sizer) 
       Pload = zeros(sizer) ; Tcal   = zeros(sizer) ; Psky = zeros(sizer)
       Pamb  = zeros(sizer) ; Phot   = zeros(sizer)
       for j in range(2) : # polarization
           for k in range(numBaseBands) :  # base band number
               [skyData,skyErr,hotData,hotErr,ambData,ambErr,refData,refErr]   = partitionAtmScan(msFile,antennaName,scanStart_,scanEnd_,j,k,fourSubScans=True,quiet=quiet)
               freq  = getRefFrequency(msFile)
               tatm_ = jVal(freq,tatm) ; toutAll_ = jVal(freq,toutAll) ; tCMB_ = jVal(freq,Tcmb)
               calHot_ = jVal(freq,calHot) ; calAmb_ = jVal(freq,calAmb)
               alpha[j,k]  = solveAlpha(calHot_,calAmb_,tatm_,toutAll_,etaF,freq)
               [Gains[j,k],dGains[j,k],Trx[j,k],dTrx[j,k],Tsky[j,k],dTsky[j,k],y[j,k],dy[j,k]] = \
                   processAtmData(skyData,skyErr,hotData,hotErr,ambData,ambErr,calAmb,calHot,tatm,freq)
               Pload[j,k] = alpha[j,k]*hotData+(1-alpha[j,k])*ambData
               Tcal[j,k]  = (tatm_-tCMB_)
               Tsys[j,k]  = Tcal[j,k]*skyData/(Pload[j,k]-skyData)
               Psky[j,k]  = skyData ; Pamb[j,k]  = ambData ; Phot[j,k]  = hotData
    return [Tcal,Tsys,Gains,dGains,Trx,dTrx,Tsky,dTsky,y,dy,alpha,Psky,Pload,Pamb,Phot]

def getBeamMapPeakAndElev(msList,scanSelect,antennaName,outFile=None) :
    if outFile == None : outFile = "%s_beamMapInfo.txt" % antennaName
    msList = aU.makeList(msList)
    fd = open(outFile,'w')
    fd.write("MSFile\t\t Pol\t Source\t Temp\t Elevation\t Peak\n")
    for i in msList :
        freq       = getRefFrequency(i)
        if freq < 200 : band = 3
        elif freq < 300 : band = 6
        else : band = 7 
        elev = getMeanElevation(i,scanSelect,antennaName)
        beamMapPeak,date = getBeamMapPeak(i,scanSelect,antennaName)
        source      = getTarget(i)
        exec 'j=ephem.%s()' % source
        j.compute(date)
        size = j.size
        sourceTemp  = planetTemperatures[source.lower()][band]
        for ii in range(len(beamMapPeak)) : fd.write("%s\t %i\t %s\t %5.2f\t %5.2f\t %7.3f %6.3f\n" % (i,ii,source,sourceTemp,elev,beamMapPeak[ii],size) )
    fd.close()

def calcSeveralEfficiences(msList,antennaName,outFile=None,sourceLarge=False,skyDipFile=None,atmFile=None,beamMapFile=None,beamSize=None) :
    if skyDipFile == None  : skyDipFile = "%s_skyDipValues.txt" % antennaName
    if atmFile == None     : atmFile = "%s_AtmValues.txt" % antennaName
    if beamMapFile == None : beamMapFile = "%s_beamMapInfo.txt" % antennaName
    if outFile == None : outFile = "%s_efficiencies.txt" % antennaName
    fd = open(outFile,'a')
    fd.write("MsFile\t\t\t Pol\t Elev\t Psky\t Psource\t Trx\t Tsky\t Tau\t EtaF\t EtaA\t jyPerK\t beamSize\n ")
    for i in msList :
        if beamSize == None : 
            freq       = getRefFrequency(i)
            wavelength = c/(freq*1e9)
            beamSize = 1.15*(wavelength/12.0e2)*206265
        for j in [0,1] :
            beam  = fiop.fileToTable(beamMapFile)
            atm   = fiop.fileToTable(atmFile)
            sky   = fiop.fileToTable(skyDipFile)
            beam_ = fiop.getRestrictTable(beam,0,i)[0]
            atm_  = fiop.getRestrictTable(atm,0,i)[0]
            sky_  = fiop.getRestrictTable(sky,0,i)[0]
            atm_  = fiop.changeTableToFloat(fiop.getInvertTable(fiop.getRestrictTable(atm_,2,str(j))[0]))
            sky_  = fiop.changeTableToFloat(fiop.getInvertTable(fiop.getRestrictTable(sky_,2,str(j))[0]))
            #beam_ = fiop.changeTableToFloat(fiop.getInvertTable(fiop.getRestrictTable(beam_,1,str(j))[0]))
            elev  = float(beam_[j][4])
            Tsource = float(beam_[j][3])
            Psource = float(beam_[j][5])
            sourceSize = float(beam_[j][6])
            sourceName = beam_[j][2]
            Psky = sum(atm_[12])/len(atm_[12])
            Trx  = sum(atm_[8])/len(atm_[8])
            Tsky = sum(atm_[10])/len(atm_[10])
            tau  = sum(sky_[5])/len(sky_[5])
            etaF = sum(sky_[4])/len(sky_[4])
#            if etaF > 1 : etaF = 1.0
            [etaA,jyPerK] = calcEfficiencies(i,elev,Psky,Psource,Trx,Tsky,tau,Tsource,j,sourceSize=sourceSize,sourceLarge=sourceLarge,etaF=etaF,beamSize=beamSize)
            print i,j,elev,Psky,Psource,Trx,Tsky,tau,etaF,etaA,jyPerK,Tsource
            fd.write("%s\t %i\t %f\t %f\t %f\t %f\t %f\t %f\t %f\t %f\t %f\t %f\t%s\n " % (i,int(j),elev,Psky,Psource,Trx,Tsky,tau,etaF,etaA,jyPerK,beamSize,sourceName) )
            
def calcEfficiencies(msFile,elev,Psky,Psource,Trx,Tsky,tau,Tsource,polarization=0,sourceSize=0,sourceLarge=False,etaF=0.99,beamSize=None,diameter=12.0e2) :
    freq       = getRefFrequency(msFile)
    wavelength = c/(freq*1e9)
    if beamSize == None : beamSize = 1.15*(wavelength/diameter)*206265
    print beamSize
    Tcmb_      = jVal(freq,Tcmb)
    Tsource_   = jVal(freq,Tsource)
    Tuse_      = correctPlanet(sourceSize,Tsource_,beamSize)
    airmass    = 1.0/(m.sin(elev*3.14159/180.0)+0.50572*(96.07995-(90-elev))**-1.6364)
    if not sourceLarge :
        print polarization
        Psource_ = normalization*Psource*biasCounts[polarization]['slope']+biasCounts[polarization]['intercept']
        etaA = ((((Psource_)/Psky)-1)*(Trx+Tsky)*m.exp(airmass*tau))/Tuse_
        jyPerK = 8*k/(etaA*math.pi*diameter**2.0)/jy2cgs
        return [etaA,jyPerK]
    else :
        Psource_ = normalization*Psource*biasCounts[polarization]['slope']+biasCounts[polarization]['intercept']
        etaB = (((Psource_/Psky)-1)*(Trx+Tsky)*m.exp(airmass*tau)+etaF*Tcmb_)/Tuse_
        return [etaB,None]

def correctPlanet(sourceSize,Tsource,fwhmBeam) :
    return Tsource*(1-m.exp(-m.log(2)*sourceSize**2.0/fwhmBeam**2.0))

def antennaTemperature(Tsys,Psky,Psource) :
    return (Psource-Psky)*Tsys/Psky

def solveAlpha(tHot,tAmb,tAtm,tOut,etaF,freq) : 
# Passed in RJ corrected values at this point
    alpha = (etaF*tAtm-tAmb+(1-etaF)*tOut)/(tHot-tAmb)
    return alpha


def getTarget(msFile) :
    tb.open("%s/SOURCE" % msFile)
    sourceName = tb.getcol('NAME')
    tb.close()
    sourceName = list(sourceName)
    while 'Unknown' in sourceName : sourceName.remove('Unknown')
    return sourceName[0]

def getBeamMapPeak(msFile,scanNumber,antennaName) :
    antId = getAntennaIndex(msFile,antennaName)
    tb.open(msFile)
    times = tb.getcol('TIME')
    tb.close()
    date = qa.time(str(times[len(times)/2])+'s',form='fits')
    date = date.replace('-','/').replace('T',' ')
    mymstb = tbtool.create()
    mymstb.open(msFile,nomodify=False)
    tb_query = ("SCAN_NUMBER==%s && ANTENNA1=%s && ANTENNA2=%s" % (str(scanNumber),str(antId),str(antId)))
    tb_ = mymstb.query(tb_query)
    data_ = tb_.getcol('FLOAT_DATA')
#    data_ = tb_.getcol('DATA')
    mymstb.close()
    data_max = zeros((len(data_)))
    for i in range(len(data_)) :
        data_max[i] = real(data_[i]).max()
    return data_max,date

def removeBadData(msList,removeList) :
    msList = aU.makeList(msList)
    removeList = aU.makeList(removeList)
    for i in removeList :
        try: msList.remove(i)
        except: continue
    return msList

def processAtmData(pSky,eSky,pHot,eHot,pAmb,eAmb,tAmb,tHot,tAtm,freq,teHot=0.5,teAmb=0.3,useHotLoad=True,fixGain=False) :
    tHot_ = jVal(freq,tHot) ; tAmb_ = jVal(freq,tAmb) ; tCMB_ = jVal(freq,Tcmb) ; tAtm_ = jVal(freq,tAtm)
    teHot_ = djVal(freq,tHot,teHot) ; teAmb_ = djVal(freq,tAmb,teAmb)
    if useHotLoad :
       Gain  = (pHot-pAmb)/(tHot_-tAmb_)  #### Real def by FE is not corrected
       dGain = (((eHot**2.0+eAmb**2.0)/(tHot_-tAmb_)**2.0)+((pHot-pAmb)**2.0/(tHot_-tAmb_)**4.0)*(teHot_**2.0+teAmb_**2.0))**0.5
       Trx_  = (pHot/Gain)-tHot_  #### Real def by FE is not correctde
       dTrx_ = (eHot**2.0/Gain**2.0+teHot_**2.0+pHot**2.0*dGain**2.0/Gain**4.0)**0.5
       Tsky_ = tAmb_-(pAmb-pSky)/Gain
       dTsky_= (teAmb_**2.0+(eAmb**2.0+eSky**2.0)/Gain**2.0+(pAmb-pSky)**2.0*dGain**2.0/Gain**4.0)**0.5
       y     = pHot/pAmb
       dy    = ((eHot/pAmb)**2.0+(pHot*eAmb/pAmb**2.0)**2.0)**0.5
    return [Gain,dGain,Trx_,dTrx_,Tsky_,dTsky_,y,dy]

def partitionAtmScan(msFile,antennaName,startTime,endTime,polarization=0,baseBand=0,percentVar=8.0,doCorrection=True,fourSubScans=False,fourScanLimit=10.,quiet=False) :
    antId = getAntennaIndex(msFile,antennaName)
    mymstb = tbtool.create()
    mymstb.open(msFile,nomodify=False)
    tb_query = ("TIME >= %s && TIME <= %s && ANTENNA1==%s && ANTENNA2==%s" % 
               (str(startTime),str(endTime),str(antId),str(antId)) )
    tb_ = mymstb.query(tb_query)
    mymstb.close()
#    data_ = real(tb_.getcol('DATA')[polarization][baseBand][:])
    data_ = real(tb_.getcol('FLOAT_DATA')[polarization][baseBand][:])
    time_ = tb_.getcol('TIME')
    data_min = min(data_)
    data_max = max(data_)
    if fourScanLimit :
        maskRef = (data_ > data_max*fourScanLimit/100.0)
        ref_ = ma.compressed(ma.array(data_,copy=True,mask=maskRef))*normalization*biasCounts[polarization]['slope']+doCorrection*biasCounts[polarization]['intercept']
        unmaskRef = (data_ <= data_max*fourScanLimit/100.0)
        data_ = ma.compressed(ma.array(data_,copy=True,mask=unmaskRef))
        data_min = min(data_)
        data_max = max(data_)   
    skyUp    = data_min*(1.0+percentVar/100.0)
    hotDown  = data_max*(1.0-percentVar/100.0)
    maskSky  = (data_ > skyUp)
    maskHot  = (data_ < hotDown)
    maskAmb1 = (data_ > skyUp)
    maskAmb2 = (data_ < hotDown)
    maskAmb  = -(maskAmb1*maskAmb2)
    sky_     = ma.compressed(ma.array(data_,copy=True,mask=maskSky))*normalization*biasCounts[polarization]['slope']+doCorrection*biasCounts[polarization]['intercept']
    hot_     = ma.compressed(ma.array(data_,copy=True,mask=maskHot))*normalization*biasCounts[polarization]['slope']+doCorrection*biasCounts[polarization]['intercept']
    amb_     = ma.compressed(ma.array(data_,copy=True,mask=maskAmb))*normalization*biasCounts[polarization]['slope']+doCorrection*biasCounts[polarization]['intercept']
    if not quiet : 
        print average((sky_-biasCounts[polarization]['intercept'])/(normalization*biasCounts[polarization]['slope'])),len(sky_)
        print average((amb_-biasCounts[polarization]['intercept'])/(normalization*biasCounts[polarization]['slope'])),len(amb_)
        print average((hot_-biasCounts[polarization]['intercept'])/(normalization*biasCounts[polarization]['slope'])),len(hot_)
        if fourScanLimit : print average((ref_)),len(ref_)
        sys.stdin.readline()
    skyData  = average(sky_) ; skyErr = std(sky_)
    hotData =  average(hot_) ; hotErr = std(hot_)
    ambData =  average(amb_) ; ambErr = std(amb_)
    refData = average(ref_)  ; refErr = std(ref_)
    if fourSubScans : return [skyData,skyErr,hotData,hotErr,ambData,ambErr,refData,refErr]
    else : return [skyData,skyErr,hotData,hotErr,ambData,ambErr]
    
def getTatm(toutAll,patmAll,hum,location='OSF') : 
    if location == 'OSF' : alt = casac.Quantity(3000.0,'m')
    elif location == 'AOS' : alt = casac.Quantity(5000.0,'m')
    tmp = casac.Quantity(toutAll,'K')
    pre = casac.Quantity(patmAll,'mbar')
    maxA = casac.Quantity(48.0,'km')
    myatm = at.initAtmProfile(alt,tmp,pre,maxA,hum)
    tempPro = at.getProfile()['temperature']
    tatm = sum(tempPro.value)/len(tempPro.value)
    return tatm

oldICDAntennas = ['DV01','DV02','DV03','DV04','DV05','PM02','PM03']
newICDAntennas = ['DV06','DV07','DV08']
newDates = [qa.splitdate('2010-07-24T09:00:00')['mjd'],qa.splitdate('2010-09-01T00:00:00')['mjd']]

def getWeatherAndCalData(startTime,endTime,antennaName=None,loadFile='/users/scorder/ampCalLog.txt',errorHot=0) :
    calTemps   = fiop.readcolPy(loadFile,formatString='s,f,f,f,f,f,f,f,f,f,f')
    calMjd     = []
    calTime    = array(calTemps[0]) ;
    for i in calTime : calMjd.append(qa.splitdate(i)['mjd'])
    calMjd = array(calMjd)*(24*60.0*60.0)
    if antennaName == 'DV08' :
        calAmb     = (array(calTemps[6])+array(calTemps[7]))/2.0
        calHot     = ((array(calTemps[1])+array(calTemps[2]))/2.0)-errorHot ;  toutAll    = (array(calTemps[8]))
    elif (antennaName in newICDAntennas) and (calMjd[0] <  newDates[1] and calMjd[0] > newDates[0]) :
        calAmb     = (array(calTemps[6])+array(calTemps[7]))/2.0
        calHot     = ((array(calTemps[1])+array(calTemps[2]))/2.0)-errorHot ;  toutAll    = (array(calTemps[8]))        
    else :
        calAmb     = (array(calTemps[3])+array(calTemps[4]))/2.0
        calHot     = ((array(calTemps[5])+array(calTemps[6]))/2.0)-errorHot ;  toutAll    = (array(calTemps[8]))
    humAll     = (array(calTemps[9]));    patmAll    = (array(calTemps[10]))
    indies = where(calMjd > startTime)
    index_ = indies[0].min()-1
    return [calMjd[index_],calTime[index_],calAmb[index_],calHot[index_],toutAll[index_],humAll[index_],patmAll[index_]]

def scanStartEndTime(msFile,scanNum,antennaName,maskStart=None,maskEnd=None) :
    antId = getAntennaIndex(msFile,antennaName)
    tb.open(msFile)
    times = tb.getcol('TIME')
    tb.close()
    if maskStart == None : maskStart = times.min()
    if maskEnd   == None : maskEnd   = times.max()
    mymstb = tbtool.create()
    mymstb.open(msFile,nomodify=False)
    tb_query = ("SCAN_NUMBER==%s && TIME >= %s && TIME <= %s && ANTENNA1=%s && ANTENNA2=%s" % (str(scanNum),str(maskStart),str(maskEnd),str(antId),str(antId)))
    tb_ = mymstb.query(tb_query)
    time_ = tb_.getcol('TIME')
    mymstb.close()
    return [time_.min(),time_.max()]

def getMeanElevation(msFile,scanNum,antennaName) :
    [time_start,time_end] = scanStartEndTime(msFile,scanNum,antennaName)
    antId = getAntennaIndex(msFile,antennaName)
    mymstb = tbtool.create()
    mymstb.open('%s/POINTING' % msFile,nomodify=False)
    tb_query = ("TIME >= %s && TIME <= %s" % (str(time_start),str(time_end)))
    tb_ = mymstb.query(tb_query)
    direction_ = tb_.getcol('DIRECTION')
    time_      = tb_.getcol('TIME')
    mymstb.close()
    elevation_ = direction_[1][0]
    return  elevation_.mean()*180.0/3.14159
    

def elevationStartEndTime(msFile,antennaName,elevation=[0,m.pi],maskStart=None,maskEnd=None) :
    antId = getAntennaIndex(msFile,antennaName)
    if maskStart == None or maskEnd == None :
        tb.open('%s/POINTING' % msFile)
        times = tb.getcol('TIME')
        tb.close()
        if maskStart == None : maskStart = times.min()
        if maskEnd   == None : maskEnd   = times.max()
    mymstb = tbtool.create()
    mymstb.open('%s/POINTING' % msFile,nomodify=False)
    tb_query = ("TIME >= %s && TIME <= %s" % (str(maskStart),str(maskEnd)))
    tb_ = mymstb.query(tb_query)
    direction_ = tb_.getcol('DIRECTION')
    time_      = tb_.getcol('TIME')
    mymstb.close()
    elevation_ = direction_[1][0]
    if len(elevation) > 1 :
       mask1 = (elevation_ >= elevation[0])
       mask2 = (elevation_ <= elevation[1])
       mask  = mask1*mask2
    else :
       mask  = (elevation_ == elevation)
    listIndex = where(mask)
    return [time_[listIndex[0].min()],time_[listIndex[0].max()]]

def getElevation(msFile,maskStart=None,maskEnd=None) :
    if maskStart == None or maskEnd == None :
        tb.open('%s/POINTING' % msFile)
        times = tb.getcol('TIME')
        tb.close()
        if maskStart == None : maskStart = times.min()
        if maskEnd   == None : maskEnd   = times.max()
    mymstb = tbtool.create()
    mymstb.open('%s/POINTING' % msFile,nomodify=False)
    tb_query = ("TIME >= %s && TIME <= %s" % (str(maskStart),str(maskEnd)))
    tb_ = mymstb.query(tb_query)
    direction_ = tb_.getcol('DIRECTION')
    time_      = tb_.getcol('TIME')
    mymstb.close()
    elevation_ = direction_[1][0]
    return average(elevation_)

def getUniqueElevations(msFile,maskStart=None,maskEnd=None) :
    if maskStart == None or maskEnd == None :
        tb.open('%s/POINTING' % msFile)
        times = tb.getcol('TIME')
        tb.close()
        if maskStart == None : maskStart = times.min()
        if maskEnd   == None : maskEnd   = times.max()
    mymstb = tbtool.create()
    mymstb.open('%s/POINTING' % msFile,nomodify=False)
    tb_query = ("TIME >= %s && TIME <= %s" % (str(maskStart),str(maskEnd)))
    tb_ = mymstb.query(tb_query)
    direction_ = tb_.getcol('DIRECTION')
    time_      = tb_.getcol('TIME')
    mymstb.close()
    elevation_ = direction_[1][0]
    elev_unique = unique(elevation_)
    elev_unique_double = makePairwise(elev_unique)
    elev_unique_double = elev_unique
    return elev_unique_double

def getRefFrequency(msFile) :
    tb.open(msFile+'/SPECTRAL_WINDOW')
    freqs = tb.getcol('REF_FREQUENCY')
    tb.close()
    return (freqs[0]/1e9)

def assignAntennaNametoID(msFile) :
    tb.open(msFile+'/ANTENNA')
    names = tb.getcol('NAME')
    tb.close()
    return names

def getAntennaIndex(msFile,antennaName) :
    ids = assignAntennaNametoID(msFile)
    return where(ids == antennaName)[0][0]

def makePairwise(inputList) :
    nestedList = []
    for i in range(len(inputList)/2) : nestedList.append([inputList[2*i],inputList[2*i+1]])
    return nestedList

def jVal(freq,temp) :
    x = h*freq*1e9/k
    return x*(m.exp(x/temp)-1)**(-1)

def djVal(freq,temp,dtemp) :
    x = h*freq*1e9/k
    return abs(x*(m.exp(x/temp)-1)**(-2)*(x*dtemp/temp**2.0)*m.exp(x/temp))
