#! /usr/bin/env python
#

"""
autoUpdateAntennaMove.py

Goal: keep the file antennaMoves.txt automatically updated without any manual intervention
Written May 27 2013 by dB
Algorithm:
   0/ Start from an up-to-date antennaMoves.txt (in ~/AIV/science/PadData/antennaMoves.txt)
   1/ Once a day in a cronjob on aos-gns run this script autoUpdateAntennaMove.py
   2/ This script checks the latest position in antennaMoves.txt against the antenna positions in the TMCDB
   3/ If all match, nothing is done
   4/ if a difference is found, a new line is inserted with the date of that day, in antennaMoves.txt
   5/ Finally, cvs commit is done with an email sent to Eric and Denis.

$Id $
"""

import os
from optparse import OptionParser
import tmcdbPlayer as t


if __name__ == '__main__':
    usage = '''
    can only be run on aos-gns
    
    
    
    '''
    # Initialize parser
    parser = OptionParser()
    
    parser.add_option("-v", "--verbose",
                      dest="verbose",
                      action="store_true",
                      default=False,
                      help=" -v option will output the verbose logs, Default is False")
    
    (options, args) = parser.parse_args()
    verb = options.verbose
    
    t = t.tmcdbPlayer()
    t.readAntennaMovesTxt()
    #t.printPadHistory('PM03')
    newAntennaMove = t.checkNewMove(verbose = verb)
   # db turns on verbose=True on April 20th to better debug future problems. Please turn this off after 1 week.
    # newAntennaMove = t.checkNewMove(verbose = True)

    print '##############################'
    if newAntennaMove == []:
        # no need to change antennaMoves.txt
        print "No antenna moves to be updated"
        pass
    else:
        # update new antennaMoves
        print 'Antenna Pad needing change'
        for line in newAntennaMove:
            print line
        t.editAntennaMovesTxt(newAntennaMove)
    print '##############################'
    
   
