#!/usr/bin/env python
# checkACDLoads.py
#written by dbarkats

# $Id: checkACDLoads.py,v 1.1 2014/10/30 00:36:16 dbarkats Exp $

from optparse import OptionParser
import os,sys
from pylab import *
import datetime
import tmUtils as tm
from itertools import groupby
from  operator import itemgetter


def system_except(cmd):
    ret = os.system(cmd)
    if ret != 0:
        raise Exception("Command '%s' returned non-zero exit status %d" %(cmd, ret))

def getAntennaNames():
        """
        simple list of all antennas
        """
        
        antList = ['DV01', 'DV02', 'DV03', 'DV04', 'DV05', 'DV06', 'DV07', 'DV08', 'DV09', 'DV10',\
                   'DV11', 'DV12', 'DV13', 'DV14', 'DV15', 'DV16', 'DV17', 'DV18', 'DV19', 'DV20',\
                   'DV21', 'DV22', 'DV23', 'DV24', 'DV25', 'DA41', 'DA42', 'DA43', 'DA44', 'DA45',\
                   'DA46', 'DA47', 'DA48', 'DA49', 'DA50', 'DA51', 'DA52', 'DA53', 'DA54', 'DA55',\
                   'DA56', 'DA57', 'DA58', 'DA59', 'DA60', 'DA61', 'DA62', 'DA63', 'DA64', 'DA65',\
                   'PM01', 'PM02', 'PM03', 'PM04', 'CM01', 'CM02', 'CM03', 'CM04', 'CM05', 'CM06',\
                   'CM07', 'CM08', 'CM09', 'CM10', 'CM11', 'CM12']
        return antList

# Execution starts here
if __name__ == '__main__':
    usage = '''

   
    '''
    # Initialize parser
    parser = OptionParser()

    parser.add_option("-f", "--from", dest="fr",
                      help="date you want to start your check. format YYYY-MM-DDTHH:MM:SS ")

    parser.add_option("-t", "--to", dest="to",
                      help="date you want to stop your check on.format YYYY-MM-DDTHH:MM:SS ")

    (options, args) = parser.parse_args()

    now = datetime.datetime.now()
    today = ('%s'%now)[0:10]
    first =  datetime.date(day=1,  month = now.month, year = now.year)
    start='%sT00:00:00'%first
    end='%sT00:00:00'%today
    
    if options.fr is None:
        day1 = start
    else:
        day1 = options.fr 
    if options.to is None:
        day2 = end
    else:
        day2 = options.to
    print '### Checking ACD Load Temps from: %s to: %s'%(day1,day2)

    antList = getAntennaNames()
    tempList = ['TEMP01','TEMP02','TEMP11','TEMP12','TEMP20','TEMP21','TEMP22']

    for ant in antList:
        for temp in tempList:
            try:
                d = tm.get_tmc_data(ant,'FrontEnd_ACD',temp,day1,day2, removefile = True, verbose=False)
            except:
                continue
            T = array(d['value'])
            N = T.size
            if temp[4] == '2':
                q = find((T-273.15 > 100) | (T-273.15 < -1))
            else:
                q = find((T-273.15 > 37) | (T-273.15 < -1))
            cq = []
            count = 0
            for k,g in groupby(enumerate(q), lambda (i,x):i-x):
                count +=1
            print '%s, %s %d out of %d outside of range'%(ant, temp, count, N)
           
