#!/usr/bin/env python
# checkFeedAngles.py

#written by dbarkats

#$Id $

# Execution starts here
from optparse import OptionParser
import os

def system_except(cmd):
    ret = os.system(cmd)
    if ret != 0:
        raise Exception("Command '%s' returned non-zero exit status %d" %(cmd, ret))


if __name__ == '__main__':
    usage = '''
    CheckFeedAngles.py can only  be run from AOS-GNS.
    
    It parses the results fro mgetFEConfiguratons to get the S/N of each ColdCart and then checks
    the config file  for each assembly for the  value of the polarization orientation. If it is wrong,
    it will print out a statement.

    Not a lot of error checking.
    getFEConfigurations is quite slow.
    '''
    # Initialize parser
    parser = OptionParser()
    
    parser.add_option("-f", "--files", dest="uid",
                      help="uid of input ASDM to be analysed",)
    
    (options, args) = parser.parse_args()
    
    a = os.popen('configuredAntennas').read()
    b = a.split('\n')
    ants = []
    for i in range(len(b)-2):
        ants.append(b[i+1][0:4])

    print ants
    for ant in ants:
        cmd = 'getFEConfigurations -a %s' %ant
        print '\n=============='
        print cmd
        a = os.popen(cmd).read().split('\n')
        print "Done with getFEConfigurations for %s" %ant
        
        for line in a:
            if 'ColdCart' in line:
                sn = line.split(' | ')[1]
                band = line.split(' | ')[4].split('ColdCart')[1][0]
                cmd2 = 'grep "PolarizationOrientation" /alma/ste/config/TMCDB_DATA/%s.xml' %sn
                b = os.popen(cmd2).read().split('\"')
                polx = b[1]
                poly = b[3]
                
                print ant, band, polx, poly
                if band == '3' and polx != '-0.1745329252':
                    print "incorrect band 3 polx values"
                elif band == '3'and poly !='1.3962634016':
                    print "incorrect band 3 polY values"
                elif band == '6' and polx != '-2.3561944902':
                    print "incorrect band 6 polx values"
                elif band == '6'and poly !='-0.7853981634':
                    print "incorrect band 6 polY values"
                elif band == '7' and polx != '-0.9346238144':
                    print "incorrect band 7 polx values"
                elif band == '7'and poly !='0.6361725124':
                    print "incorrect band 7 polY values"
                elif band == '8' and (float(polx) != 0.0):
                    print "incorrect band 8 polx values"           
                elif band == '8'and poly !='1.5707963268':
                    print "incorrect band 8 polY values"
                elif band == '9' and polx != '-3.1415926536':
                    print "incorrect band 9 polx values"
                elif band == '9'and poly !='-1.5707963268':
                    print "incorrect band 9 polY values"
                elif band == '4' and polx != '-2.9670597284':
                    print "incorrect band 4 polx values"
                elif band == '4'and poly !='-1.3962634016':
                    print "incorrect band 4 polY values"
                    
                    
    
    
