#! /usr/bin/env python
#

#  $Id: delete_my_ms.py,v 1.1 2011/07/19 15:32:21 dbarkats Exp $

import os
import optparse
import sys
import socket

# Main
if __name__ == "__main__":
    # Validate Entries
    parser = optparse.OptionParser()

    parser.add_option("-u","--user",
                      dest="user",
                      default = '',
                      type = "str",
                      help="The name of the user for which to search the files to be deleted")

    parser.add_option("-d","--days",
                      dest="days",
                      default = 365,
                      type = "int",
                      help="The most recent data to delete. Default = 365 days.")

    (options, args) = parser.parse_args()
    days= options.days
    
    if options.user == '':
        user=os.popen('whoami').read().split('\n')[0]
        ret = raw_input(" Are you user: %s  ? (y or n)"%user)
        if ret == "n" or ret == "":
            sys.exit()
    else:
        user = options.user
        
    hostname= socket.gethostname()
    if 'gns' in hostname:
        path = '/groups/science/data/RADIO/'
    elif 'red' in hostname:
        path = '/data/RADIO/'
    else:
        print 'You must run this code on either aos-gns, or sco-red or osf-red.'
        sys.exit()

        
    dir=[]    
    cmd='find %s -type d -name \*.ms\* -user %s -mtime +%d -mtime -1000 -exec ls -ldh {} \;' %(path,user,days)
    #cmd='find /groups/science/data/RADIO/SYSTEM/ -type d -name \*.ms -user %s -exec ls -ldh {} \;' %(user)
    print cmd
    out = os.popen(cmd)
    for line in  out.readlines():
        dir.append(line.split()[-1])
        print line.split()[-1]

    out = raw_input(' Would you like to go ahead and delete those MS directories (y or n) ?  ')
    if out == 'y':              
        for i in dir:
            cmd='rm -Rf %s' %i
            print cmd
            out= os.system(cmd)
            if out == 0: print "Deletion of %s successfull" %i
    else:
        sys.exit()
    
