#! /usr/bin/env python
import os
import sys
sys.path.append('/users/dbarkats/analysis_scripts/')
import analysisUtils as aU
from manualAsdmExport import manualAsdmExport
from pylab import *
import xmlrpclib

def version():
    """
    Returns the CVS revision number.
    """
    myversion = "$Id: extractWVR_for_RQ.py,v 1.8 2014/04/22 09:38:48 dbarkats Exp $"
    return myversion

def system_except(cmd):
    ret = os.system(cmd)
    if ret != 0:
        raise Exception("Command '%s' returned non-zero exit status %d" %(cmd, ret))


def extractWVR():
    # from CSV-831
    #files = ['/mnt/scops/data/data/satoki/CSV-831/uid___A002_X3f4b85_X392.ms',\
    if 0:
        files = ['/mnt/scops/data/data/satoki/CSV-831/uid___A002_X3f4b85_X399.ms',\
                 '/mnt/scops/data/data/satoki/CSV-831/uid___A002_X3ffc69_X71.ms',\
                 '/mnt/scops/data/data/satoki/CSV-831/uid___A002_X401024_Xca.ms',\
                 '/mnt/scops/data/data/satoki/CSV-831/uid___A002_X401c5a_X13e.ms',\
                 '/mnt/scops/data/data/satoki/CSV-831/uid___A002_X403046_X3d.ms',\
                 '/mnt/scops/data/data/satoki/CSV-831/uid___A002_X404191_X26.ms',\
                 '/mnt/scops/data/data/satoki/CSV-831/uid___A002_X404919_X1b.ms',\
                 '/mnt/scops/data/data/satoki/CSV-831/uid___A002_X4056cb_X3ac.ms',\
                 '/mnt/scops/data/data/satoki/CSV-831/uid___A002_X4056cb_X3b3.ms',\
                 '/mnt/scops/data/data/satoki/CSV-831/uid___A002_X40672b_X30.ms',\
                 '/mnt/scops/data/data/satoki/CSV-831/uid___A002_X406899_X195.ms',\
                 '/mnt/scops/data/data/satoki/CSV-831/uid___A002_X406899_X261.ms',\
                 '/mnt/scops/data/data/satoki/CSV-831/uid___A002_X406899_X354.ms',\
                 '/mnt/scops/data/data/satoki/CSV-831/uid___A002_X406899_Xb4.ms',\
                 '/mnt/scops/data/data/satoki/CSV-831/uid___A002_X407726_X12.ms',\
                 '/mnt/scops/data/data/satoki/CSV-831/uid___A002_X407726_X1e8.ms',\
                 '/mnt/scops/data/data/satoki/CSV-831/uid___A002_X40b03b_X2c.ms',\
                 '/mnt/scops/data/data/satoki/CSV-831/uid___A002_X40b03b_X36c.ms',\
                 '/mnt/scops/data/data/satoki/CSV-831/uid___A002_X40b03b_X465.ms',\
                 '/mnt/scops/data/data/satoki/CSV-831/uid___A002_X40c17a_X120.ms',\
                 '/mnt/scops/data/data/satoki/CSV-831/uid___A002_X412ad5_X5dd.ms',\
                 '/mnt/scops/data/data/satoki/CSV-831/uid___A002_X414566_X1cd.ms',\
                 '/mnt/scops/data/data/satoki/CSV-831/uid___A002_X414566_X90.ms',\
                 '/mnt/scops/data/data/satoki/CSV-831/uid___A002_X414dd2_Xdb.ms',\
                 '/mnt/scops/data/data/satoki/CSV-831/uid___A002_X414dd2_Xe2.ms',\
                 '/mnt/scops/data/data/satoki/CSV-831/uid___A002_X414dd2_Xe9.ms',\
                 '/mnt/scops/data/data/satoki/CSV-831/uid___A002_X414dd2_Xf0.ms',\
                 '/mnt/scops/data/data/satoki/CSV-831/uid___A002_X4158c3_X9b.ms',\
                 '/mnt/scops/data/data/satoki/CSV-831/uid___A002_X415ff2_X673.ms',\
                 '/mnt/scops/data/data/satoki/CSV-831/uid___A002_X4177c8_X3b.ms']
    else:
        #files = ['uid___A002_X6d2c9c_X109.ms']
        uidList = readData()
        
    server=xmlrpclib.ServerProxy('http://osf-red.aiv.alma.cl:8000')
    me = manualAsdmExport()

    nfiles = len(uidList)
    skipAsdm = []
    skipMS = []
    for i in range(nfiles):
        uid = uidList[i]
        print '### Analyzing file %s : %d of %d'%(uid,i,nfiles)
        asdm = uid.replace('://', '___').replace('/','_')

        # first check if the final file exists for this asdm
        if '%s_pwv.tgz'%asdm in os.listdir('/users/dbarkats/work_area_dbarkats/wvr_data_for_RQ/'):
            print "### %s already processed. Skipping..."%asdm
            continue
        
        if asdm not in os.listdir('/users/dbarkats/work_area_dbarkats/wvr_data_for_RQ/'):
            #cmd = '/users/dbarkats/analysis_scripts/manualAsdmExport.py -u %s -n -k --here' %uid
            cmd = 'asdmExport %s >1 /dev/null'%uid
            print cmd
            print '### Exporting %s ...###' %uid
            try:
                system_except(cmd)
            except:
                skipAsdm.append(uid)
                os.system('rm -Rf %s'%asdm)
                continue
            #exportedAsdm= me._getAsdm(uid, False, '1> /dev/null')
        else:
            print "### No need to export %s. Already in directory"%uid

        vis = asdm+'.ms'
        print vis
        if  vis not in os.listdir('/users/dbarkats/work_area_dbarkats/wvr_data_for_RQ'):
            print '### Converting to MS %s ...###' %uid
            try:
                system_except('asdm2MS %s'%asdm)
            except:
                skipMS.append(asdm)
                os.system('rm -Rf %s'%asdm)
                continue
        else:
            print "### No need to fill %s. Already in directory"%vis
            
        #os.system('msdump --ms %s.ms --output %s_a.hd5 --spw 0 --arraydata'%(asdm,asdm))
        #os.system('msdump --ms %s.ms --output %s.hd5 --spw 0'%(asdm,asdm))
        continue
        
        ants = aU.readAntennasFromASDM(asdm)
        for ant in ants:
            #skip if CM antenna
            if ant[0:2] =='CM':
                continue
            
            outfile= '%s_%s_pwv.txt'%(asdm,ant)
            f = open('%s'%outfile,'w')
            f.write('### Measured PWV from ASDM: %s for Antenna:%s ### \n'%(asdm,ant))
            f.write('### Values calculated using wvrretrieve inside script: extractWVR_for_RQ.py \n')
            f.write('### %s \n'%(version()))
            f.write('### Contact D Barkats: dbarkats@alma.cl for details \n')
            f.write('### Columns are: \n')
            f.write('### ALMA time, az [deg], el[deg], PWV[mm], PWV_err[mm], evidence, tau_183, tau_183_err \n')
            #read WVR data
            d= aU.Visibility(vis,antenna1=ant,antenna2=ant,spwID=0)
            twvr = d.specTime
            wvr = d.amp
            nsamples = shape(wvr)[2]
            #read pointing data
            tb.open(vis+'/POINTING')
            id = aU.getAntennaIndex(vis,ant)
            subtable = tb.query('ANTENNA_ID == %d'%id)
            az = subtable.getcol('DIRECTION')[0,0,:]*180/pi
            el = subtable.getcol('DIRECTION')[1,0,:]*180/pi
            tel = subtable.getcol('TIME')
            #interpolate pointing data to wvr timestamps
            newel = interp(twvr,tel,el)
            newaz = interp(twvr, tel, az) 
            #average wvr and pointing data to 1mn interval
            dt = twvr[2]-twvr[1]
            avg_size = floor(60./dt)
            nblocks = ceil(nsamples/avg_size)
            t_m = zeros(nblocks)
            wvr_m=zeros([4,nblocks])
            el_m  = zeros(nblocks)
            az_m = zeros(nblocks)
            for j in range(nblocks):
                t_m[j] = mean(twvr[avg_size*j:min(avg_size*(j+1)-1,nsamples)])
                wvr_m[:,j] = mean(wvr[0,:,int(avg_size*j):int(min(avg_size*(j+1)-1,nsamples))],1)
                el_m[j] = mean(newel[avg_size*j:min(avg_size*(j+1)-1,nsamples)])
                az_m[j] = mean(newaz[avg_size*j:min(avg_size*(j+1)-1,nsamples)])
            #calc pwv and write out results
            print '######ASDM           ANT         WVR0 [K]        WVR1 [K]       WVR2 [K]        WVR3 [K]     El [deg]    '
            for i in range(nblocks):
                print asdm, ant, wvr_m[0,i],wvr_m[1,i],wvr_m[2,i],wvr_m[3,i],el_m[i]
                r=server.wvrretrieve(float(wvr_m[0,i]),float(wvr_m[1,i]),float(wvr_m[2,i]),float(wvr_m[3,i]),float(el_m[i]))
                f.write('%f,%3.2f, %2.2f, %2.4f,%2.4f, %1.3e,%2.4f, %2.4f \n'%(t_m[i],az_m[i],el_m[i],r['c'],r['c_err'],r['evidence'],r['tau183'],r['tau183_err']))
            f.close()
            
        os.system('tar -czvf %s_pwv.tgz %s*.txt --remove-files'%(asdm,asdm))
        os.system('rm -Rf %s.ms* %s'%(asdm,asdm))

def readData():
    f = open('slt.pointing.txt')
    lines = f.readlines()
    f.close()
    uidList = []
    for line in lines:
        if line[0] =='#':
            continue
        uidList.append(line.split(',')[5].strip('"'))
        
    return uidList
            
        
