#!/usr/bin/env python

# extract_asdm.py
# quick check of data:
# exports asdm, converts to ms, plots amp vs. time for one antenna pair.

import os
from optparse import OptionParser
# parse options
# Options section
parser = OptionParser()

#uid=uid://A002/X2fb75b/X8b

parser.add_option("-u","--uidname",dest="uidname",metavar="UIDname", help=" uid name. the prefix uid://A002/  is not needed. eg X2fb75d/Xb or uid://A002/X2fb75d/Xb")

parser.add_option("-k","--keepasdm",dest="keepasdm",metavar="keepasdm", action="store_true", default="false",
                  help=" -k will keep the asdm in current directory after exporting. default is to delete the asdm.")

(options, args) = parser.parse_args()

#print options.uidname

if(options.uidname[0]!='u'):
  uid='uid://A002/'+options.uidname
else:
  uid=options.uidname

print ' ===  extracting ',uid,' for display , leaving ms in current directory ==='

asdm='uid___'+uid.split('/')[2]+'_'+uid.split('/')[3]+'_'+uid.split('/')[4]
vis=asdm+'.ms'

os.system('/opt/asdmExport/bin/asdmExport '+uid)
os.system('tar -xvf '+asdm+'.tar')
os.system('asdm2MS-64 '+asdm)
#print options.keepasdm

if options.keepasdm == True:
  print " keeping the asdm in the current directory. are you sure you want this? "
else:
  print "deleting the asdm from the current diectory. thank you."
  os.system('rm -rf '+asdm)

os.system('casaplotms vis='+vis+' xaxis=time yaxis=amp avgchannel=9999 antenna="0&1"')
#os.system('rm -rf '+asdm+'.tar')

