#!/usr/bin/env python
"""
Produce a time-series plot of Vertex tiltmeter temperatures.

$Id: plotDVtiltmeterTemps.py,v 1.1 2011/10/08 02:30:38 tsawada Exp $
"""

import datetime
import os
import sys
import optparse
import pylab as pl
import tmUtils as tU

antennas = []
for line in os.popen('configuredAntennas').read().split():
    words = line.strip().split()
    if len(words) > 0:
        if words[0][:2] == 'DV':
            antennas.append(words[0])

if len(antennas) == 0:
    print 'could not get antenna list.'
    sys.exit()

today = datetime.date.today()

plf = pl.figure()
for (i, ant) in enumerate(antennas):
    subpl = plf.add_subplot(pl.ceil(len(antennas)/4.), 4, i+1)
    tU.show_monitor_data_in_subplot(subpl, ant, 'Mount',
        'METR_TILT_0_METR_TILT_0_TEMPERATURE_2', 
        (today-datetime.timedelta(2)).strftime('%Y-%m-%d'),
        today.strftime('%Y-%m-%d'), ylabel='Temp[C]*100',
        yrange=[-500, 1000], title=ant)
plf.show()

dummy = raw_input('Hit return to quit: ')
