#!/usr/bin/env python
"""
Simple plotter that plots the rain sensor on the oxygen monitor located at the AOS

Just run plot_rain and it will give you a plot with its histogram.
The generic transfer function is located at
http://www.alma.cl/~dbarkats/rain_sensor_xfer_function.jpg


$Id: plot_rain.py,v 1.2 2011/02/11 02:23:23 dbarkats Exp $
"""
import os
import urllib2
import sys
import time
import pylab
from  optparse import OptionParser

timeInt=8.0
#
# Parser setup
#
parser = OptionParser()

parser.add_option("-t", "--TimeInt", dest="TimeInt",type="float",
           default="30.0",
           help="time between measurements (default 30 seconds)")

    # Parse & Transform data types
(options, args) = parser.parse_args()
   
timeInt=options.TimeInt
print '################'
print "       "

print "Plotting eain sensor voltage,  Hit control C to stop"
print "Find teh standard rain sensor Xfer function at"
print "http://www.alma.cl/~dbarkats/rain_sensor_xfer_function.jpg "
print "       "
print "##################"
#----------

def get_rain_voltage():
    """
   function to read the rain voltage
    """
    url='http://10.195.17.192:8080/raw/status.csv'
   
    try:
        furl = urllib2.urlopen(url)
    except:
        print 'Failed to open URL %s' % url
        raise
    
    a=furl.readlines()
    rain_V=pylab.double(a[11].split(',')[1])
    
    return  rain_V

pylab.ion()
pylab.plot([0,0],[0,0],'b')

time0=time.time()/60.0
V_rain=get_rain_voltage()
V_l=[V_rain]
ts_l=[time.time()/60.0-time0]


while(1):
    V_rain=get_rain_voltage()
    print time.time()/60. - time0, V_rain

    V_l.append(V_rain)
    ts_l.append(time.time()/60.0-time0)

    pylab.ioff()
    pylab.clf()
    
    pylab.subplot(2,1,1)
    pylab.plot(ts_l[-1000:],
                   V_l[-1000:],'b.-')
    pylab.ylabel('Oxygen monitor rain voltage')
    pylab.xlabel('time (mn)')
    pylab.grid(True)

    pylab.subplot(2,1,2)
    pylab.hist(V_l,bins=100, range=[0,1], normed=True)
    
    pylab.ion()
    pylab.draw()

    time.sleep(timeInt)


