#!/usr/local/bin/python2.7
# This is a post-regression test analysis tool for plotbandpass3.py and
# task_plotbandpass2.py. It performs a difference analysis on the pngs
# produced using ImageMagick tools.
import analysisUtils as au
import numpy as np
import glob, os
figdir = '/lustre/naasc/sciops/comm/thunter/plotbandpass/regression/'
single = ''  # set to '' to do all, set to '1' to do 10-19, etc.
startfrom = 0
stopafter = 1000
fromdir = 'au_2017may10' # the directory to compare from (this can contain either all or a subset of the tests)
compdir = 'au_4.7.2'
# the directory to compare against (this should contain results for *all* tests)
#compdir = 'au_5.0.0'  # the directory to compare against (this should contain results for *all* tests)
#fromdir = 'task' # the directory to compare from (this can contain either all or a subset of the tests)
#compdir = 'task_2016may26'  # the directory to compare against (this should contain results for *all* tests)
# png size should be 864 x 648  in normal circumstances
au_pnglist = sorted(glob.glob(figdir+fromdir+'/regression%s*png'%single))
au_pdflist = sorted(glob.glob(figdir+fromdir+'/regression%s*pdf'%single))
pngs = []
if (not os.path.exists(figdir+compdir)):
    print "compdir does not exist: ", figdir+compdir
    sys.exit()
compdir_pnglist = sorted(glob.glob(figdir+compdir+'/regression%s*png'%single))  
compdir_difflist = sorted(glob.glob(figdir+compdir+'/regression%s*diff*png'%single))  
compdir_pnglist = np.setdiff1d(compdir_pnglist, compdir_difflist)
compdir_pdflist = sorted(glob.glob(figdir+compdir+'/regression%s*pdf'%single))
print "Checking pdf files in %s and %s..." % (fromdir,compdir)
if (len(compdir_pdflist) != len(au_pdflist)):
    print "There is a mismatch in number of pdfs! (%d vs %d)" % (len(compdir_pdflist), len(au_pdflist))
pageCountDifferences = 0
for i,pdf in enumerate(au_pdflist):
    j = -1
    for locateMatch in range(len(compdir_pdflist)):
        if (compdir_pdflist[locateMatch].find(os.path.basename(pdf)) >= 0):
            j = locateMatch
            break
    if (j == -1):
        print "Could not find matching pdf"
        break
    au_pdfpages =  au.countPagesInPDF(pdf)
    comp_pdfpages =  au.countPagesInPDF(compdir_pdflist[j])
    if (au_pdfpages != comp_pdfpages):
        pageCountDifferences += 1
        print "Page count differs in %s (%s=%d vs. %s=%d)" % (os.path.basename(pdf),pdf,au_pdfpages,compdir_pdflist[i],comp_pdfpages)

print "Finding png files to work on..."
regressions = []
for png in au_pnglist:
    if (png.find('.diff.') < 0):
        regression = int(os.path.basename(png).split('regression')[1].split('.')[0])
        regressions.append(regression)
        if (regression <= stopafter and regression >= startfrom):
            pngs.append(png)
regressions = np.unique(regressions)
fromdirMissingPngs = []
for reg in regressions:
    reglist = glob.glob(fromdir+'/regression%02d*'%reg)
    compdirlist = glob.glob(fromdir+'/regression%02d*'%reg)
    for r in compdirlist:
        missing = True
        for f in reglist:
            if (os.path.basename(r) == os.path.basename(f)):
                missing = False
        if missing:
            fromdirMissingPngs.append(os.path.basename(r))
npngs = len(pngs)
print "Found %d pngs to check in %s" % (npngs, fromdir)
print "Found %d pngs to compare against in %s" % (len(compdir_pnglist), compdir)
f = open('plotbandpass_pngdiff%s_%d-%d.txt'%(single,startfrom,stopafter),'w')
f_all = open('plotbandpass_pngdiff%s_%d-%d.txt.all'%(single,startfrom,stopafter),'w')
ranCompare = 0
minorFailures = 0
failures = 0
compdirMissingPngs = []
for i,png in enumerate(pngs):
    if (float(i/10) == i/10.):
        print "Done %4d of %4d" % (i,npngs)
    mypath = figdir+compdir+'/'+os.path.basename(png)
    if (os.path.exists(mypath)):
#        print "Running au.comparePngs('%s','%s',cleanup=False)" % (figdir+compdir+'/'+os.path.basename(png), png)
        dB = au.comparePngs(figdir+compdir+'/'+os.path.basename(png), png, cleanup=False)
        ranCompare += 1
        if (dB >= 520):
            print "%s %d" % (png, dB)
            f.write("%s %d\n" % (png, dB))
            f.flush()
            failures += 1
        if (dB > 0):
            f_all.write("%s %d\n" % (png, dB))
            f_all.flush()
            minorFailures += 1
    else:
        print "Path does not exist: ", mypath
        compdirMissingPngs.append(png)
f.close()
print "Ran %d comparisons.  The gold standard directory contained %d png files." % (ranCompare,len(compdir_pnglist))
print "There were %d PDF page count differences" % (pageCountDifferences)
print "As for individual pngs, there were %d minor differences and %d total differences" % (minorFailures, failures)
goldstandard = 'compdir.missing'
print "The gold standard directory was missing %d pngs. Written to %s" % (len(compdirMissingPngs), goldstandard)
f = open(goldstandard, 'w')
for c in compdirMissingPngs:
    f.write(c+'\n')
f.close()
print "The test directory was missing %d pngs: " % (len(fromdirMissingPngs)), str(fromdirMissingPngs)
f_all.close()

