def readStation4():
    """
    reads station 4 focus data from  https://wikis.alma.cl/bin/view/AIV/Station4Analysis
    """
    class stru:
        def __init__(self):
            self.ant = []
            self.Yc3 = []
            self.Yc3_err = []
            self.Zs3 = []
            self.Zs3_err = []
            self.Zt3 = []
            self.Zt3_err = []
            self.Yc4 = []
            self.Yc4_err = []
            self.Zs4 = []
            self.Zs4_err = []
            self.Zt4 = []
            self.Zt4_err = []
            

    f = open('Station4FocusAnalysis.txt','r')
    lines = f.readlines()
    f.close()

    d=stru()
    for line in lines:
        #print line
        if "Col0" in line:
            d.ant.append(line.split()[5])
        elif "Col2" in line:
            d.Yc3.append(float(line.split()[4]))
            d.Yc3_err.append(float(line.split()[6]))
        elif "Col3" in line:
            d.Zs3.append(float(line.split()[4]))
            d.Zs3_err.append(float(line.split()[6]))
        elif "Col4" in line:
            d.Zt3.append(float(line.split()[4]))
            d.Zt3_err.append(float(line.split()[6]))
        elif "Col6" in line:
            try:
                d.Yc4.append(float(line.split()[4]))
                d.Yc4_err.append(float(line.split()[6]))
            except:
                d.Yc4.append(0.0)
                d.Yc4_err.append(0.0)
        elif "Col7" in line:
            try:
                d.Zs4.append(float(line.split()[4]))
                d.Zs4_err.append(float(line.split()[6]))
            except:
                d.Zs4.append(0.0)
                d.Zs4_err.append(0.0)
        elif "Col8" in line:
            try:
                d.Zt4.append(float(line.split()[4]))
                d.Zt4_err.append(float(line.split()[6]))
            except:
                d.Zt4.append(0.0)
                d.Zt4_err.append(0.0)
            
    return d


 # DV Station 4 mean and sample standard deviation for all 25: YC = -3.89 &pm; 0.30 mm, ZS = 1.88 &pm; 0.10 mm, ZT = 44 &pm; 5 um/K
# DV Station 4 mean and sample standard deviation excluding DV12 (<a href="http://jira.alma.cl/browse/OPSNCR-267" target="_top">OPSNCR-267</a>): YC = -3.86 &pm; 0.25 mm, ZS = 1.86 &pm; 0.07 mm, ZT = 44 &pm; 5 um/K
# DA Station 4 mean and sample standard deviation(DA41-58): YC = -2.69 &pm; 0.08 mm, ZS = 0.70 &pm; 0.09 mm, ZT = 12 &pm; 8 um/K
#PM Station 4 mean and sample standard deviation: YC = -6.71 &pm; 0.11 mm, ZS = 1.94 &pm; 0.12 mm, ZT = -20 &pm; 3 um/K
#CM Station 4 mean and sample standard deviation: YC = -2.57 &pm; 0.08 mm, ZS = 0.57 &pm; 0.06 mm, ZT = -11 &pm; 10 um/K

