import os
import sys
import glob
from math import *

from scipy import *
from numpy import *
from pylab import *
from taskinit import *
import datetime

import pickle
attList = ['uid','band','src','focusflagtmp','focusflag',
           't_XX','az_XX','el_XX','src_dXX','amp_XX','amp_XX_e','cenX_XX','cenX_XX_e','cenY_XX',
           'cenY_XX_e','fwhma_XX','fwhma_XX_e','fwhmb_XX','fwhmb_XX_e','fwhma_XX_de',
           'fwhmb_XX_de','pa_XX','pa_XX_e','percent_rms_XX','focusx','focusy','focusz',
           't_YY','az_YY','el_YY','src_dYY','amp_YY','amp_YY_e','cenX_YY','cenX_YY_e','cenY_YY',
           'cenY_YY_e','fwhma_YY','fwhma_YY_e','fwhmb_YY','fwhmb_YY_e','fwhma_YY_de',
           'fwhmb_YY_de','pa_YY','pa_YY_e','percent_rms_YY']


def mergedata(ant):
    username=os.environ['USER']
    host='dbarkats@wwwpub.sco.alma.cl'
    f='public_html/beam_map_data_sofar.txt'
    cmd='scp  %s:%s ./%s' % (host, f, 'beam_map_data_sofar.tmp')
    os.system(cmd)
    
    b=open('/home/dbarkats/alma_analysis/beam_map_analysis/beam_map_data_sofar.tmp')
    obs=b.readlines()

    #init variables
    j=0
    k=0
    data={}
    data[ant]={}
    for i in attList: data[ant][i] = []

    # find correct line in  beam_map_data_sofar file
    while k < size(obs):
        if obs[k].startswith('#-----%s' %ant):
            break
        k=k+1
        
    for i in range(k+1,size(obs)):
        line=obs[i]
        #print  i, line
        if line[0] != '\n' and line[0] != '#':
            data[ant]['uid'].append(line.split(',')[1].lstrip())
            data[ant]['band'].append(line.split(',')[2].lstrip())
            data[ant]['src'].append(line.split(',')[3].lstrip())
            nelem=len(line.split(','))
            if nelem > 5:
                data[ant]['focusflagtmp'].append(line.split(',')[4].lstrip())
                #focus_tmp= line.split(',')[5].lstrip()
                #p1=focus_tmp.find('(')
                #p2=focus_tmp.find(')')
                # data[ant]['focusflag'].append(NaN)
                # if p2-p1  > 1: 
                #    data[ant]['focusx'].append(float(focus_tmp[p1+1:p2].split(' ')[0]))
                #    data[ant]['focusy'].append(float(focus_tmp[p1+1:p2].split(' ')[1]))
                #    data[ant]['focusz'].append(float(focus_tmp[p1+1:p2].split(' ')[2]))
                
            paramfileX=glob.glob('%s/%s*XX*.param' %(ant,data[ant]['uid'][j]))
            if size(paramfileX) == 0:
                for i in range(5,27): data[ant][attList[i]].append(NaN)
            elif size(paramfileX) == 1:
                param=readparam(paramfileX[0])
                for l in range(5,27):
                    data[ant][attList[l]].append(float(param.split()[l-5]))
            elif size(paramfileX) > 1:
                for k in range(size(paramfileX)):
                    if k > 0:
                        data[ant]['uid'].append(line.split(',')[1].lstrip())
                        data[ant]['band'].append(line.split(',')[2].lstrip())
                        data[ant]['src'].append(line.split(',')[3].lstrip())
                    param=readparam(paramfileX[k])
                    for l in range(5,27):
                        data[ant][attList[l]].append(float(param.split()[l-5]))


            paramfileY=glob.glob('%s/%s*YY*.param' %(ant,data[ant]['uid'][j]))
            if size(paramfileY) == 0:
                for i in range(27,46) : data[ant][attList[i]].append(NaN)
            elif size(paramfileY) == 1:
                param=readparam(paramfileY[0])
                for l in range(27,46):
                    data[ant][attList[l]].append(float(param.split()[l-27]))
            elif size(paramfileY) > 1:
                for k in range(size(paramfileY)):
                    param=readparam(paramfileX[k])
                    for l in range(27,46):
                        data[ant][attList[l]].append(float(param.split()[l-27]))      
            j=j+1

    for i in attList : data[ant][i] = array(data[ant][i])       
    # save data with pickle.
    f=open('/home/dbarkats/alma_analysis/beam_map_analysis/%s_beammaps.sav' %ant,'w')
    pickle.dump(data, f)
    return data

def readparam(paramfile):
    b=open(paramfile)
    param=b.readlines()[2]
    return param

def readFocusParam(ant, date):
    """
    Retrieve the focus parameters for antenna ant for date  2009-04-23
    """
    username=os.environ['USER']
    focus_curve_name='/users/%s/AIV/science/FocusCurves/%s_focusCurves.txt' %(username,ant)
    b=open(focus_curve_name)
    
    obs=b.readlines()
    t0=qa.convert(date,'d')['value']

    fparam = {'X0' : {3 : 0, 6 : 0, 7 : 0, 9:0},
              'Y0' : {3 : 0, 6 : 0, 7 : 0, 9:0},
              'Z0' : {3 : 0, 6 : 0, 7 : 0, 9:0},
              'Z_sin' : 0, 'Y_cos' : 0, 'Z_temp' : 0.0}
                          
    i=0
    while i  < size(obs):
        line=obs[i]
        #print i, line
        if line[0] != '\n' and line[0] != '#':
            start=line.split(',')[0].lstrip()
            stop= line.split(',')[1].lstrip()
            #print start, stop
            if t0-qa.convert(start,'d')['value'] >= 0 and t0-qa.convert(stop,'d')['value'] <= 0:
                break
            else:
                i=i+1
        else:
            i=i+1

    fparam['X0'][3]=float(line.split(',')[2].lstrip())
    fparam['Y0'][3]=float(line.split(',')[3].lstrip())
    fparam['Z0'][3]=float(line.split(',')[4].lstrip())
    fparam['X0'][6]=float(line.split(',')[5].lstrip())
    fparam['Y0'][6]=float(line.split(',')[6].lstrip())
    fparam['Z0'][6]=float(line.split(',')[7].lstrip())
    fparam['X0'][7]=float(line.split(',')[8].lstrip())
    fparam['Y0'][7]=float(line.split(',')[9].lstrip())
    fparam['Z0'][7]=float(line.split(',')[10].lstrip())
    fparam['X0'][9]=float(line.split(',')[8].lstrip())
    fparam['Y0'][9]=float(line.split(',')[9].lstrip())
    fparam['Z0'][9]=float(line.split(',')[10].lstrip())
    fparam['Z_sin']=float(line.split(',')[11].lstrip())
    fparam['Y_cos']=float(line.split(',')[12].lstrip())
    fparam['Z_temp']=float(line.split(',')[13].lstrip())
    #for i in fList : fparam[i] = array(fparam[i])
   
    return fparam

def focuscurve(fparam, el, band):
    el=el*pi/180
    fcurve=array(zeros([size(el), 3]))
    a=(fparam['X0'][band])
    b=(fparam['Y0'][band])
    c=(fparam['Z0'][band])
    d=(fparam['Y_cos'])
    e=(fparam['Z_sin'])
    f=(fparam['Z_temp'])
    fcurve[:,0] = a *1000.
    fcurve[:,1] = (b+(d*cos(el))) *1000.
    fcurve[:,2] = (c+(e*sin(el))+f)*1000.

    return fcurve

#def make_diff_maps():
# make diff maps
#periods=rb.find_same_days(data) 
#    figure(12);
#    clf()
#    f1='uid___X02_X1fa2b_X1'
#    f2='uid___X02_X1faeb_X1'
#    fname1=glob.glob('%s/%s*XX*.image' %('DV03',f1))[0].split('.image')[0]
#    fname2=glob.glob('%s/%s*XX*.image' %('DV03',f2))[0].split('.image')[0]
#    os.system('cp -Rf '+fname1+'.image  '+f1+'_'+f2+'.diff')
#    ia.open(fname1+'.image')
#    z1=ia.getchunk(dropdeg=True)
#    mm=z1.max()
#    st0=ia.statistics()
#    blcf=st0['blcf']
#    azmax=float(blcf.split(',')[0][:-3])
#    elmin=float(blcf.split(',')[1][:-3])
#    trcf=st0['trcf']
#    azmin=float(trcf.split(',')[0][:-3])-360
#    elmax=float(trcf.split(',')[1][:-3]) 
#    ia.open(fname2+'.image')
#    z2=ia.getchunk(dropdeg=True)
#    diff=transpose(z1/z1.max()-z2/z2.max())
#    ia.open(f1+'_'+f2+'.diff')
#    ia.putchunk(diff)   # save the diff map
#    mtext='%s.image > %s' %(fname1, mm/10)
#    st2=ia.statistics(mask=mtext ) 
#    diff_rms=st2['rms'][0]*100
#    ia.close()
 #   imshow(diff, origin='lower',extent=[azmax, azmin, elmin, elmax],aspect='equal',interpolation='nearest',vmin=-.05, vmax=.05)
#    hot()
#    xlabel('AZ (deg)'); ylabel('EL (deg)')
#    tit1=f1+' - '+f2
#    title(tit1)
#    t0='RMS Residual in 10dB contour = %1.3g%%  ' % diff_rms
#    figtext(0.33, 0.85, t0, color='w')
#    figtext(0.89, 0.4, '% of boresight amplitude', rotation='vertical')
#    colorbar()
#    savefig('DV03_'+f1+'_'+f2+'_diff.png', format='png')
     

   
def make_plots(filename):
    f=open(filename, 'r')
    data=pickle.load(f)
    ant=filename[-17:-13]
    npoints=size(data[ant]['t_XX'])
    date=[]
    mdate=[]
    um=1e6
    data=data[ant]
    
    figure(12) ;clf() ;ioff()
    # plot El vs focus points along with curve
    for i in range(npoints):
        date.append(qa.time('%s s' % data['t_XX'][i], form='fits'))
        tmp=datetime.datetime.strptime(date[i].replace('T',' '),"%Y-%m-%d %H:%M:%S")
        mdate.append(date2num(tmp))

        fparam=readFocusParam(ant, date[i])
        band=int(data['band'][i])

        el=array(range(10, 90))
        fcurve=focuscurve(fparam, el, band)

        if band== 3:
            c='r'
        elif band==6:
            c='g'
        elif band==7:
            c='b'

        subplot(3,1,1)
        plot([data['el_XX'][i]], [data['focusx'][i]*um],'%s.'%c)
        hold(True)
        plot(el, fcurve[:,0],color=c)
        ylim([-6500, -5800])
        ylabel('X focus')
        subplot(3,1,2)
        plot([data['el_XX'][i]], [data['focusy'][i]*um],'%s.'%c)
        plot(el, fcurve[:,1], color=c)
        ylim([-4000, 1000])
        ylabel('Y focus')
        subplot(3,1,3)
        plot([data['el_XX'][i]], [data['focusz'][i]*um],'%s.'%c)
        plot(el, fcurve[:,2], color=c)
        ylim([-2000, 2000])
        ylabel('Z focus')
        xlabel('El')
    figtext(0.2, 0.92,' Focus values and Focus curves during beam maps for %s ' %ant, size='large')
    savefig(ant+'_focus_vs_el.png', format='png')
        
    ion()
    show()
    
   
    #cut away non-focused data.
    #mask_f= data['focusflag']=='1'
    #data2={}
    #for i in attList : data2[i] = data[i][mask_f]
    data2=data
    
    b3=data2['band']=='3'
    b6=data2['band']=='6'
    b7=data2['band']=='7'

    j=data2['src']=='Jup'
    s=data2['src']=='Sat'
    m=data2['src']=='Mars'

    jb3=logical_and(j,b3)
    jb7=logical_and(j,b7)
    mb7=logical_and(m,b7)
    mb6=logical_and(m,b6)
    jb6=logical_and(j,b6)

    fwhm_b3=99*60/100.
    fwhm_b6=99*60/243.
    fwhm_b7=99*60/324.
   
    # plot source diameter vs time observed
    figure(9, figsize=(10,5))
    clf()
    plot_date(array(mdate)[j], data['src_dXX'][j],'bD-')
    plot_date(array(mdate)[s], data['src_dXX'][s],'bo-')
    plot_date(array(mdate)[m], data['src_dXX'][m],'b^-')
    axhline(y=fwhm_b3,linestyle='--', color='r', linewidth=2)
    axhline(y=fwhm_b6,linestyle='--', color='g', linewidth=2)
    axhline(y=fwhm_b7,linestyle='--', color='b', linewidth=2)
    title('Source size for %s BeamMaps'%ant)
    xlabel('date'); ylabel('source diameter [arcsec]')
    legend(('Jupiter','Saturn','Mars'), loc=1)
    grid(True)
    savefig(ant+'_sourcediam_vs_time.png', format='png')

     
    #plot all data vs az and el
    figure(1)
    plot(data['az_XX'], data['el_XX'],'ko')
    plot(data2['az_XX'], data2['el_XX'],'bo')
    xlim([-100 ,100])
    xlabel('Az');ylabel('El'); title('Focused(b), Non-Focused(k)  BeamMaps for '+ant)
    savefig(ant+'_all_maps_az_el.png', format='png')

    #
    for i in range(size(data2['pa_XX'])) :
        if data2['pa_XX'][i] > 90:
            data2['pa_XX'][i] = mod(data2['pa_XX'][i],-90)
    for i in range(size(data2['pa_YY'])) :
        if data2['pa_YY'][i] > 90:
            data2['pa_YY'][i] = mod(data2['pa_YY'][i],-90)
            
    
    #plot focused data only vs as, el, vs planet
    figure(2)
    clf()
    plot(data2['az_XX'][j], data2['el_XX'][j],'bD')
    plot(data2['az_XX'][s], data2['el_XX'][s],'bo')
    plot(data2['az_XX'][m], data2['el_XX'][m],'b^')
    xlabel('Az');ylabel('El'); title('Focused  BeamMaps for '+ant)
    legend(('Jupiter', 'Saturn','Mars'), loc=2)
    xlim([-100 ,100])
    savefig(ant+'_focused_maps_az_el_vs_src.png', format='png')

    #plot focused data only vs as, el, vs band
    figure(3)
    clf()
    plot(data2['az_XX'][b3], data2['el_XX'][b3],'ro')
    plot(data2['az_XX'][b6], data2['el_XX'][b6],'go')
    plot(data2['az_XX'][b7], data2['el_XX'][b7],'bo')
    xlabel('Az');ylabel('El'); title('Focused  BeamMaps for '+ant)
    legend(('Band3', 'Band6','Band7'), loc=2)
    xlim([-100 ,100])
    savefig(ant+'_focused_maps_az_el_vs_band.png', format='png')

    #plot Band3, 6, 7  fwhma vs fwhmb non deconvolved data
    figure(4);
    clf()
    line=array([0,100])
    subplot(2,2,1)
    errorbar(data2['fwhma_XX'][b3]*3600,data2['fwhmb_XX'][b3]*3600,data2['fwhma_XX_e'][b3]*3600,data2['fwhmb_XX_e'][b3]*3600,'ro')
    title('Band 3'); ylabel('fwhmb')
    hold(True)
    errorbar(data2['fwhma_YY'][b3]*3600,data2['fwhmb_YY'][b3]*3600,data2['fwhma_YY_e'][b3]*3600,data2['fwhmb_YY_e'][b3]*3600,'o')
    plot(line, line,'k-.')
    axhline(y=fwhm_b3, xmin=0, xmax=1, color='r')
    axvline(x=fwhm_b3, ymin=0, ymax=1, color='r')
    xlim([55 ,80]); ylim([55 ,80])
       
    subplot(2,2,3)
    errorbar(data2['fwhma_XX'][b6]*3600,data2['fwhmb_XX'][b6]*3600,data2['fwhma_XX_e'][b6]*3600,data2['fwhmb_XX_e'][b6]*3600,'ro')        
    errorbar(data2['fwhma_YY'][b6]*3600,data2['fwhmb_YY'][b6]*3600,data2['fwhma_YY_e'][b6]*3600,data2['fwhmb_YY_e'][b6]*3600,'o')
    xlabel('fwhma'),; ylabel('fwhmb');title('Band 6')
    plot(line, line,'k-.')
    axhline(y=fwhm_b6, xmin=0, xmax=1, color='r')
    axvline(x=fwhm_b6, ymin=0, ymax=1, color='r')
    xlim([24,34]); ylim([24 ,34])
    
    subplot(2,2,4)
    errorbar(data2['fwhma_XX'][b7]*3600,data2['fwhmb_XX'][b7]*3600,data2['fwhma_XX_e'][b7]*3600,data2['fwhmb_XX_e'][b7]*3600,'ro')
    errorbar(data2['fwhma_YY'][b7]*3600,data2['fwhmb_YY'][b7]*3600,data2['fwhma_YY_e'][b7]*3600,data2['fwhmb_YY_e'][b7]*3600,'o')
    xlabel('fwhma'),; ylabel('fwhmb');title('Band 7')
    plot(line, line,'k-.')
    axhline(y=fwhm_b7, xmin=0, xmax=1, color='r')
    axvline(x=fwhm_b7, ymin=0, ymax=1, color='r')
    xlim([15 ,25]); ylim([15 ,25])
    figtext(0.3, 0.95, ' XX-pol (b) YY-pol(g) FWHM [arcsec] ', size='large')
    savefig(ant+'_focused_maps_fwhm.png', format='png')

    #plot Band3, 6, 7  fwhma vs fwhmb deconvolved 
    figure(4);
    clf()
    line=array([0,100])
    subplot(2,2,1)
    errorbar(data2['fwhma_XX_de'][b3]*3600,data2['fwhmb_XX_de'][b3]*3600,data2['fwhma_XX_e'][b3]*3600,data2['fwhmb_XX_e'][b3]*3600,'o')
    title('Band 3'); ylabel('fwhmb')
    hold(True)
    errorbar(data2['fwhma_YY_de'][b3]*3600,data2['fwhmb_YY_de'][b3]*3600,data2['fwhma_YY_e'][b3]*3600,data2['fwhmb_YY_e'][b3]*3600,'o')
    plot(line, line,'k-.')
    axhline(y=fwhm_b3, xmin=0, xmax=1, color='r')
    axvline(x=fwhm_b3, ymin=0, ymax=1, color='r')
    xlim([55 ,80]); ylim([55 ,80])
     
    subplot(2,2,3)
    errorbar(data2['fwhma_XX_de'][b6]*3600,data2['fwhmb_XX_de'][b6]*3600,data2['fwhma_XX_e'][b6]*3600,data2['fwhmb_XX_e'][b6]*3600,'o')
    errorbar(data2['fwhma_YY_de'][b6]*3600,data2['fwhmb_YY_de'][b6]*3600,data2['fwhma_YY_e'][b6]*3600,data2['fwhmb_YY_e'][b6]*3600,'o')
    xlabel('fwhma'),; ylabel('fwhmb');title('Band 6')
    plot(line, line,'k-.')
    axhline(y=fwhm_b6, xmin=0, xmax=1, color='r')
    axvline(x=fwhm_b6, ymin=0, ymax=1, color='r')
    xlim([24,34]); ylim([24 ,34])
    
    subplot(2,2,4)
    errorbar(data2['fwhma_XX_de'][b7]*3600,data2['fwhmb_XX_de'][b7]*3600,data2['fwhma_XX_e'][b7]*3600,data2['fwhmb_XX_e'][b7]*3600,'o')
    errorbar(data2['fwhma_YY_de'][b7]*3600,data2['fwhmb_YY_de'][b7]*3600,data2['fwhma_YY_e'][b7]*3600,data2['fwhmb_YY_e'][b7]*3600,'o')
    xlabel('fwhma'),; ylabel('fwhmb');title('Band 7')
    plot(line, line,'k-.')
    axhline(y=fwhm_b7, xmin=0, xmax=1, color='r')
    axvline(x=fwhm_b7, ymin=0, ymax=1, color='r')
    xlim([15 ,25]); ylim([15 ,25])
    figtext(0.3, 0.95, ' XX-pol (b) YY-pol(g) FWHM (deconvolved)[arcsec] ', size='large')
    savefig(ant+'_focused_maps_fwhm_de.png', format='png')


    # plot the position angle 
    figure(5);
    clf()
    subplot(2,2,1)
    errorbar(data2['pa_XX'][b3],data2['pa_YY'][b3],data2['pa_XX_e'][b3],data2['pa_YY_e'][b3],'o')
    ylabel('pa_YY'); title('Band 3 position angle')
    xlim([-100 ,100]); ylim([-100 ,100])
    hold(True)

    subplot(2,2,3)
    errorbar(data2['pa_XX'][b7],data2['pa_YY'][b7],data2['pa_XX_e'][b7],data2['pa_YY_e'][b7],'o')
    xlabel('pa_XX'),; ylabel('pa_YY');title('Band 7 position Angle')
    xlim([-100 ,100]); ylim([-100 ,100])
    
    subplot(2,2,4)
    errorbar(data2['pa_XX'][b6],data2['pa_YY'][b6],data2['pa_XX_e'][b6],data2['pa_YY_e'][b6],'o')
    xlabel('pa_XX');title('Band 6 position Angle')
    xlim([-100 ,100]); ylim([-100 ,100])
 
    figtext(0.3, 0.95,'XX-pol vs YY-pol position angle', size='large')
    savefig(ant+'_focused_maps_pa.png', format='png')

    #plot ellipticity  (defined normally as sqrt(c^2-a^2/c^2))
    figure(6);
    clf()
    subplot(2,2,1)
    plot(sqrt((data2['fwhma_XX'][b3]**2-data2['fwhmb_XX'][b3]**2)/data2['fwhma_XX'][b3]**2),sqrt((data2['fwhma_YY'][b3]**2-data2['fwhmb_YY'][b3]**2)/data2['fwhma_YY'][b3]**2),'o')
    title('Band 3'); ylabel('ellipticity YY-pol')
    hold(True)
    xlim([-0.5 ,0.5]); ylim([-0.5 ,0.5])
    
    subplot(2,2,3)
    plot(sqrt((data2['fwhma_XX'][b6]**2-data2['fwhmb_XX'][b6]**2)/data2['fwhma_XX'][b6]**2),sqrt((data2['fwhma_YY'][b6]**2-data2['fwhmb_YY'][b6]**2)/data2['fwhma_YY'][b6]**2),'o')
    xlabel('ellipticity XX-pol');ylabel('ellipticity YY-pol');title('Band 6')
    xlim([-0.5 ,0.5]); ylim([-0.5 ,0.5])
        
    subplot(2,2,4)
    plot(sqrt((data2['fwhma_XX'][b7]**2-data2['fwhmb_XX'][b7]**2)/data2['fwhma_XX'][b7]**2), sqrt((data2['fwhma_YY'][b7]**2-data2['fwhmb_YY'][b7]**2)/data2['fwhma_YY'][b7]**2),'o')
    xlabel('ellipticity XX-pol');title('Band 7')
    xlim([-1 ,1]); ylim([-1 ,1])

    figtext(0.3, 0.95,'XX-pol vs YY-pol ellipticity', size='large')
    savefig(ant+'_focused_maps_ell.png', format='png')

    # plot Band3, 6, 7  centerX - centerY to look for diff pointing
    figure(8);
    clf()
    subplot(2,2,1)
    errorbar(data2['cenX_XX'][b3]*3600-data2['cenX_YY'][b3]*3600,\
             data2['cenY_XX'][b3]*3600-data2['cenY_YY'][b3]*3600,\
             sqrt((data2['cenX_XX_e'][b3]*3600)**2+ (data2['cenX_YY_e'][b3]*3600)**2),\
             sqrt((data2['cenY_XX_e'][b3]*3600)**2+ (data2['cenY_YY_e'][b3]*3600)**2) ,'o')
    title('Band 3'); ylabel('Diff Pointing El')
    xlim([-1 ,1]); ylim([-1 ,1])

    subplot(2,2,4)
    errorbar(data2['cenX_XX'][b7]*3600-data2['cenX_YY'][b7]*3600,\
             data2['cenY_XX'][b7]*3600-data2['cenY_YY'][b7]*3600,\
             sqrt((data2['cenX_XX_e'][b7]*3600)**2+ (data2['cenX_YY_e'][b7]*3600)**2),\
             sqrt((data2['cenY_XX_e'][b7]*3600)**2+ (data2['cenY_YY_e'][b7]*3600)**2) ,'o')
    xlabel('Diff pointing Az');title('Band 7')
    xlim([-2 ,2]); ylim([-2 ,2])
    
    subplot(2,2,3)
    errorbar(data2['cenX_XX'][b6]*3600-data2['cenX_YY'][b6]*3600,\
             data2['cenY_XX'][b6]*3600-data2['cenY_YY'][b6]*3600,\
             sqrt((data2['cenX_XX_e'][b6]*3600)**2+ (data2['cenX_YY_e'][b6]*3600)**2),\
             sqrt((data2['cenY_XX_e'][b6]*3600)**2+ (data2['cenY_YY_e'][b6]*3600)**2) ,'o')
    xlabel('Diff Pointing Az'),; ylabel('Diff Pointing El');title('Band 6')
    xlim([-1,1]); ylim([-1 ,1])
   
   
    figtext(0.3, 0.95, 'Differential Pointing  [arcsec] ', size='large')
    savefig(ant+'_focused_maps_diff_pointing.png', format='png')
    
    #plot  percent rms
    figure(10);
    clf()
    subplot(2,2,1)
    plot(data2['percent_rms_XX'][b3],data2['percent_rms_YY'][b3],'o')
    title('Band 3');
    ylabel('YY-pol')
    xlim([0,5]); ylim([0 ,5])
    hold(True)

    subplot(2,2,3)
    plot(data2['percent_rms_XX'][b6],data2['percent_rms_YY'][b6],'o')
    title('Band 6');
    xlabel('XX-pol'),ylabel('YY-pol')
    xlim([0,5]); ylim([0 ,5])
        
    subplot(2,2,4)
    plot(data2['percent_rms_XX'][b7],data2['percent_rms_YY'][b7],'o')
    title('Band 7');
    xlabel('XX-pol')
    xlim([0,5]); ylim([0 ,5])

    figtext(0.3, 0.95,'xx-pol vs YY-pol %rms inside 10dB contour', size='large')
    savefig(ant+'_focused_maps_percent_rms.png', format='png')

    # plot left going vs right going.
    
    

def make_html():
    
    list=sort(glob.glob('uid___X5*_X*_Mar_band7*XX_OFF.png'))
    c=0
    
    for name in list:
       
        if c == 0:
            st='<tr><td><a href="%s"><img src="%s" width=150></a>\n <a href="%s_log.png"><img src="%s_log.png" width=150></a> \n <a href="%sYY_OFF.png"><img src="%sYY_OFF.png" width=150> \n </a><a href="%sYY_OFF_log.png"><img src="%sYY_OFF_log.png" width=150></a></td> \n \n'
            c=c+1
            #print c
            
        elif c == 7:
            st='<td><a href="%s"><img src="%s" width=150></a>\n <a href="%s_log.png"><img src="%s_log.png" width=150></a> \n <a href="%sYY_OFF.png"><img src="%sYY_OFF.png" width=150> \n </a><a href="%sYY_OFF_log.png"><img src="%sYY_OFF_log.png" width=150></a></td></tr> \n \n'
            c=0
            #print c
            
        else :
            st='<td><a href="%s"><img src="%s" width=150></a>\n <a href="%s_log.png"><img src="%s_log.png" width=150></a> \n <a href="%sYY_OFF.png"><img src="%sYY_OFF.png" width=150> \n </a><a href="%sYY_OFF_log.png"><img src="%sYY_OFF_log.png" width=150></a></td> \n \n'
            c=c+1
            #print c
        print st  % (name, name, name[:-4],name[:-4], name[:-10],name[:-10],name[:-10],name[:-10])
        

def find_same_days(data):

    atime = data['t_XX']
    aband = data['band']
    auid  = data['uid']
    
    result = {}

    for band in ['3', '6', '7']:
        print 'Band%s' % band

        result[band] = {}

        bindex = where(aband == band)
        btime = atime[bindex]
        buid = auid[bindex]
        bdate = btime.copy()
        
        date0 = 0.
        for i in range(len(btime)):
            datestr = qa.time('%fs' % btime[i], form='ymd')
            (year, month, day, timestr) = datestr.split('/')
            (hour, minute, second) = timestr.split(':')
        ### UT13h is assumed to be the border of the session
            if int(hour) < 13:
                # UT0h of the day before
                bdate[i] = btime[i] - (int(hour)*3600.+int(minute)*60.+float(second)) - 86400.
            else:
                # UT0h of the day
                bdate[i] = btime[i] - (int(hour)*3600.+int(minute)*60.+float(second))
                
            if abs(date0 - bdate[i]) > 10.:
                bdatestr = '-'.join(qa.time('%fs' % bdate[i], form='ymd').split('/')[:3])
                print bdatestr
                print buid[i], datestr
                date0 = bdate[i]
                result[band][bdatestr] = [buid[i]]
            else:
                print buid[i], datestr
                result[band][bdatestr].append(buid[i])

    return result
 
