import math
import os
from array import array
#from path import path

###########################################################
#
# Need to make source scan selection automatic
# Need put frequency scale
# Need average some channels 

def computeBandpass (invis='uid___X02_X1861f_X1.ms',plot='',spw1='',timebin1='',corr='',plotfig=0,ymin='',ymax='',logfile1='',scan1='',autocorr='',timerange1=''):

   #invis=invis

   clearstat()
   
   antenna1='DV01'
   antenna2='DV02'
   auto1=str(antenna1)+'&&&'
   auto2=str(antenna2)+'&&&'
   baseline12=str(antenna1)+'&'+(antenna2)
   #timebin_ito='300'
   timebin_ito=timebin1
   correlation_1=corr
   spw=spw1
   logfile=logfile1
   scanito=scan1
   timerange=timerange1

   #timerange='09:14:0~09:54:0'

   chop_edge=5
   
   Nscan=1 #Only for reference of Nchan. Assuming all scans have same spectral setup
   antenna=0 #same

   extension='.png'

      
   #plot=baseline12
   
   

   # name of averaged  data files
   figfile1=invis.split('.ms' )[0]+'_ant_'+plot+'_spw'+spw+'_corr_'+correlation_1+'_auto.txt'
   figfile_amp=invis.split('.ms' )[0]+'_ant_'+plot+'_spw'+spw+'_corr_'+correlation_1+'_amp_time_auto.txt'
   # name of Hardcopy plots
   true_figfile1=invis.split('.ms' )[0]+'_ant_'+plot+'_spw'+spw+'_corr_'+correlation_1+extension
   true_figfile_amp=invis.split('.ms' )[0]+'_ant_'+plot+'_spw'+spw+'_corr_'+correlation_1+'_amp_time'+extension

   # Remove existing files
   #mydir = os.path.abspath('./')
   #if (len(mydir.isfile(figfile1)) == 1):
   #  os.remove(figfile1)
   #if (len(mydir.isfile(figfile_amp)) == 1):
   #  os.remove(figfile_amp)

   title1=invis.split('.ms' )[0]+' '+plot+' spw  '+spw+'_corr_'+correlation_1+'Amp v/s Channel '+timebin_ito+' seconds average'
   
   plotxy(vis=invis,xaxis='channel',yaxis='amp',datacolumn='data',antenna=plot,selectdata=True,spw=spw,averagemode='vector',timebin=timebin_ito,correlation=correlation_1,figfile=figfile1,scan=scanito,timerange=timerange)
   pl.clf()
   if (plotfig==1):
      plotxy(vis=invis,xaxis='channel',yaxis='amp',datacolumn='data',antenna=plot,selectdata=True,spw=spw,averagemode='vector',timebin=timebin_ito,correlation=correlation_1,figfile=true_figfile1,scan=scanito,timerange=timerange)
   
   # same but versus time to get time reference
   
   title1=invis.split('.ms' )[0]+' '+plot+' spw  '+spw+'_corr_'+correlation_1+'Amp v/s Time '+timebin_ito+' seconds average'
   
   plotxy(vis=invis,xaxis='time',yaxis='amp',datacolumn='data',antenna=plot,selectdata=True,spw=spw,averagemode='vector',timebin=timebin_ito,correlation=correlation_1,width='all',selectplot=True,title=title1,figfile=figfile_amp,scan=scanito,timerange=timerange)
   pl.clf()
   if (plotfig==1):
      plotxy(vis=invis,xaxis='time',yaxis='amp',datacolumn='data',antenna=plot,selectdata=True,spw=spw,averagemode='vector',timebin=timebin_ito,correlation=correlation_1,width='all',selectplot=True,title=title1,figfile=true_figfile_amp,scan=scanito,timerange=timerange)
   ###########################################################
   
#   vis='uid___X02_X1861f_X1.ms'
#   infile='uid___X02_X1861f_X1_ant_DV01_spw0.txt'
#   infile_amp='uid___X02_X1861f_X1_ant_DV01_spw0_amp_time.txt'
   
   
   f  = open (figfile1,'r+')
   all_lines1=f.readlines()
   f1 = open (figfile1,'w+')
   for line in all_lines1[1:]:
    f1.write(line)
   
   f.close()
   f1.close()
   
   
   f = open (figfile_amp,'r+') 
   all_lines2=f.readlines()
   f2 = open (figfile_amp,'w+')
   for line in all_lines2[1:]:
    f2.write(line)
   
   f.close()
   f2.close()
     
   
   outfile=figfile1.split('.txt' )[0]+'.table'
     
   
   tb.open(invis)
   tb1=tb.query("SCAN_NUMBER==%d && ANTENNA1==%d && PROCESSOR_ID=0" % (Nscan,antenna))
   dd_ID=tb1.getcol('DATA_DESC_ID')
   
   # next find which SPW ID's correspond to this:
   dataDescTb=tbtool.create()
   dataDescTb.open(invis+'/DATA_DESCRIPTION')
   spw_ID = dataDescTb.getcol('SPECTRAL_WINDOW_ID')
   spwTb = tbtool.create()
   spwTb.open(invis+'/SPECTRAL_WINDOW')
   
   for i in range(0,len(spw_ID)):
        numChan = spwTb.getcell('NUM_CHAN',spw_ID[i])
        print "Spectral Window %d has %d channels" % (spw_ID[i],numChan)
   
   mytb = tbtool.create()
   mytb.fromascii(outfile,figfile1,autoheader=true,firstline=1)
   mytb.close()
   
   
   mytb.open(outfile,nomodify=false)
   data=mytb.getcol('Column2')
   
   integration=[]
   bandpass=[]#array('d')
   
   count=1
   ii=0
   for i in range(0,len(data)):
       if (ii<spwTb.getcell('NUM_CHAN',spw_ID[0])):
           datita=data[i]
           #print i,ii,datita
           bandpass.append(datita)
       
       if (ii==spwTb.getcell('NUM_CHAN',spw_ID[0])-1):
           integration.append(bandpass)
           count=count+1
           #print "Appending bandpass or lenght %f" % (len(bandpass))
           print ii, count
           bandpass=[]#array('d')
           ii=-1
       ii=ii+1
   
   
   print "Total of "+ timebin_ito+" seconds averages ", len(integration)
   
   
   
   #####Now get average times and amplitudes
   
   outfile_amp=figfile_amp.split('.txt' )[0]+'.table'
   
   mytb = tbtool.create()
   mytb.fromascii(outfile_amp,figfile_amp,autoheader=true,firstline=1)
   mytb.close()
   
   mytb.open(outfile_amp,nomodify=false)
   times=mytb.getcol('Column1')
   amps=mytb.getcol('Column2')
   
   
   print "Total of averaged Amplitudes and Timestamps ", len(times)
   print "Plotting basebands at time %f and time %f" % (times[0],times[len(times)-1])
   print "Averaged Amplitudes at those time %f and time %f are %f and %f " % (times[0],times[len(times)-1],amps[0],amps[len(amps)-1]) 
   
   
   pl.clf()
   pl.plot(integration[0])
   pl.plot(integration[len(integration)-1])
   
   
   
   ###########  Form Fractional Difference

   Daf=[]#array('d')

   if (autocorr==1):
        print "Processing Autocorrelation from %f and  %f" % (len(integration)-1,0)
        for i in range(0+chop_edge,len(integration[0])-chop_edge):
            dafi=(integration[len(integration)-1][i]-integration[0][i])/integration[0][i]
	    Daf.append(dafi)
            print "i is", i
   else:
        print "Processing Cross-correlation"
        for i in range(0+chop_edge,len(integration[0])-chop_edge):
            dafi=(abs(integration[len(integration)-1][i])-abs(integration[0][i]))/abs(integration[0][i])
	    Daf.append(dafi)     
            
   
   print " Daf has length ", len(Daf)

   (mean_Daf,rms_Daf,max_Daf)=meanrms(Daf)


   davarf=[]#array('d')

   for i in range(0+chop_edge,len(Daf)-chop_edge):
            davarf_ito=Daf[i]-mean_Daf
	    davarf.append(davarf_ito)	



   # Compute statistics for davarf
   (mean_davarf,rms_davarf,max_davarf)=meanrms(davarf)

   print "DAvarf stats for " + plot +" spw "+spw+" Corr "+ correlation_1 + " are : Mean, RMS, MaX, %f %f %f" % (mean_davarf,rms_davarf,max_davarf)

   f = open(logfile,'a')
   line = "DAvarf stats for " + plot +" spw "+spw+" Corr "+ correlation_1 + " are : Mean, RMS, MaX, %f %f %f \n " % (mean_davarf,rms_davarf,max_davarf)
   f.write(line)
   f.close()

  
   pl.ion()
   pl.clf()
   title1=invis.split('.ms' )[0]+' '+plot+' spw  '+spw+' corr '+correlation_1+' '+timebin_ito+' seconds average'


   
   pl.subplot(211)
   pl.title(title1)
   pl.plot(integration[0][0+chop_edge:len(Daf)-chop_edge])
   pl.plot(integration[len(integration)-1][0+chop_edge:len(Daf)-chop_edge])
   pl.xlabel('Aaf To and Tf ')
   #pl.xlim(0+chop_edge,len(Daf)-chop_edge)
   
   pl.subplot(212)   
   pl.plot(davarf)
   pl.xlabel('dAvarf')
   #pl.ylim((ymin,ymax))

   plotname=invis.split('.ms' )[0]+'_ant_'+plot+'_spw'+spw+'_corr_'+correlation_1+'_DAvarf'+extension
   pl.savefig(plotname)
   #pl.close()


   # set yplot limits fir DAvarf plot
   
   ymax=mean_davarf+1*rms_davarf
   ymin=mean_davarf-1*rms_davarf
   print "ymin and ymax are %f  %f " % (ymin,ymax)
   


   pl.figure(2)
   pl.title(title1)
   pl.xlabel('dAvarf')
   pl.xlabel('dAvarf')
   pl.plot(davarf)
   pl.ylim((ymin,ymax))
   plotname=invis.split('.ms' )[0]+'_ant_'+plot+'_spw'+spw+'_corr_'+correlation_1+'_DAvarf_Zoom'+extension
   pl.savefig(plotname)
   pl.close()

   
   tb.close()
   
   return (mean_davarf,rms_davarf,max_davarf)



def meanrms (myarray):

    array=myarray
    counter=0
    m1=myarray[0]
    s1=0
    mk=0
    sk=0
    totalf2775=array
    #print array
    massimo=0

    for i in range(0,len(array)):
	counter=counter+1
	mk=m1+((array[i]-m1)/counter)
	sk=s1+((array[i]-m1)*(array[i]-mk))
	m1=mk
	s1=sk
	if abs(array[i]) > massimo:
		massimo = abs(array[i])

    sk=sqrt(sk/(counter-1))
    
    #print "Maximum value =",massimo
    #print "Mean over", counter," scans =", mk 
    #print "Sigma over", counter,", scans =", sk 
    #print "Mean and Std deviation over", counter," scans  = ", mk , sk 
    return (mk,sk,massimo)
