#!/usr/bin/env python

# rem_cloud.py
# to run, start up casapy, then:
# vis='uid___A002_X....'
# correct_ms=True  (to do the corrections to the wvr data in the ms)
# verb=False    (to avoid verbose output to screen)
# execfile('rem_cloud.py')    # assuming script is in current directory or path

import numpy
from numpy import *
from matplotlib import pyplot
from scipy import stats
import scipy.optimize as opt

global verb
global tau_arr
global std_arr

def func1(x,a,b,c):    
    return a*(x-b)**2+c

def approxCalc(tsrc0,tsrc1,tsrc2,tsrc3,m_el,Tamb):
    global verb
    global std_arr_subset
    global tau_arr_subset
    
    m_el=m_el/57.295   # convert to radians
    mean_pwt=0.0; raw_mean_pwt=0.0
#    print " starting rough calc of pwv_z"
# correct for coupling to the sky, assuming T_loss=275K, eta_c=0.98

    eta_c=0.98
    T_loss=275.0

    tsrc0=(tsrc0-(1.0-eta_c)*T_loss)/eta_c
    tsrc1=(tsrc1-(1.0-eta_c)*T_loss)/eta_c
    tsrc2=(tsrc2-(1.0-eta_c)*T_loss)/eta_c
    tsrc3=(tsrc3-(1.0-eta_c)*T_loss)/eta_c

#    m_az, m_el, m_ts= mc.actualAzEl()

    pw=[0.0,0.0,0.0,0.0];     pw_noc=[0.0,0.0,0.0,0.0]
    site="AOS"
    
# sets up fitting constants depending on the site:
    if site == "OSF":   # constants:
       tau0=[0.024,0.02,0.009,0.01]
       r=[1.205,0.402,0.177,0.116]
# approximate physical temp of atmosphere:
       Tphys=267.0

    elif site == "AOS":  # constants:
       tau0=[0.027,0.02,0.010,0.01]
       r=[1.193,0.399,0.176,0.115]
# approximate physical temp of atmosphere ,based on ambient temperature, Tamb, in centrigrade:
       Tphys=270.0 +Tamb

       if Tphys<tsrc0:
           Tphys=tsrc0+1.0
           if verb: print 'fixed physical temperature to be tsrc0'

#    print site, Tphys


    tsrcn=zeros(4)
    teln=zeros(4)

    tel=[0.0,0.0,0.0,0.0]
    tz=[0.0,0.0,0.0,0.0]
    wt=[0.0,0.0,0.0,0.0]

# calculates transmissions:
    tel[3]=(1.0-tsrc3/Tphys)
    tel[2]=(1.0-tsrc2/Tphys)
    tel[1]=(1.0-tsrc1/Tphys)
    tel[0]=(1.0-tsrc0/Tphys)

    for i in range(4):
      if tel[i]<0.02:
         tel[i]=0.02
      wt[i]=1.0-(abs(tel[i]-0.5)/0.49)**2.0    # weights

    if verb: print tsrc0,tsrc1,tsrc2,tsrc3
    if verb: print wt

    use=1
    for i in range(4):
           pw[i]=-(pl.log(tel[i])+tau0[i])/r[i]

    rat31_1=pw[3]/pw[1]
    pwm=mean(pw)

    if pwm>5.0: wt[0]=0.0

 #     wt[1]=0.0

#    print tsrc0,tsrc1,tsrc2,tsrc3
#    print tel
#    print pw

    if pwm>0.5:   # only lok for a wet cloud component if pwv>0.5mm   (bit arbitrary cutof but probably ok)
        pwt=zeros(4)

# now set increment factor for tauc depending on dekta T
        dt=pw[3]-pw[2]

        tauc_r=zeros(5)
        std_pwt_r=zeros(5)
# find std for tauc=0.0000
        for i1 in range(4):
                pwt[i1]=-(pl.log(tel[i1])+tau0[i1])/r[i1]
     #           if pwt[i1]<0.0:
     #               iloop=False
     #               print 'pwt',i1,' is <0'
        mean_pwt,std_pwt_0=weighted_avg_and_std(pwt, wt)   # get std of 4 v
#        print 'pwt0',pwt 

#   tauc_r are the 5 ranges used to estimate the max value to be used in the array for fitting
        tauc_r[0]=0.05
        tauc_r[1]=0.1
        tauc_r[2]=0.5
        tauc_r[3]=1.0
        tauc_r[4]=3.0
    
        it_stop=0
        for it in range(5):
            for i1 in range(4):
                pwt[i1]=-((pl.log(tel[i1])+tau0[i1])+tauc_r[it])/r[i1]
            #    if pwt[i1]<0.0:
            #        iloop=False
            #        print 'pwt',i1,' is <0'
            mean_pwt,std_pwt_r[it]=weighted_avg_and_std(pwt, wt)   # get std of 4 values, using weights (should weight down channels 0,1 a lot)
#            print it,pwt,std_pwt_r[it]
            
        if min(std_pwt_r)==std_pwt_r[4]:
      #      print 'tauc is too large - setting to max'
            tau_constant=3.0
        else:
            for itr in range(4,-1,-1):
                if std_pwt_r[itr]>std_pwt_0: it_stop=itr    # this is used to find the first value of it where the std is increaseing again
    #        print std_pwt_r
            it_stop=it_stop
    # now creates an array of std's, up to it_stop (to avoid edges)

    #        print 'it_stop ',it_stop,tauc_r[it_stop]
            tau_arr=zeros(300)
            std_arr=zeros(300)
            for it in range(300):
                tau_arr[it]=tauc_r[it_stop]*float(it)/300.0
                for i1 in range(4):
                    pwt[i1]=-((pl.log(tel[i1])+tau0[i1])+tau_arr[it])/r[i1]
                    if pwt[i1]<0.0:
                        iloop=False
          #              print 'pwt',i1,' is <0'
                mean_pwt,std_arr[it]=weighted_avg_and_std(pwt, wt)
       #     print tau_arr,std_arr

# we now have the array. need to do a fit.
# first check that 0'th elevent is not the smallest, if it is, then no need to fit
            if std_arr[0]>(numpy.mean(std_arr[1:3])):
                x0=numpy.array([0.0,0.0,0.0])    # first guess
# now find the minimum:
                mm=min(std_arr)
                nmin=[ii for ii,jj in enumerate(std_arr) if jj==mm][0]
                a2=tau_arr[nmin]

                if verb: print ' first guess tauc, nmin:',a2,nmin
    # now do a fit +-50 elements around this point
                tau_arr_subset=[]; std_arr_subset=[]
                for isubset in range(-50,50):
                    i_arr=nmin+isubset
                    if i_arr>-1 and i_arr<300:
                        tau_arr_subset.append(tau_arr[i_arr])
                        std_arr_subset.append(std_arr[i_arr])
#                print tau_arr_subset,std_arr_subset
                try:
                    a1,a2,a3=opt.curve_fit(func1,tau_arr_subset,std_arr_subset,x0)[0]
                except:
                    a2=tau_arr[nmin]
                    print 'fitting failed, using approximation (minimum)'
                   

                tau_constant=a2
            else:
                tau_constant=0.0
            
#        print 'tauc=',tau_constant


# re-estimates pwv, after removing additional tau_constant component.
#  (could add extra factor 1/(1-tau) in measured line abs. because it's absorbed by the continuum atmopheric abs.. although maybe not
# if they are colocated - this needs some radiative transfer...)

        for i in range(4):
           pw_noc[i]=(-(pl.log(tel[i])+tau0[i]+tau_constant)/r[i])    # *(1./(1-tau_constant))

# reverse-calculate the effective tsrcn(0-3) based on the new pwvs:
        for i in range(4):
            teln[i]=exp(-(pw_noc[i]*r[i]+tau0[i]))
            tsrcn[i]=Tphys*(1.0-teln[i])

        if verb:    print pw
        if verb: print pw_noc
        if verb: print tsrc0,tsrc1,tsrc2,tsrc3
        if verb: print tsrcn[0],tsrcn[1],tsrcn[2],tsrcn[3]
    
 
#  estimates weighted mean pwv, with and without cloud component:
# first estimate
        ws=0.0
        for i in range(4):
            ws=ws+pw[i]*wt[i]
        pwv_los=ws/sum(wt)
        pwv_z=pwv_los*math.sin(m_el)

# now remove moisture component
        ws=0.0
        for i in range(4):
            ws=ws+pw_noc[i]*wt[i]
        pwv_los_noc=ws/sum(wt)

        pwv_z_noc=pwv_los_noc*math.sin(m_el)
    

#    print 'weights:',wt
#    print pwv_z,pwv_z_noc
    
#       print "approx pwv_zen", pwv_z

#    for i in range(4):
#          pw[i]=pw[i]*math.sin(m_el)
    else:
        tau_constant=0.0
        ws=0.0
        for i in range(4):
            ws=ws+pw[i]*wt[i]
        pwv_los=ws/sum(wt)
        pwv_z=pwv_los*math.sin(m_el)
        pwv_z_noc=pwv_z
        
    return pwv_z,pwv_z_noc,tau_constant,tsrcn


def weighted_avg_and_std(values, weights):
    """
    Return the weighted average and standard deviation.

    values, weights -- Numpy ndarrays with the same shape.
    """
    average = numpy.average(values, weights=weights)
    variance = numpy.average((values-average)**2, weights=weights)
    return (average, math.sqrt(variance))

# ---------------------------------------

verb=False
if correct_ms:   # either correct or dont correct ms file - need to set in advance
    print 'CORRECTING MS'
    
if vis=='':
    vis='uid___A002_X9c604c_X5.ms'
    print 'taking default vis ',vis,'  set vis in advance if you want different'
else:
    print ' taking ms ',vis

#get basic info

tb.open(vis+'/ANTENNA')
nant=tb.nrows()
antnames=tb.getcol('NAME')
tb.close()

tb.open(vis+'/PROCESSOR')
np=tb.nrows()
procs=tb.getcol('SUB_TYPE')
for ipp in range(len(procs)):
    if procs[ipp]=='ALMA_RADIOMETER':
        proc_id=ipp
tb.close()


tb.open(vis+'/WEATHER')
Tamb=numpy.median(tb.getcol('TEMPERATURE'))-273.1
tb.close()

tb.open(vis+'/POINTING')
m_el=360.0*(numpy.median(tb.getcol('DIRECTION')[1]))/(2.0*3.14)
tb.close()

if correct_ms:
	tb.open(vis,nomodify=False)
else:
	tb.open(vis,nomodify=True)    # for testing, dont modify asdm



tsrcn=zeros(4)
# values for each ant
pwv_ant=zeros(nant)
pwv_std_ant=zeros(nant)
tauc_ant=zeros(nant)
tauc_std_ant=zeros(nant)

for iant in range(nant):
#for iant in range(21,22):
    print 'starting antenna#',iant, antnames[iant],':'
    tb1=tb.query("ANTENNA1==%d && PROCESSOR_ID==%d" % (iant,proc_id))
    temp=tb1.getcol('DATA')
    nsamples=len(temp[0][0][:])
    pwvna=zeros(nsamples)
    pwvn_noca=zeros(nsamples)
    tau_con=zeros(nsamples)
    for isam in range(nsamples):
        tsrc0=(temp[0][0][isam]).real
        tsrc1=(temp[0][1][isam]).real
        tsrc2=(temp[0][2][isam]).real
        tsrc3=(temp[0][3][isam]).real

# got temps, now convert to pwv

#        if antnames[iant]=='DA57' and (isam<6):
#            verb=True
#        else:
#            verb=False
        pwvna[isam],pwvn_noca[isam],tau_con[isam],tsrcn=approxCalc(tsrc0, tsrc1, tsrc2, tsrc3, m_el,Tamb)

	if correct_ms:
# put the new tsrcn values for this sample & antenna into temp[0][0-3][isam]
        	if verb: print 'writing new values to table in ',vis
        	for it in range(4):
            		temp[0][it][isam]=tsrcn[it]
        	tb1.putcol('DATA',temp)
        
# now outputs to the screen the medians of the samples
# this just removes crazy numbers, for rms estimate
    pwvna_m=numpy.median(pwvna)
    pwvn_noca_m=numpy.median(pwvn_noca)
    tau_constant_m=numpy.median(tau_con)
    for i in range(len(pwvna)):
        if abs(pwvna[i]-pwvna_m)>1.0:
            pwvna[i]=nan
        if abs(pwvn_noca[i]-pwvn_noca_m)>1.0:
            pwvn_noca[i]=nan
        if abs(tau_con[i]-tau_constant_m)>0.2:
            tau_con[i]=nan

    print antnames[iant],':-'
    print 'PWV: before, after ',stats.nanmedian(pwvna),stats.nanmedian(pwvn_noca)
    print 'PWV rms: before, after ',stats.nanstd(pwvna),stats.nanstd(pwvn_noca)
    print ' tau_constant ',tau_constant_m, '  rms ',stats.nanstd(tau_con)

    pwv_ant[iant]=stats.nanmedian(pwvn_noca)
    pwv_std_ant[iant]=stats.nanstd(pwvn_noca)
    tauc_ant[iant]=tau_constant_m
    tauc_std_ant[iant]=stats.nanstd(tau_con)

# plot before and after results

    tau_con_scaled=10*tau_con
    matplotlib.pylab.ion()
    pyplot.clf()
    pyplot.plot(pwvna)
    pyplot.plot(pwvn_noca,color='r')
    pyplot.plot(tau_con_scaled)
    pyplot.title((antnames[iant]+'  '+str(iant)+'  '+vis))
    pyplot.draw()
    plotfil=antnames[iant]+'.png'
    pyplot.savefig(plotfil)
    
    # print pwvna[0],pwvn_noca[0],tau_c
tb.close()
if correct_ms:
    print 'ms has been corrected'
else:
    print ' ms has NOT been corrected'

tb.close()
print 'closed table'

pwv_noca_all=stats.nanmedian(pwv_ant)
pwv_std_all=stats.nanmedian(pwv_std_ant)
tauc_all=stats.nanmedian(tauc_ant)
tauc_std_all=stats.nanmedian(tauc_std_ant)

fil=open('baseline_p.txt','a')
lineo=vis+'  pwv '+str(pwv_noca_all)+'+/-'+str(pwv_std_all)+' tauc '+str(tauc_all)+'+/-'+str(tauc_std_all)+'\n'
fil.write(lineo)
fil.close()
print lineo

# -------------------------------

  
