# Script to address SCIREQ-114: new flagging heuristics based on comparing
# corrected data to model data.

# It is assumed that you are running CASA and are in the directory:  
#  /lustre/naasc/sciops/comm/thunter/flaggingAnalysis/no_flags_applied

import time as timeUtilities
import visibilityOutliers as vo
import numpy as np
reload(vo)

beginTime = timeUtilities.time()

# The dataset that I restored first
dirs = ['2015.1.00075.S_uid___A001_X2fe_X862_products/']  #  3*1920, 1TDM
showvis = [[]]  # if empty list, then show all ms; otherwise, only show those ms in the list

# 10 Datasets that I restored Oct 25-onward
dirs += ['2015.1.00926.S_uid___A001_X2d8_X21_products/',  # all TDM
         '2015.1.00808.S_uid___A001_X2fb_X5b6_products/', # one 3840, rest TDM
         '2015.1.00315.S_uid___A001_X2fb_X9a9_products/', # 1920, 2*960
         '2015.1.00633.S_uid___A001_X2f7_X1e5_products/', # all TDM
         '2015.1.00813.S_uid___A001_X2f7_X189_products/', # all TDM
         '2015.1.00813.S_uid___A001_X2f7_X185_products/', # all TDM
         '2015.1.00926.S_uid___A001_X2d8_X29_products/',  # all TDM
         '2015.1.00960.S_uid___A001_X5a3_X15b_products/', # 4*1920
         '2015.1.00870.S_uid___A001_X2d6_Xcb_products/',  # all TDM; only 1/4 ms have any outliers  X74b2.ms
         '2015.1.00813.S_uid___A001_X2f7_X181_products/'] # all TDM
showvis += [[],[],[],[],[],[],[],[],[],[]]

# 12 Datasets that Remy restored (and I have soft-linked from my area)
dirs += ['2015.1.00091.S_uid___A001_X2fb_X764_products/',  # one 240, rest TDM
#         '2015.1.00113.S_uid___A001_X2d6_X37_products/',  # 4*480; no outliers
#         '2015.1.00168.S_uid___A001_X5a3_X1ce_products/', # 4*960,1920; no outliers
         '2015.1.00183.S_uid___A001_X2fa_X13e_products/', # 4*480,960,2*1920; no outliers in 1/4 only X1718.ms, X1e6b.ms & X147b.ms have any
         '2015.1.00392.S_uid___A001_X2fe_X711_products/', # one 3840, rest TDM
         '2015.1.00878.S_uid___A001_X2fa_X2f1_products/', # one 480, rest TDM
         '2015.1.00878.S_uid___A001_X2fa_X2e9_products/', # one 480, rest TDM
         '2015.1.00926.S_uid___A001_X2d8_X19_products/',  # all TDM
         '2015.1.01388.S_uid___A001_X2df_X11e_products/', # 2*1920, 3*960; only 1/2 ms have any  X21dd.ms
         '2015.1.00661.S_uid___A001_X2fb_X329_products/', # one 480, rest TDM
         '2015.1.00870.S_uid___A001_X2d6_Xc7_products/', # all TDM; no outliers?
         '2015.1.00697.S_uid___A001_X2fb_X4bf_products/'] # all TDM
#showvis += [[],['uid___A002_Xb4e075_X1718.ms'],[],[],[],[],[],[],[],[]]
showvis += [[],[],[],[],[],[],[],[],[],[]]
spws = ''

# decorrelation datasets (from above)
#dirs = ['2015.1.00392.S_uid___A001_X2fe_X711_products',
#        '2015.1.00808.S_uid___A001_X2fb_X5b6_products',
#        '2015.1.00878.S_uid___A001_X2fa_X2f1_products',
#        '2015.1.00926.S_uid___A001_X2d8_X19_products',
#        '2015.1.01388.S_uid___A001_X2df_X11e_products'
#]
intents = ['*BANDPASS*','*PHASE*','*FLUX*']
metrics = ['ratio','vectordiff','scalardiff'] 

# First dataset with SSO.
#dirs = ['2015.1.00075.S_uid___A001_X2fe_X862_products/']
#showvis = [[]]

# All datasets with SSOs
#dirs = ['2015.1.00075.S_uid___A001_X2fe_X862_products/',
#        '2015.1.00183.S_uid___A001_X2fa_X13e_products/',
#        '2015.1.00661.S_uid___A001_X2fb_X329_products/',
#        '2015.1.00813.S_uid___A001_X2f7_X181_products/',
#        '2015.1.00813.S_uid___A001_X2f7_X189_products/',
#        '2015.1.00813.S_uid___A001_X2f7_X185_products/',
#        '2015.1.00926.S_uid___A001_X2d8_X21_products/']

#dirs = ['2015.1.00661.S_uid___A001_X2fb_X329_products/', # good for +4.0 sigma testing
#        '2015.1.00075.S_uid___A001_X2fe_X862_products/'] 
#showvis += [[],[]]

#dirs = ['2015.1.00075.S_uid___A001_X2fe_X862_products/', # good for resolved calibrators
#        '2015.1.00878.S_uid___A001_X2fa_X2e9_products/']  # good for pol testing
#showvis = [[],[]]

#dirs = ['2015.1.00878.S_uid___A001_X2fa_X2f1_products/'] # good for negative outliers (FLUX)
#        '2015.1.01388.S_uid___A001_X2df_X11e_products/', # good for negative outliers (BANDPASS)
#        '2015.1.00808.S_uid___A001_X2fb_X5b6_products/'] # high values on ratio that went above old limit of 2  (FLUX)

# Examples of positive flagging that did not happen but maybe should have
#dirs = ['2015.1.00315.S_uid___A001_X2fb_X9a9_products'] # X12cf4 Bandpass, Flux spw 19
#spws = [[19]]
#dirs += ['2015.1.00878.S_uid___A001_X2fa_X2e9_products'] # X5aeb Bandpass, Flux, Phase spw 23, 25 
#spws += [[23,25]]

# Examples of should have gotten "too many"?
#dirs = ['2015.1.00813.S_uid___A001_X2f7_X185_products'] #  X585 Flux spw 17 
#spws = [[17]]

#dirs = ['2015.1.00661.S_uid___A001_X2fb_X329_products',  # X76d3 # Bandpass spw 25
#        '2015.1.00813.S_uid___A001_X2f7_X189_products',  #  X4b876 Bandpass 17
#        '2015.1.00870.S_uid___A001_X2d6_Xcb_products', # X74b2 Flux spw  23
#        '2015.1.00860.S_uid___A001_X2d8_X299_products'] # X21bf Bandpass, Flux spw 23
#spws = [[25],[17],[23],[23]]
#showvis = [[],[],[],[]]

amplitudeLevelForFirstNull = 0.75 # 0.2 is consistent with gfluxscale amp vs. uvdist plots;  however, 0.7 is consistent with amp/model vs antenna plot
idx = np.argsort(dirs)
dirs = [str(i) for i in np.array(dirs)[idx]]
showvis = list(np.array(showvis)[idx])
if spws != '':
    spws = list(np.array(spws)[idx])

if False:
    dirs = ['2015.1.00870.S_uid___A001_X2d6_Xc7_products/'] # no outliers.  good test for what happens in housekeeping part of code.
    metrics = ['ratio','scalardiff'] 
    intents = ['*PHASE*','*FLUX*']
#    dirs = ['2015.1.00633.S_uid___A001_X2f7_X1e5_products/']
#    showvis = [['uid___A002_Xb47876_X3918.ms']]  # if empty list, then show all ms; otherwise, only show those ms in the list
else:
    # Cycle "4" meaning reduced after Oct 1, 2016 and appearing on the manual flagging spreadsheet
    # Put these at the end, after the sorted ones, so first 888 are in same order as before adding these.
    # test for propagation to science target. Placed in order of the rows in the spreadsheet
    c4dir = '../Cycle4_no_flags_applied/'
    cycle4 = [c4dir+'2015.1.01287.S_uid___A001_X2d8_X27d',# one 3840, rest TDM
              c4dir+'2015.1.00878.S_uid___A001_X2fa_X2dd',# one 480, rest TDM  
              c4dir+'2015.1.01506.S_uid___A001_X2f3_X631',# 2*960, rest TDM
              c4dir+'2015.1.00869.S_uid___A001_X2fb_X82f',# all TDM
              c4dir+'2016.1.00165.S_uid___A001_X88e_X1d5',# 4*1920
              c4dir+'2015.1.00926.S_uid___A001_X2d8_X35', # all TDM
              c4dir+'2015.1.01023.S_uid___A001_X33e_X11c',# 2*1920,3*960
              c4dir+'2015.1.00736.S_uid___A001_X2d6_Xed', # all TDM
              c4dir+'2015.1.00870.S_uid___A001_X2d6_Xc3', # all TDM
              c4dir+'2015.1.00773.S_uid___A001_X2d2_X98', # one 3840, rest TDM
              c4dir+'2016.1.00613.S_uid___A001_X879_X462',# 4*480; one bad antenna-based timestamp
              c4dir+'2016.1.00628.S_uid___A001_X879_X37f',# one 480, rest TDM; one bad antenna-based timestamp
              c4dir+'2015.1.00847.S_uid___A001_X2fb_X75e' # 2*1920, rest TDM
          ]
    dirs += cycle4
for i in range(len(cycle4)):
    showvis.append([])

#dirs = ['2015.1.00075.S_uid___A001_X2fe_X862_products/']

cwd = os.getcwd()
runSetJyIfNecessary = False  # it will never run if it finds working directory, regardless of this setting
makePlots = True
buildPDF = False
rebuildPlots = True
relabelPlots = True
flag_nsigma={'ratio':3.0, 'vectordiff':10., 'scalardiff': 3.0}  # [3.5,10.,3.5]
catchNegativeOutliers = {'ratio':3.7, 'vectordiff': False, 'scalardiff': 3.7}   # was 5.0
#
mymsmd = au.createCasaTool(msmdtool)
bookmarkTitles = []
bookmarkPages = []
bookmarkLevels = []
montagePngs = []
plotsWithBadData = []
timeSpentAveraging = 0
tooManyBaselinesFraction = 0.18 # 0.25
tooManyIntegrationsFraction = 0.09  # 0.10
doChannelAveragingInPython = False
verbose = False
timeSpentAveraging = 0
timeSpentVisstat2 = 0
timeSpentPlotting = 0
timeSpentMontaging = 0
timeSpentGettingIntegrationTime = 0
pageOffset = 0
if not os.path.exists('newFlagTemplateFiles'):
    os.mkdir('newFlagTemplateFiles')
for i,mydir in enumerate(dirs):
    if spws != '':
        myspws = spws[i]
    else:
        myspws = ''
    print "Working on directory %d/%d = %s" % (i+1,len(dirs),mydir)
    myshowvis = showvis[i]
    if (len(bookmarkPages) > 0):
        pageOffset = bookmarkPages[-1] + 1 # assumes dual-pol
    result = vo.makeFlagTemplates(mydir, metrics, intents, amplitudeLevelForFirstNull, 
                                  tooManyBaselinesFraction, tooManyIntegrationsFraction,
                                  flag_nsigma, catchNegativeOutliers, runSetJyIfNecessary, rebuildPlots, 
                                  relabelPlots, buildPDF, myshowvis, makePlots, doChannelAveragingInPython, 
                                  verbose, pageOffset=pageOffset, spws=myspws, 
                                  checkForAntennaBasedBadIntegrations=0.05, 
                                  positiveSigmaAntennaBased=6.0)
    print "Returned %d pngs" % (len(result[0]))
    if not buildPDF:
        montagePngs += result[0]
        bookmarkTitles += result[1]
        bookmarkPages += result[2]
        print "bookmarkPages = ", bookmarkPages
        bookmarkLevels += result[3]
        timeSpentAveraging += result[5]
        timeSpentVisstat2 += result[6]
        timeSpentPlotting += result[7]
        timeSpentMontaging += result[8]
        timeSpentGettingIntegrationTime += result[9]
        plotsWithBadData += result[10]
    for flagTemplateFile in result[-1]:
        os.system('rsync -vau %s newFlagTemplateFiles/' % (flagTemplateFile))

pdf = 'metricComparison%d_2pol.pdf' % (len(montagePngs))
pdftk = '/users/thunter/usr/local/bin/pdftk'  # A version newer than the system version was required for bookmarks to work.
if not os.path.exists(pdftk):
    pdftk = 'pdftk'
aU.buildPdfFromPngs(montagePngs, pdf, pdftk=pdftk, gs='', cleanup=False, writeCommand=True, overwritePdfs=True)        
print "Wrote ", pdf
# build bookmarks
newpdf = pdf.replace('.pdf','_bookmarked.pdf')
tt.insertBookmarks(pdf, newpdf, bookmarkPages, bookmarkTitles, bookmarkLevels, pdftk=pdftk)
print "Wrote bookmarked version: ", newpdf
if (not buildPDF and len(plotsWithBadData) > 0):
    pdf2 = 'metricComparisonBadDataOnly%d_2pol.pdf' % (len(plotsWithBadData))
    aU.buildPdfFromPngs(plotsWithBadData, pdf2, pdftk=pdftk, gs='', cleanup=False, writeCommand=True, overwritePdfs=True)        
    
totalTime = timeUtilities.time()-beginTime
cmd = "timeSpentVisstat2: %.2f sec = %.1f%% of total time: %.1f sec" % (timeSpentVisstat2, 100*timeSpentVisstat2/totalTime, totalTime)
casalog.post(cmd)
print cmd
cmd = "timeSpentPlotting: %.1f sec = %.0f%% of total time: %.1f sec" % (timeSpentPlotting, 100*timeSpentPlotting/totalTime, totalTime)
casalog.post(cmd)
print cmd
if rebuildPlots:
    cmd = "timeSpentAveraging: %.1f sec = %.0f%% of total time: %.1f sec" % (timeSpentAveraging, 100*timeSpentAveraging/totalTime, totalTime)
    print cmd
    casalog.post(cmd)
    cmd = "timeSpentMontaging: %.1f sec = %.0f%% of total time: %.1f sec" % (timeSpentMontaging, 100*timeSpentMontaging/totalTime, totalTime)
    print cmd
    casalog.post(cmd)
    cmd = "timeSpentGettingIntegrationTime: %.1f sec = %.0f%% of total time: %.1f sec" % (timeSpentGettingIntegrationTime, 100*timeSpentGettingIntegrationTime/totalTime, totalTime)
    print cmd
    casalog.post(cmd)
